2006-11-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* unexmacosx.c (malloc_cookie): Remove unused variable.
	(region_list_head, region_list_tail, lca, nlc, infile_lc_highest_addr)
	(text_seg_lowest_offset, mh, curr_header_offset, infd, outfd)
	(emacs_zone, data_segment_old_fileoff, data_segment_scp)
	(num_unexec_regions, unexec_regions): Make variables static.
	(print_regions, find_emacs_zone_regions): Make static.
	(unexec_region_info): New typedef.
	(unexec_regions): Change type from vm_range_t[] to unexec_region_info[].
	All uses changed.
	(unexec_regions_recorder): Subtract size of trailing null pages from
	filesize.  Show filesize.
	(unexec_regions_merge): Don't merge if null pages of preceding region
	is not too small.  Use long format in printf.
	(copy_segment, copy_data_segment): Show filesize.
	(copy_data_segment): Write filesize bytes of region data.  Adjust
	filesize in segment command accordingly.
	(dump_it): Use long format in printf.

2006-11-05  Juanma Barranquero  <lekktu@gmail.com>

	* dosfns.c (Finsert_startup_screen):
	* fns.c (Ffeaturep, syms_of_fns):
	* frame.c (syms_of_frame): Fix typos in docstrings.

	* unexcw.c (unexec): Fix typo in output message.

2006-11-04  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): Remove code for handling -geometry
	command line option and `initial-frame-alist' which is superfluous
	after the last change to `w32_createwindow'.

2006-11-04  Slawomir Nowaczyk  <slawek@cs.lth.se>  (tiny change)

	* w32proc.c (sys_wait): Only wait for processes with fd<0.
	Others should be handled by sys_select instead.  Fixes problems
	with (progn (start-process "" nil "ls") (call-process "ls")).

2006-11-04  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* xmenu.c (Fmenu_bar_open): Declare variable before BLOCK_INPUT to
	avoid gcc 2.95 error.

2006-11-04  Chong Yidong  <cyd@stupidchicken.com>

	* gtkutil.c (update_frame_tool_bar): If icon image is invalid and
	wicon is null, insert an empty button.

2006-11-03  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (x_raise_frame): Send _NET_ACTIVE_WINDOW when raising the
	window.

2006-11-02  Juanma Barranquero  <lekktu@gmail.com>

	* emacs.c (Fkill_emacs): Fix typo in docstring.

2006-11-02  Nozomu Ando  <nand@mac.com>

	* unexmacosx.c (mach_header, segment_command, vm_region, section)
	[_LP64]: New defines.
	(VM_REGION_BASIC_INFO_COUNT, VM_REGION_BASIC_INFO, LC_SEGMENT)
	(MH_MAGIC) [_LP64]: Redefine.
	(delta): Remove variable.
	(curr_file_offset, pagesize): New variables.
	(ROUNDUP_TO_PAGE_BOUNDARY): New macro.
	(data_segment_old_fileoff): Initialize explicitly.
	(print_region, unexec_regions_recorder, print_load_command_name)
	(copy_segment, copy_data_segment): Use long format in printf.
	(MAX_UNEXEC_REGIONS): Increase to 400.
	(unexec_regions_recorder): Don't warn too many regions here.
	(find_emacs_zone_regions): Warn too many regions here.
	(print_load_command_name) [_LP64]: Show correct load command name.
	(copy_segment, copy_data_segment): Use variable `curr_file_offset'.
	Show starting virtual memory address.  Don't show ending file offset.
	(copy_symtab, copy_dysymtab, copy_twolevelhints): New argument DELTA.
	(dump_it): Use new local variable `linkedit_delta' and pass to them.
	Error if trying to handle multiple DATA segments.
	(unexec): Initialize variable `pagesize'.

2006-11-01  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fcatch): Doc fix.

2006-10-31  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (image_load_qt_1, xpm_scan, xpm_make_color_table_v)
	(xpm_put_color_table_v,	xpm_get_color_table_v, xpm_make_color_table_h)
	(xpm_put_color_table_h, xpm_get_color_table_h, xpm_str_to_color_key)
	(xpm_load_image): Add const qualifier to arguments.
	[MAC_OS] (xpm_color_key_strings): Make static const.

	* mac.c (create_apple_event_from_event_ref)
	(create_apple_event_from_drag_ref, skip_white_space, parse_comment)
	(parse_include_file, parse_binding, parse_component)
	(parse_resource_name, parse_value, parse_resource_line)
	(xrm_merge_string_database, xrm_get_resource)
	(xrm_get_preference_database): Add const qualifier to arguments.
	[MAC_OSX] (sys_select): Make variable `context' static const.

	* macfns.c (mac_color_map): Make static const.
	(mac_color_map_lookup): Add const qualifier to arguments.

	* macmenu.c (install_menu_quit_handler): Make variable `typesList'
	static const.
	(name_is_separator): Add const qualifier to arguments.

	* macselect.c (init_service_handler): Make variable `specs' static
	const.

	* macterm.c (mac_create_bitmap_from_bitmap_data): Make variable
	`swap_nibbles' static const.
	(atsu_get_text_layout_with_text_ptr): Make variables `lengths',
	`tags', `sizes', `values' static const.
	(mac_draw_string_common): Make variables `context' static.  Make
	variables `tags', `sizes', and `values' static const.
	(pcm_get_status, x_detect_focus_change, x_scroll_bar_handle_click)
	(xlfdpat_create, xlfdpat_block_match_1, xlfdpat_match)
	(mac_to_x_fontname, parse_x_font_name, add_mac_font_name)
	(mac_do_list_fonts, is_fully_specified_xlfd, do_grow_window)
	(mac_store_event_ref_as_apple_event, mac_make_rdb): Add const
	qualifier to arguments.
	(xlfd_scalable_fields, keycode_to_xkeysym_table)
	(fn_keycode_to_keycode_table): Make static const.
	(mac_load_query_font): Make variables `tags', `sizes', `values',
	`types', and `selectors' static const.
	(mac_handle_command_event, mac_handle_window_event): Make
	variables `names' and `types' static const.
	(init_command_handler, install_window_handler): Make variables
	`specs*' static const.
	(mac_handle_font_event, mac_handle_text_input_event)
	(mac_store_service_event): Make variables `names' and `types'
	const.  Make variables `names_*' and `types_*' static const.

	* macterm.h (create_apple_event_from_event_ref)
	(create_apple_event_from_drag_ref, xrm_merge_string_database)
	(xrm_get_resource, xrm_get_preference_database): Add const
	qualifier to arguments in externs.

2006-10-31  Kenichi Handa  <handa@m17n.org>

	* xfns.c (xic_create_xfontset): Fix previous change.

2006-10-30  Chong Yidong  <cyd@stupidchicken.com>

	* s/openbsd.h (LD_SWITCH_SYSTEM): Add /usr/pkg/lib and
	/usr/pkg/lib to library search path.

2006-10-29  Mark Davies  <mark@mcs.vuw.ac.nz>  (tiny change)

	* ralloc.c (relinquish): Use a long for excess space counter to
	handle 64-bit case correctly.

2006-10-29  Jeramey Crawford  <jeramey@jeramey.com>

	* m/amdx86-64.h: Add defines for OpenBSD x86-64.

2006-10-29  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fdisplay_buffer): Fix typo in docstring.

2006-10-27  Ben North  <ben@redfrontdoor.org>  (tiny change)

	* w32term.c (x_draw_glyph_string_foreground): Set background mode
	to TRANSPARENT before using overstrike to simulate bold faces.

	* xfaces.c (best_matching_font): Fix logic to decide whether to
	use overstriking to simulate bold-face (it was reversed).

2006-10-23  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (remember_mouse_glyph): Do nothing if glyphs are not
	initialized.

	* keyboard.c (read_char): Make an element (t . EVENT) in
	unread-command-events add EVENT to the current command's key sequence.
	(syms_of_keyboard) <unread-command-events>: Update doc.

2006-10-21  Richard Stallman  <rms@gnu.org>

	* minibuf.c (Vread_expression_map): Define here.
	(Qread_expression_history): New variable.
	(syms_of_minibuf): Initialize them.
	(Feval_minibuffer): Use Vread_expression_map and
	Qread_expression_history.

2006-10-21  Kenichi Handa  <handa@m17n.org>

	* xfns.c (xic_create_fontsetname): If ADSTYLE field is not a wild
	card, change it to "*".
	(xic_create_xfontset): Call XCreateFontSet for each single
	fontname in fontsetname.

2006-10-19  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (callint_message): Convert to a Lisp string.
	(syms_of_callint): Initialize it.
	(callint_message_size): Var deleted.
	(Fcall_interactively): Use Fformat instead of doprnt to construct
	prompt string.

2006-10-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (display_mode_line): Clear enabled_p flag on mode-line row.

2006-10-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Vmac_carbon_version_string) [TARGET_API_MAC_CARBON]:
	New variable.
	(syms_of_macfns) [TARGET_API_MAC_CARBON]: Defvar it.

2006-10-19  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xselect.c (x_handle_selection_request): If the converted_selection
	is NIL or XCDR (converted_selection) is NIL, decline the request.

2006-10-16  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (get_utf8_string): Remove warnings with casts.
	(xg_tool_bar_button_cb): Ditto
	(xg_tool_bar_callback): Ditto.

2006-10-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispnew.c (adjust_frame_glyphs_for_frame_redisplay): Remove unused
	variable ch_dim.
	(adjust_frame_glyphs_for_window_redisplay): Likewise.  Don't allocate
	menu bar window matrices on non-X systems.

	* mac.c (Fmac_get_preference, Fmac_code_convert_string): Add GCPROs.

	* macterm.c (mac_query_char_extents): Don't return glyph ID if layout
	adjustment is needed.
	(mac_load_query_font): Check if width and height are positive.

2006-10-14  Richard Stallman  <rms@gnu.org>

	* sysdep.c (init_sys_modes): Delete DEFVAR_LISP in the wrong place.

2006-10-13  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (decode_mode_spec): Ignore %c and %l constructs in frame
	title.

2006-10-12  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (Fkey_binding): Check Lisp_Object types before doing
	XCAR and XINT.

2006-10-12  Romain Francoise  <romain@orebokech.com>

	* image.c (xbm_read_bitmap_data): Delete extra semicolon.

2006-10-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c: Include xterm.h for x_fully_uncatch_errors and friends.

	* dispextern.h: Declare x_create_bitmap_from_xpm_data.

	* xterm.c (x_check_expected_move): Remove unused var `count'.

	* xmenu.c (syms_of_xmenu): Use Ffset rather than Fdefalias, since
	Fdefalias is not declared in any *.h file.

2006-10-09  Chong Yidong  <cyd@stupidchicken.com>

	* dispnew.c (sit_for): Sit forever if TIMEOUT is t.

	* keyboard.c (command_loop_1): Handle non-number values of
	`minibuffer-message-timeout'.
	(Fexecute_extended_command): Fix typo.

	* minibuf.c (temp_echo_area_glyphs): Sit for
	`minibuffer-message-timeout' seconds.

2006-10-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_draw_image_string, mac_draw_image_string_16):
	Add argument OVERSTRIKE_P.
	(mac_draw_string_common, mac_draw_image_string_cg): Likewise.
	Support overstrike.
	(mac_draw_string, mac_draw_string_16): Remove functions.
	(x_draw_glyph_string_foreground): Use overstrike when needed.
	(x_draw_composite_glyph_string_foreground): Likewise.
	Use mac_draw_image_string_16 instead of mac_draw_string_16.
	(mac_load_query_font): Rename from XLoadQueryFont.  Take argument
	F instead of DPY.  All uses changed.  Don't save/restore font.

2006-10-07  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): Honour left and top positions if
	supplied explicitly.

2006-10-06  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Fix value when EOB is visible.

2006-10-05  Chong Yidong  <cyd@stupidchicken.com>

	* frame.c (Qinhibit_face_set_after_frame_default): New var.
	(syms_of_frame): Initialize it.
	(x_set_frame_parameters): Avoid resetting :font attributes to the
	new-frame defaults.

2006-10-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (clear_regexp_cache): Declare.

	* search.c (compile_pattern): Only check `cp->syntax_table' if needed.
	(compile_pattern_1): Remember `used_syntax' in `cp->syntax_table'.
	(clear_regexp_cache): Only flush those regexps which depend on
	a syntax-table.

	* regex.c (regex_compile): Set the new `used_syntax' bit.

	* regex.h: Remove file local variables.
	(struct re_pattern_buffer): New field `used_syntax'.

2006-10-03  Kim F. Storm  <storm@cua.dk>

	* process.c (list_processes_1): Run sentinels before removing dead
	processes.  Also remove `closed' network connections.

2006-10-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (handle_fontified_prop): Don't fontify at EOB.

2006-09-30  Eli Zaretskii  <eliz@gnu.org>

	* config.in: Regenerated.

2006-09-29  Juri Linkov  <juri@jurta.org>

	* buffer.c (syms_of_buffer): Reorder coding systems in the
	docstring of %z to the real order displayed in the modeline.

2006-09-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (Fdefine_key): Yet another int/Lisp_Object mixup (YAILOM).

2006-09-26  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Do move back if the Lisp string
	being displayed contains newlines.

2006-09-26  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_compute_glyph_string_overhangs, XLoadQueryFont)
	[USE_CG_DRAWING]: Call mac_prepare_for_quickdraw before QDTextBounds.

2006-09-26  Kenichi Handa  <handa@m17n.org>

	* keymap.c (Fsingle_key_description): For an invalid char, return
	"Invalid char code NNNNN".

2006-09-25  Chong Yidong  <cyd@stupidchicken.com>

	* callint.c (Fcall_interactively): Doc fix.

2006-09-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (x_underline_at_descent_line): New variable.
	(syms_of_macterm): DEFVAR_BOOL it.
	(x_draw_glyph_string): Use it.
	(XLoadQueryFont): Calculate min_bounds.descent and max_bounds.descent.

2006-09-25  Kenichi Handa  <handa@m17n.org>

	* keymap.c (Fsingle_key_description): Return unique names for
	generic characters.

2006-09-24  Richard Stallman  <rms@gnu.org>

	* search.c (compile_pattern_1): Don't BLOCK_INPUT.

2006-09-24  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(BLD)/fns.$(O), $(BLD)/w32proc.$(O)):
	Depend on nt/inc/langinfo.h and nt/inc/nl_types.h.

	* w32proc.c (nl_langinfo): New function.

	* w32fns.c (w32-pass-alt-to-system, w32-alt-is-meta)
	(w32-pass-lwindow-to-system, w32-enable-num-lock)
	(w32-enable-caps-lock, w32-scroll-lock-modifier)
	(w32-lwindow-modifier, w32-rwindow-modifier)
	(w32-apps-modifier, w32-mouse-button-tolerance): Doc fix.

2006-09-23  Juanma Barranquero  <lekktu@gmail.com>

	* minibuf.c (Finternal_complete_buffer, Fread_minibuffer)
	(Fdisplay_completion_list): Fix typos in docstrings.

2006-09-23  Romain Francoise  <romain@orebokech.com>

	* s/gnu-linux.h (MAIL_USE_FLOCK): Check for HAVE_LIBLOCKFILE too.

2006-09-23  Kenichi Handa  <handa@m17n.org>

	* keymap.c (Fmap_keymap): Docstring mentions about generic character.

2006-09-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.c (analyse_first): For eight-bit-control chars, mark both the
	char's value and its leading byte in the fastmap.
	(re_search_2): When fast-scanning without translation, be careful to
	check that we only match the leading byte of a multibyte char.

	* charset.h (PREV_CHAR_BOUNDARY): Make it work from within a char's
	byte sequence.
	(AT_CHAR_BOUNDARY): New macro.

2006-09-22  Kenichi Handa  <handa@m17n.org>

	* fns.c (optimize_sub_char_table): Don't optimize a sub-char-table
	whose default value is non-nil.

2006-09-22  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Only show C-l help for
	Gtk+ versions < 2.10.

	* xfns.c (syms_of_xfns): Fix typo in help text for
	x-gtk-file-dialog-help-text.

2006-09-21  Kim F. Storm  <storm@cua.dk>

	* fns.c (Fmemq): Refill doc string.
	(Fmemql): New defun, like memq but using eql.
	(syms_of_fns): Defsubr it.

2006-09-20  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): CHARPOS < 0 means return info for
	last visible glyph in window.

	* window.c (Fset_window_hscroll, Fwindow_line_height):
	Doc fix.  Use "off-window" instead of "off-screen".
	(Fpos_visible_in_window_p): Likewise.
	If POS is t, return info for last visible glyph in window.

2006-09-19  Chong Yidong  <cyd@stupidchicken.com>

	* search.c (struct regexp_cache): New entry syntax_table.
	(compile_pattern_1): Set it.
	(syms_of_search): Initialize it.
	(compile_pattern): Require the syntax_table entry of the cache
	element to match the current syntax table entry.

2006-09-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fwindow_end): Fix recent change.

2006-09-19  Kim F. Storm  <storm@cua.dk>

	* window.c (Fset_window_hscroll, Fpos_visible_in_window_p):
	Doc fix.  Use "off-screen" instead of "invisible".
	(Fwindow_line_height): Make line numbers 0-based.  Make line arg
	optional; if nil, use current cursor row.  Handle text terminals
	properly.  Return nil if non-interactive or pseudo-window.

2006-09-19  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c: Include alloca.h if available.
	(Fkey_binding): Only use AREF after checking it's a vector.
	Remove unused var `window'.

2006-09-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (shut_down_emacs) [!subprocesses]: Don't set
	inhibit_sentinels.

	* mac.c [!MAC_OSX] (select): Fix argument name.

	* macmenu.c (enum mac_menu_kind, min_menu_id): New enumerator and
	menu ID for Apple menu.
	(menubar_selection_callback): Remove function.
	(find_and_call_menu_selection): New function from xmenu.c.
	(x_activate_menubar): Use it.
	(set_frame_menubar): Don't use f->output_data.mac->menubar_active.

	* macterm.c (menubar_selection_callback): Remove extern.
	(M_APPLE): Change to 234.
	(do_apple_menu) [!TARGET_API_MAC_CARBON]: Make non-static.
	(do_menu_choice): Remove function.

	* macterm.h (struct mac_output): Remove member menubar_active.
	(do_menu_choice): Remove extern.
	(do_apple_menu) [!TARGET_API_MAC_CARBON]: Add extern.

2006-09-18  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (syms_of_xfns): Rename x_gtk_show_chooser_help_text to
	x_gtk_file_dialog_help_text.

	* gtkutil.c (xg_uses_old_file_dialog): Rename x-use-old-gtk-file-dialog
	to x-gtk-use-old-file-dialog.
	(xg_get_file_with_chooser): Rename x_gtk_show_chooser_help_text to
	x_gtk_file_dialog_help_text.

	* xfns.c (syms_of_xfns): Ditto.

2006-09-18  Kim F. Storm  <storm@cua.dk>

	* window.c (Fwindow_line_visibility): Remove.
	(Fwindow_line_height): New defun replacing it.
	(syms_of_window): Defsubr it.

2006-09-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (SELECT_USE_CFSOCKET) [MAC_OSX]: Set default to 1.
	[MAC_OSX] (sys_select) [SELECT_USE_CFSOCKET]: Fix pointer type.

2006-09-17  Jay Belanger  <belanger@truman.edu>

	* gmalloc.c:
	* md5.c:
	* md5.h:
	* strftime.c: Replace "GNU Library General Public License" by "GNU
	General Public License" throughout.

2006-09-17  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (update_text_area): Undo 2000-07-18 change.
	Always redrawing whole row if line has mouse-face in it causes
	excessive flickering of the mode line.

2006-09-17  Chong Yidong  <cyd@stupidchicken.com>

	* search.c (clear_regexp_cache): New function.

	* syntax.c (Fmodify_syntax_entry): Clear regexp cache.

2006-09-16  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser):
	Check x-gtk-show-chooser-help-text before adding the help text.

	* xfns.c (syms_of_xfns): New variable: x-gtk-show-chooser-help-text.

	* gtkutil.c (get_utf8_string): Try harder to convert to UTF8.  Gtk+
	will simply crash if we fail.

2006-09-16  Richard Stallman  <rms@gnu.org>

	* regex.c (re_compile_pattern): Set gl_state.current_syntax_table.

2006-09-15  Kim F. Storm  <storm@cua.dk>

	* window.c (Fwindow_line_visibility): New defun for line-move-partial.
	(syms_of_window): Defsubr it.
	(Fwindow_end): Use window's buffer rather than current buffer.

2006-09-15  Jay Belanger  <belanger@truman.edu>

	* COPYING: Replace "Library Public License" by "Lesser Public
	License" throughout.

2006-09-15  David Kastrup  <dak@gnu.org>

	* Makefile.in (keymap.o): Add "keymap.h" and "window.h" dependencies.

	* keymap.c: include "window.h".
	(Fcommand_remapping): New optional POSITION argument.
	(Fkey_binding): New optional POSITION argument.  Completely rework
	handling of mouse clicks to get the same order of keymaps as
	`read-key-sequence' and heed POSITION.  Also temporarily switch
	buffers to location of mouse click and back.

	* keyboard.c (command_loop_1): Adjust call of `Fcommand_remapping'
	for additional argument.
	(parse_menu_item): Adjust call of `Fkey_binding' for additional
	argument.
	(read_key_sequence): If there are both `local-map' and `keymap'
	text properties at some buffer position, heed both.

	* keymap.h: Declare additional optional arguments of
	`Fcommand_remapping' and `Fkey_binding'.

2006-09-15  Juanma Barranquero  <lekktu@gmail.com>

	* indent.c (Fcurrent_column, Findent_to): Fix typos in docstring.

2006-09-14  Andreas Schwab  <schwab@suse.de>

	* print.c: Whitespace fixup.

2006-09-14  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (produce_image_glyph): Automatically crop wide images at
	right window edge so we can draw the cursor on the same row to
	avoid confusing redisplay by placing the cursor outside the visible
	window area.

2006-09-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xterm.c (x_initialize): Don't install Xt event timer here.
	(x_timeout_atimer_activated_flag): New var.
	(x_activate_timeout_atimer): New function to install Xt timer.
	(x_send_scroll_bar_event, x_process_timeouts): Use it.

	* xmenu.c (x_menu_set_in_use, popup_activate_callback)
	(create_and_show_popup_menu, create_and_show_dialog): Use it.

	* xterm.h (x_activate_timeout_atimer): Add prototype.

2006-09-13  Richard Stallman  <rms@gnu.org>

	* print.c (print_string): When printcharfun is t,
	copy string contents and call strout on the copy.

	* keyboard.c (read_char): If end_time specified, don't put the
	event into this_command_keys.
	(read_key_sequence): If Voverriding_terminal_local_map is specified,
	don't check Voverriding_local_map at all.

2006-09-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* textprop.c (Fnext_property_change, Fnext_single_property_change)
	(Fprevious_property_change, Fprevious_single_property_change):
	Avoid changing limit, so we can correctly catch the case where the
	property is constant up to limit.

2006-09-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (mac_window) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	* macterm.c (XTread_socket) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Undo 2006-09-08 change.

2006-09-11  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (Fkey_binding): Use string position for string objects.

2006-09-11  Kim F. Storm  <storm@cua.dk>

	* keymap.c (Fkey_binding): Fix last change.

	* editfns.c (Fmessage): Recommend using (message "%s" ...).

2006-09-10  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (Fkey_binding): Check for local keymap for mouse click
	events.

2006-09-10  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (Finput_pending_p): Check Vunread_input_method_events
	and Vunread_post_input_method_events.

	* dispnew.c (Fredisplay): Document return value.

2006-09-10  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_close_connection): Call xg_display_close when USE_GTK.

	* gtkutil.c (xg_display_close): Always change default display if needed,
	check for < Gtk+ version 2.10 before calling gdk_display_close.

2006-09-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [MAC_OSX] (sys_select): Check argument `nfds' more rigidly.
	Make variable `ofds' static.  Remove variable `maxfd'.

	* macfns.c (Fx_file_dialog): Remove unused variable `f'.
	Call check_mac.

	* macmenu.c (Vmenu_updating_frame, syms_of_macmenu):
	* w32menu.c (Vmenu_updating_frame, syms_of_w32menu):
	Apply 2006-09-08 change for xmenu.c.

	* xfns.c (Fx_file_dialog): Call check_x.

2006-09-10  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_window_cursor_type): Use hollow cursor on
	non-transparent images.

2006-09-09  Eli Zaretskii  <eliz@gnu.org>

	* editfns.c (Fsystem_name): Mention "host" in the doc string.
	(syms_of_editfns) <system-name>: Likewise.

2006-08-27  Martin Rudalics  <rudalics@gmx.at>

	* xdisp.c (mouse_autoselect_window): Remove.
	(Vmouse_autoselect_window): New variable.  DEFVAR_LISP it.

	* dispextern.h (mouse_autoselect_window): Remove extern.
	(Vmouse_autoselect_window): Add extern.

	* macterm.c (XTread_socket): Test Vmouse_autoselect_window
	instead of mouse_autoselect_window.

	* msdos.c (dos_rawgetc): Likewise.

	* w32term.c (w32_read_socket): Likewise.

	* xterm.c (handle_one_xevent): Likewise.

2006-09-08  Richard Stallman  <rms@gnu.org>

	* xdisp.c (Vmenu_updating_frame): Define here.
	(syms_of_xdisp): DEFVAR it here.
	(update_menu_bar): Always return hooks_run.
	Set Vmenu_updating_frame.

	* xdisp.c (redisplay_internal): Test Vinhibit_redisplay
	before calculating SELECTED_FRAME.

	* xmenu.c (Vmenu_updating_frame): Don't define here.
	(syms_of_xmenu): Don't DEFVAR it here.

	* xterm.c (x_error_quitter): For BadName error, just return.

	* eval.c (find_handler_clause): Give up on debugger if INPUT_BLOCKED_P.

	* casetab.c (init_casetab_once): Call set_case_table.

	* emacs.c (shut_down_emacs): Set inhibit_sentinels.

	* process.c (inhibit_sentinels): New variable.
	(exec_sentinel): Test inhibit_sentinels.
	(init_process): Initialize it.

	* process.h (inhibit_sentinels): Add decl.

	* search.c (looking_at_1, string_match_1, search_command):
	Make syntax table's canon table point to eqv table.

2006-09-08  Andreas Schwab  <schwab@suse.de>

	* print.c (strout): Fix whitespace.

2006-09-08  Kim F. Storm  <storm@cua.dk>

	* xterm.c (x_draw_glyph_string): Fix 2006-08-24 change.

2006-09-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [!MAC_OSX]: Don't include keyboard.h.
	[!MAC_OSX] (select): Try detect_input_pending before ReceiveNextEvent
	in the same BLOCK_INPUT block, in case that some input has already
	been read asynchronously.  Pretend to be interrupted by a signal
	if some input is available.
	[MAC_OSX] (select_and_poll_event, sys_select): Likewise.
	(SELECT_POLLING_PERIOD_USEC) [SELECT_USE_CFSOCKET]: Change to 100000.
	Now used for ReceiveNextEvent timeout instead of select timeout.
	(EVENT_CLASS_SOCK) [SELECT_USE_CFSOCKET]: Remove macro.
	[SELECT_USE_CFSOCKET] (socket_callback): Add non-blocking connect
	support.  Quit event loop.
	[MAC_OSX] (sys_select) [SELECT_USE_CFSOCKET]: Add non-blocking
	connect support.  Reuse previously allocated CFRunLoopSource.
	(Fmac_process_hi_command) [TARGET_API_MAC_CARBON]: New function.
	(syms_of_mac) [TARGET_API_MAC_CARBON]: Defsubr it.

	* macfns.c (mac_window) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]:
	Specify kWindowAsyncDragAttribute.

	* macterm.c (mac_handle_origin_change, mac_handle_size_change)
	(mac_get_ideal_size): New functions.
	(x_set_offset, x_set_window_size, x_make_frame_visible)
	(do_zoom_window, mac_handle_window_event, XTread_socket): Use them.
	(install_window_handler, mac_handle_window_event)
	[USE_CARBON_EVENTS]: Handle kEventWindowGetIdealSize and
	kEventWindowBoundsChanged.
	(XTread_socket) [MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: Don't call
	DragWindow.

2006-09-07  Andreas Schwab  <schwab@suse.de>

	* m/ibms390x.h (START_FILES, LIB_STANDARD): Override to
	use lib64 instead of lib.

2006-09-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* Makefile.in: Avoid double quotes when possible.

2006-09-06  Kenichi Handa  <handa@m17n.org>

	* editfns.c (Fformat_time_string): Use make_unibyte_string to make
	a Lisp string from the result of emacs_memftimeu call.

2006-09-06  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Remove exact_mode_line_heights_p arg;
	so calculate heights even when pos-visible-in-window-p is called
	with partially = t.  Don't overshoot last_visible_y in move_it_to.
	Return row height and row number in new rowh and vpos args.
	(cursor_row_fully_visible_p): First line is always "fully visible".
	(try_window): Don't clear matrix if vscrolled.

	* lisp.h (pos_visible_p): Update prototype.

	* window.c (Fpos_visible_in_window_p): Adapt to new pos_visible_p.
	Return row height and row number for partially visible rows.
	Modify return value to a 2 element list for fully visible rows and
	6 for partially visible row.
	(window_scroll_pixel_based): Use pos_visible_p directly instead of
	Fpos_visible_in_window_p.  Fix auto vscrolling for partially
	visible lines.  Only vscroll backwards if already vscrolled
	forwards.  Unconditionally vscroll forwards if PT is first (and
	only) line.  Set new window start instead of scrolling at
	start/end of tall line.

2006-09-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (install_window_handler, mac_handle_window_event)
	[USE_CARBON_EVENTS]: Handle kEventWindowClose.
	[USE_MAC_TSM] (mac_handle_text_input_event): Set modifiers for
	ASCII keystroke event.

2006-09-04  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Don't mention specific keys in
	the file chooser message.  Only call gtk_file_chooser_set_current_name
	when action is SAVE.

2006-09-04  Andreas Schwab  <schwab@suse.de>

	* Makefile.in: Double all single and back quotes in C-style
	comments to help fontifier.

2006-09-03  Jason Rumney  <jasonr@gnu.org>

	* w32.c (shutdown_handler): New function to exit cleanly on shutdown.
	(globals_of_w32): Register it as a signal handler.

2006-09-02  Juri Linkov  <juri@jurta.org>

	* marker.c (Fmarker_position): Doc fix.

2006-09-03  Eli Zaretskii  <eliz@gnu.org>

	* window.c (syms_of_window) <split-height-threshold>:
	<window-min-height, window-min-width>: Doc fix.

2006-09-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Change file chooser message
	for writing files.  Call gtk_file_chooser_set_current_name to keep
	default filename.

	* minibuf.c (Finternal_complete_buffer): Move after DEFUN:s it calls

2006-09-02  Jindrich Makovicka  <makovick@gmail.com>  (tiny change)

	* fns.c (concat) [__GNUC__]: Declare with
	`__attribute__((noinline))'.

	* eval.c (apply1, call2) [__GNUC__]: Declare with
	`__attribute__((noinline))'.

2006-09-02  Stuart D. Herring  <herring@lanl.gov>

	* minibuf.c (Finternal_complete_buffer): New function.
	(syms_of_minibuf): Defsubr it.
	(Fread_buffer): Use it, instead of Vbuffer_alist.

2006-09-01  Martin Rudalics  <rudalics@gmx.at>

	* buffer.h (struct buffer_text): New field chars_modiff.
	(CHARS_MODIFF, BUF_CHARS_MODIFF): New macros.
	* buffer.c (Fbuffer_chars_modified_tick): New function returning
	value of BUF_CHARS_MODIFF.
	(syms_of_buffer): Defsubr it.
	(Fget_buffer_create): Initialize BUF_CHARS_MODIFF.
	* insdel.c (modify_region): New argument preserve_chars_modiff.
	Set CHARS_MODIFF to MODIFF provided preserve_chars_modiff is zero.
	(insert_1_both, insert_from_string_1, insert_from_buffer_1)
	(adjust_after_replace, adjust_after_replace_noundo)
	(replace_range, replace_range_2, del_range_2): Reset CHARS_MODIFF.
	* lisp.h (modify_region): Add fourth argument in extern.
	* casefiddle.c (casify_region): Call modify_region with fourth
	argument zero to assert that CHARS_MODIFF is updated.
	* editfns.c (Fsubst_char_in_region, Ftranslate_region_internal)
	(Ftranspose_regions): Likewise.
	* textprop.c (Fadd_text_properties, Fset_text_properties)
	(Fremove_text_properties, Fremove_list_of_text_properties):
	Call modify_region with fourth argument 1 to avoid that
	CHARS_MODIFF is updated.

2006-08-31  Richard Stallman  <rms@gnu.org>

	* editfns.c (Fformat): Don't sign-extend for %o or %x.

2006-08-29  Chong Yidong  <cyd@stupidchicken.com>

	* indent.c (Fvertical_motion): Don't move back if we were
	displaying a Lisp string, either.

2006-08-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_window_cursor_type) [!HAVE_WINDOW_SYSTEM]:
	Don't attempt to replace cursor on image glyphs.

2006-08-28  Kenichi Handa  <handa@m17n.org>

	* coding.c (Fdetect_coding_region, Fdetect_coding_string): Fix
	docstring about ISO-2022 control characters.

2006-08-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_window_cursor_type): Replace BOX cursor on images
	with a hollow box cursor if image is larger than 32x32 (or the default
	frame font if that is bigger).  Replace any other cursor on images
	with hollow box cursor, as redisplay doesn't support bar and hbar
	cursors on images.

2006-08-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (BLOCK_INPUT_ALLOC, UNBLOCK_INPUT_ALLOC): Undo previous
	change.  Move mutex lock/unlock operations inside BLOCK_INPUT.

	* dired.c (directory_files_internal_unwind, directory_files_internal)
	(file_name_completion): Add BLOCK_INPUT around opendir/closedir.

	* image.c [MAC_OS] (image_load_qt_1): Use ComponentResult instead
	of OSErr.

	* keyboard.c (in_sighandler): Remove variable.
	(Fcurrent_idle_time): Add missing `doc:'.
	(input_available_signal, init_keyboard): Undo previous change.

	* keyboard.h (in_sighandler): Remove extern.

	* mac.c (create_apple_event_from_event_ref, select)
	(Fmac_get_file_creator, Fmac_get_file_type, Fmac_set_file_creator)
	(Fmac_set_file_type, cfstring_create_normalized)
	(mac_get_system_locale, select_and_poll_event, sys_select):
	Use OSStatus instead of OSErr.

	* macfns.c [TARGET_API_MAC_CARBON] (mac_update_proxy_icon):
	Don't use FRAME_FILE_NAME.  Use (FS)UpdateAlias.
	(Fx_create_frame): Apply 2006-07-03 for xfns.c.

	* macselect.c (get_scrap_from_symbol, clear_scrap, put_scrap_string)
	(put_scrap_private_timestamp, scrap_has_target_type, get_scrap_string)
	(get_scrap_private_timestamp, get_scrap_target_type_list)
	(x_own_selection, x_get_foreign_selection)
	(Fx_disown_selection_internal, Fx_selection_owner_p)
	(Fx_selection_exists_p): Use OSStatus instead of OSErr.

	* macterm.c (mac_draw_string_common, mac_query_char_extents)
	(x_iconify_frame, XLoadQueryFont, install_window_handler)
	(mac_handle_command_event, init_command_handler, init_menu_bar):
	Use OSStatus instead of OSErr.
	(x_free_frame_resources) [TARGET_API_MAC_CARBON]: Don't use
	FRAME_FILE_NAME.
	(x_query_font): Apply 2006-08-04 change for xterm.c.
	(Qhi_command): Rename from Qhicommand.  All uses changed.

	* macterm.h (struct mac_output) [TARGET_API_MAC_CARBON]: Remove member
	file_name.
	(FRAME_FILE_NAME): Remove macro.
	(install_window_handler, create_apple_event_from_event_ref):
	Return OSStatus instead of OSErr.

2006-08-26  Kim F. Storm  <storm@cua.dk>

	* buffer.c (Fset_buffer_multibyte):
	* editfns.c (Fcurrent_time, Fget_internal_run_time):
	* macfns.c (Fxw_color_values):
	* w32fns.c (Fxw_color_values):
	* xfns.c (Fxw_color_values): Simplify; use list3.

	* fileio.c (Fmake_directory_internal, Fdelete_directory)
	(Fdelete_file): Simplify; use list1.
	(Frename_file, Fadd_name_to_file, Fmake_symbolic_link):
	Simplify; remove NO_ARG_ARRAY stuff, use list2.

2006-08-25  Richard Stallman  <rms@gnu.org>

	* buffer.c (Fswitch_to_buffer): Fix previous change.

2006-08-25  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (Fcurrent_idle_time): Simplify.

2006-08-25  Richard Stallman  <rms@gnu.org>

	* fns.c (sxhash_string): Rotate properly; don't lose bits.

2006-08-24  Francesc Rocher  <francesc.rocher@gmail.com>

	* xdisp.c (overline_margin): New variable.
	(x_produce_glyphs): Use it.
	(syms_of_xdisp): DEFVAR_INT it.

	* xterm.c (x_underline_at_descent_line): New variable.
	(syms_of_xterm): DEFVAR_BOOL it.
	(x_draw_glyph_string): Use it.
	Draw underline and overline up to the end of line if the face
	extends to the end of line.

	* macterm.c: Likewise.

	* w32term.c: Likewise.

2006-08-24  Nick Roberts  <nickrob@snap.net.nz>

	* buffer.c (Fswitch_to_buffer): Move buffer to front of
	buffer-alist if necessary.

2006-08-22  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (update_tool_bar): Redisplay toolbar also when only
	number of items changes.

2006-08-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.c (Fset_buffer_multibyte): Record proper undo entry.

2006-08-21  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* keyboard.c: Clarify difference between in_sighandler and
	handling_signal.

2006-08-21  Kim F. Storm  <storm@cua.dk>

	* macterm.c (x_draw_stretch_glyph_string):
	* w32term.c (x_draw_stretch_glyph_string):
	* xterm.c (x_draw_stretch_glyph_string): It is ok to draw a
	stretch	glyph in left marginal areas on	header and mode lines.

2006-08-21  Kenichi Handa  <handa@m17n.org>

	* keyboard.c (syms_of_keyboard): Docstring of
	Vunread_post_input_method_events and Vunread_input_method_events
	fixed.

2006-08-20  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (show_help_echo): Preserve mouse movement flag if
	tracking mouse.

2006-08-20  Richard Stallman  <rms@gnu.org>

	* xfaces.c (load_pixmap): Add quotes in error message.

	* keyboard.c (Fcurrent_idle_time): New function.
	(syms_of_keyboard): defsubr it.

2006-08-18  Nick Roberts  <nickrob@snap.net.nz>

	* window.c (Fset_window_fringes): Do nothing on a tty.
	(Fwindow_fringes): Put ? operator after the line break.

2006-08-16  Andreas Schwab  <schwab@suse.de>

	* print.c (debug_output_compilation_hack): Fix return type.

2006-08-16  Richard Stallman  <rms@gnu.org>

	* print.c (debug_output_compilation_hack): New function.

2006-08-16  Kenichi Handa  <handa@m17n.org>

	* fileio.c (choose_write_coding_system): Use LF for end-of-line
	in auto-saving.

2006-08-15  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): Don't change idle timer state at all if
	end_time is supplied.

2006-08-15  Kenichi Handa  <handa@m17n.org>

	* coding.c (ONE_MORE_BYTE_CHECK_MULTIBYTE): New arg RET.  If SRC
	is exhausted, return with RET.
	(detect_coding_emacs_mule, detect_coding_iso2022)
	(detect_coding_sjis, detect_coding_big5, detect_coding_utf_8)
	(detect_coding_utf_16, detect_coding_ccl): Adjusted for the above
	change.

2006-08-14  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): Don't reset idle timers if a time limit
	is supplied.

2006-08-14  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Print iterator position.
	Limit stack dump in case iterator is not initialized.

2006-08-12  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (Fmouse_position, Fmouse_pixel_position)
	(Fset_mouse_position, Fset_mouse_pixel_position): Doc fix.

2006-08-11  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xselect.c (Fx_register_dnd_atom): New function.
	(syms_of_xselect): Defsubr it.
	(x_handle_dnd_message): Check that message_type is in
	dpyinfo->x_dnd_atoms before generating lisp event.

	* xterm.h (struct x_display_info): Add x_dnd_atoms* to keep track
	of drag and drop Atoms.

	* xterm.c (x_term_init): Initialize dpyinfo->x_dnd_atoms*

2006-08-10  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* keyboard.c: Define in_sighandler.
	(input_available_signal): Set in_sighandler.
	(init_keyboard): Initialize in_sighandler.

	* keyboard.h: Declare in_sighandler.

	* alloc.c (UNBLOCK_INPUT_ALLOC, BLOCK_INPUT_ALLOC): Use in_sighandler
	to check if mutex should be locked or not.

2006-08-09  Richard Stallman  <rms@gnu.org>

	* keyboard.c (keyremap_step): No-op if fkey->parent = nil.
	(read_key_sequence): Always start fkey.start and fkey.end at 0,
	and likewise for keytran.

2006-08-09  Kenichi Handa  <handa@m17n.org>

	* coding.c (syms_of_coding): Improve the docstring
	file-coding-system-alist.

2006-08-07  Andreas Schwab  <schwab@suse.de>

	* puresize.h (BASE_PURESIZE): Increase to 1120000.

2006-08-06  Chong Yidong  <cyd@stupidchicken.com>

	* buffer.c (Vchange_major_mode_hook, Qchange_major_mode_hook): New vars.
	(Fkill_all_local_variables): Use it.
	(syms_of_buffer): Defvar it.

2006-08-05  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (w32_valid_pointer_p): New function.

	* w32.h: Add prototype for w32_valid_pointer_p.

	* alloc.c: Include w32.h.
	(valid_lisp_object_p) [WINDOWSNT]: Call w32_valid_pointer_p to do
	the job.

	* keyboard.c (kbd_buffer_get_event): Return Qnil when current time
	is exactly equal to end_time, not only when it is past that.

2006-08-04  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): Rebalance specpdl after receiving jump.

	* process.c: Reapply 2006-08-01 change.

2006-08-04  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_query_font): Fix last change: use stricmp.

2006-08-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fsubst_char_in_region): Redo the setup work after running
	the before-change-functions since they may have altered the buffer.

2006-08-04  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): Handle -geometry command line option
	and the geometry settings in the Registry.

2006-08-04  Kenichi Handa  <handa@m17n.org>

	* w32fns.c (w32_query_font): Compare names by ignoring case.

	* xterm.c (x_query_font): Compare names by ignoring case.

2006-08-03  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (w32_menu_show, w32_dialog_show): Call Fsignal to quit
	when no option selected.

2006-08-03  Chong Yidong  <cyd@stupidchicken.com>

	* process.c: Revert last change.

2006-08-01  Kim F. Storm  <storm@cua.dk>

	* process.c (wait_reading_process_output_unwind): New function.
	Restores waiting_for_user_input_p to saved value.
	(wait_reading_process_output): Unwind protect waiting_for_user_input_p
	instead of save/restore old value on stack.

2006-07-30  Thien-Thi Nguyen  <ttn@gnu.org>

	* editfns.c: Undo 2006-06-27 change.

2006-07-29  Eli Zaretskii  <eliz@gnu.org>

	* coding.c (Ffind_operation_coding_system): Revert the change from
	2006-05-29.

	* alloc.c [WINDOWSNT]: Include fcntl.h, to fix last change.

2006-07-28  Richard Stallman  <rms@gnu.org>

	* xfaces.c (lookup_named_face, Fdisplay_supports_face_attributes_p):
	Add conditional aborts for clarity.

	* xdisp.c (update_menu_bar): New arg HOOKS_RUN.  Callers changed.
	Used to avoid running the hooks over and over for each frame.
	(prepare_menu_bars): Pass value from update_menu_bar
	as HOOKS_RUN of next call.

	* keyboard.c (safe_run_hooks_1): Don't crash if Vrun_hooks is nil.

2006-07-28  Kim F. Storm  <storm@cua.dk>

	* alloc.c (valid_pointer_p): New function (from valid_lisp_object_p).
	(valid_lisp_object_p): Use it to check for valid SUBRP obj.

2006-07-26  Chong Yidong  <cyd@stupidchicken.com>

	* keyboard.c (read_char): New arg END_TIME specifying timeout.
	All callers changed.  Turn off echoing if END_TIME is non-NULL.
	(kbd_buffer_get_event): New arg END_TIME.

	* lread.c (read_filtered_event): New arg SECONDS to wait until.
	(Fread_char, Fread_event, Fread_char_exclusive): New arg SECONDS.

	* lisp.h: Update read-char, read-event, and read_filtered_event
	prototypes.

	* keyboard.h: Include systime.h.  Update read_char prototype.

2006-07-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (find_string_data_in_pure): New function.
	(make_pure_string): Use it to reuse existing string data if possible.

	* puresize.h (BASE_PURESIZE): Decrease to 1102000.

2006-07-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (Fdefine_key): If the key binding definition looks like an
	XEmacs-style key sequence, convert it to Emacs's format.

2006-07-22  Ralf Angeli  <angeli@caeruleus.net>

	* w32fns.c (w32_createwindow): If `left' and/or `top' frame
	parameters are bound to some values, use that instead of
	CW_USEDEFAULT.

2006-07-21  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (convert_time): Use explicit long double constants to
	ensure long double arithmetics is used throughout.

2006-07-20  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* alloc.c (pure_bytes_used_lisp, pure_bytes_used_non_lisp): New	vars.
	(init_alloc_once): Initialize them.
	(pure_alloc): Allocate non-Lisp objects from the end of pure storage
	without alignment.

	* puresize.h (BASE_PURESIZE): Decrease to 1141000.

2006-07-18  Francis Litterio  <franl@world.std.com>

	* w32term.c (x_calc_absolute_position): Fix frame positioning
	with negative X/Y coordinates.

2006-07-18  Dan Nicolaescu  <dann@ics.uci.edu>

	* xterm.c (x_connection_closed, x_error_quitter): Mark as NO_RETURN.

	* textprop.c (text_read_only): Likewise.

	* lread.c (end_of_file_error): Likewise.

	* lisp.h (circular_list_error, memory_full, buffer_memory_full):
	Likewise.

	* eval.c (unwind_to_catch): Likewise.

	* buffer.h (buffer_slot_type_mismatch): Likewise.

2006-07-18  Kim F. Storm  <storm@cua.dk>

	Cleanup Fsignal calls that never returns; now only use it for Qquit.

	* eval.c (xsignal): New func.  Like Fsignal, but marked no-return.
	(xsignal0, xsignal1, xsignal2, xsignal3): New no-return functions.
	(signal_error): New no-return function (from xfaces.c).
	(Fthrow): Use xsignal2 instead of Fsignal + abort.
	(error): Use xsignal1 instead of Fsignal + abort.
	(FletX, Flet, grow_specpdl): Use signal_error.
	(Feval, Ffuncall, funcall_lambda): Use xsignal1, xsignal2.

	* alloc.c (buffer_memory_full, memory_full): Use xsignal.  Remove loop.
	(list1): New function.

	* lisp.h (list1): Add EXFUN.
	(xsignal, xsignal0, xsignal1, xsignal2, xsignal3, signal_error):
	Add prototypes.  Mark them as no-return.

	* buffer.c (Fbuffer_local_value, Fbarf_if_buffer_read_only):
	Use xsignal1.

	* callint.c (check_mark): Use xsignal0.

	* casefiddle.c (casify_object): wrong_type_argument is no-return.

	* cmds.c (Fforward_char, Fdelete_char): Use xsignal0.

	* coding.c (Fcheck_coding_system): Use xsignal1.  Remove loop.
	(Fdefine_coding_system_internal): Use xsignal1.

	* data.c (circular_list_error): Use xsignal.
	(wrong_type_argument): Use xsignal2.  Don't care about return value.
	(args_out_of_range, args_out_of_range_3): Use xsignal2, xsignal3.
	Remove loop around Fsignal.
	(indirect_variable, Fsymbol_value, set_internal, Fdefault_value)
	(indirect_function, Findirect_function, Fstring_to_number)
	(Fmakunbound, Ffmakunbound, Fsymbol_function, Ffset): Use xsignal1.
	(arith_driver, float_arith_driver, Frem, Fmod, arith_error):
	Use xsignal0.

	* doc.c (Fdocumentation): Use xsignal1.

	* editfns.c (region_limit, Fget_internal_run_time): Use xsignal0.

	* fileio.c (report_file_error): Use xsignal.
	(barf_or_query_if_file_exists, Fcopy_file, Fdelete_file)
	(Finsert_file_contents): Use xsignal2.
	(syms_of_fileio): Use list2, list3.

	* floatfns.c (arith_error, range_error, domain_error): Use xsignal2.
	(range_error2, domain_error2): Use xsignal3.
	(rounding_driver, fmod_float): Use xsignal0.
	(float_error): Use xsignal1.
	(matherr): Use xsignal.

	* fns.c (Flength): wrong_type_argument is no-return.
	(hashfn_user_defined, Fmake_hash_table): Use signal_error.
	(Fmd5): Use xsignal1.

	* frame.c (x_set_line_spacing, x_set_screen_gamma): Use signal_error.

	* keyboard.c (recursive_edit_1): Use xsignal1.

	* keymap.c (Fmap_keymap): Use xsignal1.

	* lread.c (Fload): Use xsignal2, signal_error.
	(end_of_file_error): Use xsignal0, xsignal1.
	(read0): Use xsignal1.
	(invalid_syntax): New error function marked no-return.
	(read_integer, read1, read_list): Use it.

	* macselect.c (x_get_local_selection): Use signal_error.

	* msdos.c (Fmsdos_set_mouse_buttons): Use xsignal2.

	* search.c (compile_pattern_1): Use xsignal1.
	(signal_failure): Remove (was only called once).
	(search_command): Use xsignal1 instead of signal_failure.

	* syntax.c (scan_lists): Use xsignal3.

	* textprop.c (text_read_only): Use xsignal0, xsignal1.

	* unexsol.c (unexec): Use xsignal.

	* window.c (window_scroll_pixel_based, window_scroll_line_based):
	Use xsignal0.

	* xfaces.c (signal_error): Move to eval.c.
	(resolve_face_name): Use xsignal1.

	* xfns.c (x_decode_color): Use signal_error.

	* xselect.c (x_get_local_selection, copy_multiple_data)
	(x_get_window_property_as_lisp_data)
	(lisp_data_to_selection_data, CHECK_CUT_BUFFER)
	(Fx_get_cut_buffer_internal): Use signal_error.

2006-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (XTread_socket): Undo previous change.

2006-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (keycode_to_xkeysym): Remove function.  All uses now
	directly lookup keycode_to_xkeysym_table.
	[USE_MAC_TSM] (mac_handle_text_input_event): Don't construct
	ASCII_KEYSTROKE_EVENT for non-zero keycode_to_xkeysym_table entries.
	(XTread_socket): Use character codes to construct keypad key events.
	(mac_initialize_display_info) [MAC_OSX]: Use CGDisplaySamplesPerPixel.
	(x_delete_display): Apply 2006-07-04 change for xterm.c.

2006-07-17  Richard Stallman  <rms@gnu.org>

	* keyboard.c (Vcommand_error_function): New variable.
	(syms_of_keyboard): Defvar it.
	(cmd_error_internal): Simplify, and handle Vcommand_error_function.

	* dispnew.c (init_display): Mention DISPLAY as well as TERM in err msg.

2006-07-17  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_single_display_spec): Ensure the right value of
	it->position is saved by push_it.
	(pop_it): Restore it->object for GET_FROM_BUFFER and GET_FROM_STRING.
	(reseat_1): Don't setup it->object twice.
	(set_iterator_to_next): No need to set it->object after pop_it.
	(move_it_to): Explicitly check to see if last move reached to_charpos.

2006-07-17  Thien-Thi Nguyen  <ttn@gnu.org>

	* xdisp.c (display_mode_line): Preserve match data.

2006-07-14  Kim F. Storm  <storm@cua.dk>

	* w32.c (pfn_WSACreateEvent, pfn_WSACloseEvent): New func ptrs.
	(init_winsock): Load them.  Use ws2_32.dll.
	(sys_listen): Undo last change.  Just set FILE_LISTEN flag.
	(sys_accept): Undo last change.  Instead, set child status to
	STATUS_READ_ACKNOWLEDGED and reset char_avail event so next
	sys_select will wakeup the reader thread.
	(_sys_wait_accept): New function used by reader thread to wait for
	an incoming connection on a server socket.

	* w32.h (_sys_read_ahead, _sys_wait_accept): Add prototypes.

	* w32proc.c (reader_thread): Use _sys_wait_accept to wait on a
	server socket (FILE_LISTEN flag).

2006-07-14  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* sound.c (alsa_init): Call snd_pcm_close after successful snd_pcm_open.

2006-07-14  Kim F. Storm  <storm@cua.dk>

	* w32.c: Fix high cpu load for server sockets.
	(pfn_WSAEventSelect): New function ptr.
	(init_winsock): Load it.
	(sys_listen): Set FILE_LISTEN flag. Set event mask for socket's
	char_avail event object to FD_ACCEPT.
	(sys_accept): Check FILE_LISTEN flag.  Set event mask on new
	socket's char_avail event object to FD_READ|FD_CLOSE.

	* w32.h (FILE_LISTEN): New filedesc flag value.

2006-07-13  Kim F. Storm  <storm@cua.dk>

	* bytecode.c (Fbyte_code): Use CAR, CDR for Bcar, Bcdr.
	Use CAR_SAFE, CDR_SAFE for Bcar_safe, Bcdr_safe.
	Simplify loops and use CAR for Bnth and Belt.

	* data.c (Findirect_function): Optimize for no indirection.

	* eval.c (Fthrow): Remove loop around Fsignal.
	(Feval, Fapply, Ffuncall): Optimize for no function indirection.
	Use original function name in all signaled errors.
	Simplify Fsignal calls (no return).
	(funcall_lambda): Simplify Fsignal calls (no return).

2006-07-13  Andreas Schwab  <schwab@suse.de>

	* syntax.c (scan_sexps_forward): Use EMACS_INT for out_bytepos and
	out_charpos.

2006-07-13  Kenichi Handa  <handa@m17n.org>

	* editfns.c (Fformat): Fix calculation of text property positions
	of format string.

2006-07-12  Kim F. Storm  <storm@cua.dk>

	* lisp.h (CHECK_TYPE): New macro for generic type checking.
	(CAR_SAFE, CDR_SAFE): New macros.
	(ARRAYP, CHECK_ARRAY): New macros.
	(CHECK_VECTOR_OR_STRING, CHECK_SUBR): New macros.
	(CHECK_WINDOW_CONFIGURATION): New macro.
	(CHECK_LIST_CONS, CHECK_LIST_END): New checks for list traversal.
	(CHECK_STRING_OR_BUFFER, CHECK_HASH_TABLE, CHECK_LIST)
	(CHECK_STRING, CHECK_STRING_CAR, CHECK_CONS, CHECK_SYMBOL)
	(CHECK_CHAR_TABLE, CHECK_VECTOR, CHECK_VECTOR_OR_CHAR_TABLE)
	(CHECK_BUFFER, CHECK_WINDOW, CHECK_LIVE_WINDOW, CHECK_PROCESS)
	(CHECK_NUMBER, CHECK_NATNUM, CHECK_MARKER, CHECK_OVERLAY)
	(CHECK_NUMBER_COERCE_MARKER, CHECK_FLOAT, CHECK_NUMBER_OR_FLOAT)
	(CHECK_NUMBER_OR_FLOAT_COERCE_MARKER): Use CHECK_TYPE.

	* category.h (CHECK_CATEGORY, CHECK_CATEGORY_SET):
	* frame.h (CHECK_FRAME, CHECK_LIVE_FRAME): Use CHECK_TYPE.

	* callint.c (Fcall_interactively):
	* casefiddle.c (casify_object):
	* editfns.c (general_insert_function):
	* fns.c (Flength, Felt, Ffillarray):
	* data.c (Fcar, Fcdr): Remove loop around wrong_type_argument.

	* data.c (wrong_type_argument): Remove loop around Fsignal.
	(Farrayp, Fsequencep): Use ARRAYP.
	(Fcar): Use CAR.
	(Fcar_safe): Use CAR_SAFE.
	(Fcdr): Use CDR.
	(Fcdr_safe): Use CDR_SAFE.
	(Fsetcar, Fsetcdr): Use CHECK_CONS.
	(Fsubr_arity, Fsubr_name): Use CHECK_SUBR.
	(Faset): Use CHECK_ARRAY.

	* fns.c (Felt): Use CHECK_ARRAY.
	(concat): Use CHECK_NUMBER.
	(Fsubstring, substring_both): Use CHECK_VECTOR_OR_STRING.
	(Fmemq): Use CHECK_LIST.
	(Fassq, Fassoc, Frassq, Frassoc): Use CAR.
	(assq_no_quit): Use CAR_SAFE.
	(Fnthcdr, Fmember, Fdelq, Fdelete, Fnreverse, Fnconc):
	Use CHECK_LIST_CONS.
	(Freverse, Fplist_get, Flax_plist_get): Use CHECK_LIST_END.

	* bytecode.c (Fbyte_code): Use CHECK_VECTOR.

	* casetab.c (check_case_table):
	* category.c (check_category_table):
	* marker.c (Fcopy_marker):
	* syntax.c (check_syntax_table):
	* xfaces.c (load_pixmap): Use CHECK_TYPE.

	* fns.c (Fcopy_sequence, concat):
	* fringe.c (Fdefine_fringe_bitmap):
	* lread.c (check_obarray): Cleanup wrong_type_argument use.

	* keyboard.c (access_keymap_keyremap): Use ARRAYP.

	* keymap.c (Fdefine_key, Flookup_key):
	* macros.c (Fstart_kbd_macro): Use CHECK_VECTOR_OR_STRING.

	* mac.c (Fmac_get_preference): Use CHECK_LIST_END.

	* search.c (Fset_match_data): Use CHECK_LIST.

	* sunfns.c (sun_item_create): Use CHECK_LIST_CONS.

	* window.c (Fwindow_configuration_frame, Fset_window_configuration):
	(compare_window_configurations): Use CHECK_WINDOW_CONFIGURATION.

2006-07-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (dired.o, editfns.o, fileio.o): Depend on blockinput.h.

	* dired.c: Include blockinput.h.
	(Ffile_attributes): Add BLOCK_INPUT around getpwuid/getgrgid.

	* editfns.c: Include blockinput.h.
	(Fuser_login_name, Fuser_full_name): Add BLOCK_INPUT around
	getpwuid/getpwnam.

	* fileio.c: Include blockinput.h.
	(Fexpand_file_name, search_embedded_absfilename): Add BLOCK_INPUT
	around getpwnam.
	(search_embedded_absfilename): Remove spurious xfree.

2006-07-11  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (sit_for): Reduce number of args from 5 to 3.
	Now just one TIMEOUT arg that can be a Lisp float or Lisp int.
	Combine args DISPLAY and INITIAL_DISPLAY into one arg DO_DISPLAY.
	Signal error if TIMEOUT is not a number.
	Undo 2006-06-14 change for non-preemptive display if TIMEOUT < 0.
	The rework of sit_for args also fixes several incorrect Qt args
	which should have been 1.
	(Fredisplay): Pass 1 instead of Qt to swallow_events and
	detect_input_pending_run_timers.

	* lisp.h (sit_for): Update prototype.
	(Fredisplay): Add EXFUN.

	* dispextern.h (sit_for): Remove prototype.

	* callint.c (Fcall_interactively):
	* minibuf.c (temp_echo_area_glyphs):
	* keyboard.c (command_loop_1, read_char, Fexecute_extended_command):
	* fileio.c (Fdo_auto_save): Update/simplify sit_for calls.

2006-07-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (forw_comment): Also use EMACS_INT for buffer positions.

2006-07-11  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (Fredisplay): Add FORCE argument to force redisplay when
	input is available.  Fix test for redisplay_dont_pause non-nil.
	Specbind redisplay-dont-pause to t if FORCE non-nil.

2006-07-10  Chong Yidong  <cyd@stupidchicken.com>

	* puresize.h (BASE_PURESIZE): Increment to 1211000.

	* dispnew.c (Fredisplay): New function, equivalent to (sit-for 0).
	(Fsit_for): Function deleted.

	* keyboard.c (command_loop_1, Fexecute_extended_command):
	Call sit_for instead of Fsit_for.

	* minibuf.c (temp_echo_area_glyphs): Likewise.

2006-07-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (Fforward_comment): Revert the reversion.
	(back_comment, scan_lists): Also use EMACS_INT for buffer positions.

2006-07-09  John Paul Wallington  <jpw@pobox.com>

	* syntax.c (Fforward_comment): Revert previous change.

2006-07-09  Kim F. Storm  <storm@cua.dk>

	* window.c (Fforce_window_update): Doc fix.

2006-07-08  Stephen Gildea  <gildea@stop.mail-abuse.org>

	* fileio.c (do_auto_save_make_dir): Make the auto-save-list-file
	directory unreadable for better user privacy.

2006-07-07  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (Fforward_comment): Fix int-32 vs EMACS_INT-64 mixup.

	* lread.c (read_filtered_event): Remove `register' qualifier because it
	causes compilation problem with gcc-4.0.2-20051125 on amd64.
	(readevalloop): Remove unused var `bpos'.
	Yet another int/Lisp_Object mixup (YAILOM).

2006-07-07  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (Fexecute_extended_command): Mention the argument
	PREFIXARG in the doc string.

2006-07-07  Kim F. Storm  <storm@cua.dk>

	* fringe.c (Fdefine_fringe_bitmap): Doc fix.

2006-07-05  Chong Yidong  <cyd@stupidchicken.com>

	* insdel.c (prepare_to_modify_buffer): For an indirect buffer, do
	clash detection using the base buffer.

	* puresize.h (BASE_PURESIZE): Increment to 1210500.

2006-07-04  Kim F. Storm  <storm@cua.dk>

	* xterm.c (x_delete_display): Don't free or derefence NULL pointers.

2006-07-04  Kenichi Handa  <handa@m17n.org>

	* fontset.c (Fset_overriding_fontspec_internal): Check if we need
	to update Voverriding_fontspec_alist.

2006-07-03  Richard Stallman  <rms@gnu.org>

	* xfns.c (Fx_create_frame): Move unwind_create_frame setup down.

	* xfaces.c (Fface_attribute_relative_p): Doc fix.

	* textprop.c (Fget_char_property_and_overlay): Doc fix.

	* eval.c (Fdefvaralias): Doc fix.

2006-07-03  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (sit_for): Fix preempt condition.

2006-07-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (read_filtered_event): Treat select-window just like
	switch-frame.

2006-07-02  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_tool_bar_line): Skip glyphs which are too big
	to ever fit the tool-bar,
	(MAX_FRAME_TOOL_BAR_HEIGHT): New macro.
	(tool_bar_lines_needed): Use unused mode-line row as temp_row.
	(redisplay_tool_bar): Only clear desired matrix if we actually
	change the tool-bar window height.  Only try to make the tool-bar
	window bigger if there is actually room for it.

2006-06-30  Ralf Angeli  <angeli@caeruleus.net>

	* w32term.c (x_make_frame_visible): Use SystemParametersInfo with
	SPI_GETWORKAREA to find the dimensions of the screen work area,
	and adjust vertical position of the frame in order to avoid being
	covered by the task bar.

	* w32fns.c (w32_createwindow): Use CW_USEDEFAULT instead of
	f->left_pos and SH_SHOW instead of f->top_pos in the call to
	CreateWindow.  Record the actual position in f->left_pos and
	f->top_pos.

2006-06-30  John Paul Wallington  <jpw@pobox.com>

	* w32console.c (syms_of_ntterm) <w32-use-full-screen-buffer>:
	Doc fix - default value has changed.

2006-06-28  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [!TARGET_API_MAC_CARBON]: Don't include FixMath.h or Scrap.h.

	* macfns.c (Fx_create_frame): Apply 2006-06-24 change for xfns.c.

	* macgui.h (USE_MAC_TSM) [TARGET_API_MAC_CARBON]: Set default to 1.

	* macterm.c (Qeql): Add extern.
	(x_set_mouse_pixel_position) [MAC_OSX]: Use CGWarpMouseCursorPosition.
	(fm_style_face_attributes_alist) [USE_ATSUI]: New variable.
	(syms_of_macterm) [USE_ATSUI]: Initialize and staticpro it.
	Change keys of Vmac_atsu_font_table from strings to numbers.
	(fm_style_to_face_attributes) [USE_ATSUI]: New function.
	(init_font_name_table) [USE_ATSUI]: Use it.
	(saved_ts_script_language_on_focus) [USE_MAC_TSM]: New variable.
	(syms_of_macterm) [USE_MAC_TSM]: Initialize and staticpro it.
	[USE_MAC_TSM] (mac_tsm_resume): Restore script and language codes
	only when saved_ts_script_language_on_focus coincides with
	Vmac_ts_script_language_on_focus.
	[USE_MAC_TSM] (mac_tsm_suspend): Save value of
	Vmac_ts_script_language_on_focus to saved_ts_script_language_on_focus.
	(XTread_socket) [USE_MAC_TSM]: Add Mac OS Classic support.
	[USE_MAC_TSM] (mac_handle_text_input_event, init_tsm): Likewise.

2006-06-27  Chong Yidong  <cyd@stupidchicken.com>

	* editfns.c (Fdelete_field, Ffield_string, Ffield_beginning)
	(Ffield_string_no_properties, Ffield_end): Mention
	args-out-of-range error condition in docstring.

2006-06-27  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_composition_prop): Set stop_charpos before push_it.

2006-06-25  Kim F. Storm  <storm@cua.dk>

	* s/gnu-linux.h (SIGNALS_VIA_CHARACTERS): Define for Linux kernel
	version 2.4 and later.

2006-06-24  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (Fx_create_frame): Set font parameter directly instead of
	using x_default_parameter, since x_get_args clears the parm alist.

2006-06-24  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (directory_files_internal) [WINDOWSNT]: Find files
	case-insensitively.

2006-06-24  Aidan Kehoe  <kehoea@parhasard.net>

	* lread.c (read_escape): When an unknown Unicode code point is
	encountered as a string or character escape, signal an error.

2006-06-23  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Dump iterator stack.

	* xdisp.c (handle_composition_prop): Push iterator on stack.
	(set_iterator_to_next): Pop iterator at end of composition.

2006-06-23  Martin Rudalics  <rudalics@gmx.at>

	* fileio.c (Frename_file) [DOS_NT]: Don't try to move directory to
	itself on DOS_NT platforms, if the old and new names are identical
	but for the letter-case.

2006-06-21  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (struct it): Add `position' member to iterator stack.
	Rename `pos' member to `current'.  Rearrange and add comments.

	* xdisp.c (handle_stop): Set it->ignore_overlay_strings_at_pos_p
	if  we get any overlays.
	(set_cursor_from_row): Don't clobber `end' if we rescan from
	start_string.
	(push_it, pop_it): Save it->position.

2006-06-19  Richard Stallman  <rms@gnu.org>

	* window.c (size_window): New arg FIRST_ONLY.  All callers changed.
	(adjust_window_trailing_edge): Specially compute FIRST_PARALLEL
	for the case of a top-level window and the following minibuffer.
	Don't exit because of no `next' when there is a parent.
	Use the FIRST_ONLY feature when resizing following windows.

	* syntax.c (init_syntax_once): Give most control chars' syntax Spunct.

2006-06-17  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (update_frame): Check for input pending on entry.
	(update_window, update_frame_1): Break loop if input is detected.

2006-06-16  Francis Litterio  <flitterio@gmail.com>

	* xterm.c (x_check_expected_move, handle_one_xevent)
	(x_set_offset, x_check_fullscreen): Extensive changes to make
	frame positioning deterministic under X.

	* xterm.h (x_output): Add members left_before_move and
	top_before_move.  Removed members expected_left and expected_top.

2006-06-16  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (struct it): Add union to iterator stack to save
	image, composition, and stretch specific paramters.

	* xdisp.c (next_overlay_string): Fix assert.
	(push_it, pop_it): Handle composition and stretch specific values.
	Only handle it->slice in image (for now).
	(back_to_previous_visible_line_start): Continue search if newline is
	part of a compisition.  Simplify.
	(reseat_1): Set it->object to buffer.
	(set_iterator_to_next): Set it->object to string or buffer, when
	setting it->method to GET_FROM_STRING or GET_FROM_BUFFER.
	(next_element_from_composition): Set it->object to buffer if not
	from string.
	(set_cursor_from_row): Only save start of string if not already
	done to handle multiple strings in a row.

	* .gdbinit (pitx): Show composition parameters.
	(pgx, pg): New commands to print a glyph structure.
	(pgi, pgn): New commands to print specific/next glyph.
	(pgrowx, pgrow): New commands to print all glyphs in a row.

2006-06-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (Fx_display_mm_height, Fx_display_mm_width)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1030]: Use CGDisplayScreenSize.

	* macterm.c (do_app_resume, do_app_suspend): Remove functions.
	(mac_tsm_resume, mac_tsm_suspend) [USE_MAC_TSM]: New functions.
	(mac_handle_window_event, XTread_socket) [USE_MAC_TSM]: Use them.
	(Vmac_ts_script_language_on_focus) [USE_MAC_TSM]: New variable.
	(syms_of_macterm) [USE_MAC_TSM]: Defvar it.
	(saved_ts_language, saved_ts_component) [USE_MAC_TSM]: New variables.
	(mac_initialize_display_info) [MAC_OSX]: Use Quartz Display
	Services functions to get size of main display in pixels.

2006-06-14  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (back_to_previous_visible_line_start):
	Reset it->continuation_lines_width.

2006-06-14  Richard Stallman  <rms@gnu.org>

	* eval.c (Fdefconst): Mark variable as risky.

	* callproc.c (Fcall_process): Doc fix.

	* window.c (adjust_window_trailing_edge): Don't break out of the loop
	because there's no next window, if there are parallel windows.
	Do break out when WINDOW is nil.

2006-06-14  Kim F. Storm  <storm@cua.dk>

	* dispextern.h (IT_STACK_SIZE): New macro specifying size of
	iterator stack (instead of hardcoded number).  Increase from 2 to
	4 to make room for propertized overlay strings before and after a
	display string, image or composition.
	(struct it): Add image_id and method members to iterator stack.

	* xdisp.c (init_from_display_pos): Don't set it->method and
	overlay_string_index after pop_it.  Add asserts.
	(handle_stop): Look for overlay strings around a display string,
	image, or composition.  Handle properties on those strings.
	(next_overlay_string): Don't set string, pos or method after pop_it.
	(get_overlay_strings_1): Split from get_overlay_strings; don't
	modify it if no overlay strings are found.
	(get_overlay_strings): Use get_overlay_strings_1.  Always set
	it->string and it->method.
	(push_it): Push it->image_id and it->method.  Push it->object
	instead of it->string if method is GET_FROM_IMAGE.
	(pop_it): Pop it->image_id and it->method.  Ppo it->object
	instead of it->string if method is GET_FROM_IMAGE.
	Reset it->current.string_pos if popped it->string is nil.
	(reseat_1): Remove comment dated 19 May 2003.  It expressed doubt
	whether a given change was correct; but the change is correct.
	Clear it->string_from_display_prop_p.
	(set_iterator_to_next): Rely on it->method and it->image_id from
	iterator stack, instead of setting them explicitly after pop_it.

	* dispnew.c (sit_for): Undo 2006-06-01 change.  Instead, a
	negative time forces redisplay even when input is available.
	(Fsit_for): Doc fix.

2006-06-13  Kim F. Storm  <storm@cua.dk>

	* dispnew.c: Modify preemptive redisplay to be based on periodic
	checks for input.
	(PERIODIC_PREEMPTION_CHECKING): Define to 1 iff EMACS_HAS_USECS.
	(Vredisplay_preemption_period): New variable.
	(syms_of_display): DEFVAR_LISP and initialize it.
	(preemption_period, preemption_next_check): New variables.
	(update_frame, update_single_window): Initialize them based on
	Vredisplay_preemption_period if !force_p.
	(update_window, update_frame_1): Use them to determine when to
	check for input.

2006-06-03  Aidan Kehoe  <kehoea@parhasard.net>

	* lread.c (read_escape): Provide a Unicode character escape
	syntax; \u followed by exactly four or \U followed by exactly
	eight hex digits in a comment or string is read as a Unicode
	character with that code point.

2006-06-09  Eli Zaretskii  <eliz@gnu.org>

	* window.c (window_scroll_pixel_based): Signal "Beginning of
	buffer" when scroll-down at the beginning of an empty buffer.

2006-06-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_MAC_TSM] (mac_handle_text_input_event):
	Exclude 0x7f from ASCII range.

2006-06-05  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (w32_set_scroll_bar_thumb, x_scroll_bar_create)
	(w32_set_vertical_scroll_bar, w32_scroll_bar_handle_click)
	(x_scroll_bar_report_motion): Remove workarounds for
	versions of Windows NT < 3.51.
	[!SIF_ALL]: Remove.
	(pfnSetScrollInfo, pfnGetScrollInfo): Remove.
	(w32_initialize): Don't dynamically load Get/SetScrollInfo.

2006-06-04  David Kastrup  <dak@gnu.org>

	* dispnew.c: Mention `redisplay-dont-pause' in doc string of
	`sit-for'.

2006-06-03  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_set_icon_name): Apply 2006-06-02 change for xfns.c.

	* macgui.h (USE_MAC_TSM): Set default to 1 on Mac OS X.

	* macterm.c (tsm_document_id) [USE_MAC_TSM]: New variable.
	(Qtext_input, Qupdate_active_input_area, Qunicode_for_key_event)
	[USE_MAC_TSM]: Likewise.
	(syms_of_macterm) [USE_MAC_TSM]: Intern and staticpro them.
	(Qbefore_string) [USE_MAC_TSM]: Add extern.
	(do_app_resume, do_app_suspend) [USE_MAC_TSM]: Call
	ActivateTSMDocument/DeactivateTSMDocument.
	(mac_store_event_ref_as_apple_event): Call mac_post_mouse_moved_event.
	(mac_handle_window_event) [USE_MAC_TSM]: Handle
	kEventWindowFocusAcquired/kEventWindowFocusRelinquish.
	(mac_handle_text_input_event) [USE_MAC_TSM]: New function.
	(install_window_handler) [USE_MAC_TSM]: Install it.  Register
	kEventWindowFocusAcquired/kEventWindowFocusRelinquish.
	(keycode_to_xkeysym_table): Add entry for f16.
	(XTread_socket) [USE_MAC_TSM]: Set/reset read_socket_inev
	before/after passing keystroke event to toolbox dispatcher.
	(init_tsm) [USE_MAC_TSM]: New function.
	(mac_initialize) [USE_MAC_TSM]: Call it.
	(Vmac_ts_active_input_overlay) [USE_MAC_TSM]: New defvar.

	* macterm.h (EVENT_PARAM_TEXT_INPUT_SEQUENCE_NUMBER): New enumerator.

2006-06-02  John Paul Wallington  <jpw@gnu.org>

	* xfns.c (x_set_name_internal): Set icon to `text', derived from
	name, when frame's icon_name isn't a string rather than only when
	it is nil.

2006-06-03  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (x_set_icon_name): Don't use arg if it's not a string
	and not nil.

2006-06-02  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (x_set_icon_name): No-op if arg is non-nil and not a
	string.

2006-06-02  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (next_element_from_composition): Set it->object to
	it->string if composition is coming from string.
	(set_cursor_from_row): Don't return 0 unless row displays a
	continued line.
	(dump_glyph): Dump composite glyph.

2006-06-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (menu_nav_ended): Check that menubar_widget is not NULL.

2006-06-01  Richard Stallman  <rms@gnu.org>

	* window.c (Fsplit_window): Doc fix.

2006-06-01  Micha,Ak(Bl Cadilhac  <michael.cadilhac@lrde.org>

	* process.c (deleted_pid_list): New variable to store the pids
	of deleted processes.  Declare it only if SIGCHLD is defined.
	(init_process): Initialize it.
	(syms_of_process): Staticpro it.
	(Fdelete_process): Add pid of the deleted process to it.  Check after
	the addition and before the kill if the process is already stopped,
	in which case it is deleted from the list and not killed.
	(sigchld_handler): Define it only if SIGCHLD is.  Search the process
	that signaled Emacs in `deleted_pid_list' before `Vprocess_alist'.
	Original idea by Stefan Monnier.

2006-06-01  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (sit_for): Perform redisplay even if input is pending
	when redisplay-dont-pause is non-nil.

2006-06-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_handle_visibility_change): Set buf.arg to Qnil.
	(XTread_socket): Remove obsolete comment.

2006-06-01  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (syms_of_xmenu): Make accelerate-menu an alias for
	menu-bar-open.

2006-06-01  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xmenu.c (Fmenu_bar_open, syms_of_xmenu): Change menu-bar-start to
	menu-bar-open.

	* gtkutil.c (menu_nav_ended): Change x-menu-bar-start to menu-bar-open.

2006-05-31  Juri Linkov  <juri@jurta.org>

	* minibuf.c (Vhistory_add_new_input): New variable.
	(read_minibuf): Use it.
	(syms_of_minibuf) <history-add-new-input>: New Lisp variable.
	(syms_of_minibuf) <history-delete-duplicates>: Doc fix.

2006-05-31  Kim F. Storm  <storm@cua.dk>

	* process.c (select_wrapper): Add wrapper around select to work around
	"incomplete backtrace" bug in gdb 5.3, when emacs is stopped inside
	select called from wait_reading_process_output.

2006-05-30  Andreas Schwab  <schwab@suse.de>

	* xmenu.c (Fmenu_bar_start): Return a value.

2006-05-30  Richard Stallman  <rms@gnu.org>

	* coding.c (Ffind_operation_coding_system): Doc fix.

2006-05-30  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c (x_draw_hollow_cursor): Fix last change.

2006-05-29  Kim F. Storm  <storm@cua.dk>

	* w32term.c (x_draw_stretch_glyph_string): Fix last change.

2006-05-29  Eli Zaretskii  <eliz@gnu.org>

	* coding.c (Ffind_operation_coding_system): Doc fix.

2006-05-29  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c [USE_MAC_FONT_PANEL] (Fmac_set_font_panel_visibility):
	Call mac_set_font_info_for_selection if font panel is made visible.

	* macterm.c (font_panel_shown_p) [USE_MAC_FONT_PANEL]: New variable.
	(mac_font_panel_visible_p, mac_show_hide_font_panel)
	[USE_MAC_FONT_PANEL]: New functions.
	[USE_MAC_FONT_PANEL] (mac_set_font_info_for_selection): Return
	immediately if font panel is not visible.

	* macterm.h (mac_font_panel_visible_p, mac_show_hide_font_panel):
	Add externs.

2006-05-29  Dan Nicolaescu  <dann@ics.uci.edu>

	* search.c (matcher_overflow): Mark as NO_RETURN.

	* xterm.c (x_connection_closed): Likewise.

	* sysdep.c (croak): Likewise.

	* sound.c (sound_perror, alsa_sound_perror): Likewise.

	* lisp.h (die, nsberror): Likewise.

2006-05-29  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* sound.c (alsa_open, alsa_configure, alsa_write): Move
	assignment to err out of if-statement.

	* gtkutil.c (menu_nav_ended): New function.
	(create_menus): Connect menu_nav_ended to "selection-done" to fix
	grabs.

	* xmenu.c (Fmenu_bar_start): New function for USE_GTK and USE_X_TOOLKIT.

2006-05-28  Dan Nicolaescu  <dann@ics.uci.edu>

	* charset.h (invalid_character): Mark as NO_RETURN.

2006-05-29  Kenichi Handa  <handa@m17n.org>

	* coding.c (Ffind_operation_coding_system): Call a function by
	safe_call1 instead of call1.

2006-05-28  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (struct saved_window): Add `dedicated'.
	(Fset_window_configuration, save_window_save): Save/restore the
	`dedicated' flag.

2006-05-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_cursor_from_row): If cursor cannot be set in row,
	don't update w->cursor and return 0.  Return 1 on success.
	(try_cursor_movement): Repeat set_cursor_from_row on successive rows
	until it succeeds.

	* dispextern.h (set_cursor_from_row): Update prototype.

2006-05-28  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (get_phys_cursor_geometry): Return computed x and y through
	parameters.  Adjust x and width in case cursor in on a partially
	visible stretch glyph on the left edge.
	(erase_phys_cursor): Don't erase into left fringe/margin in case
	previous cursor glyph is a partially visible stretch glyph on left.

	* dispextern.h (get_phys_cursor_geometry): Update prototype.

	* xterm.c (x_draw_stretch_glyph_string): Fix problems with invisible
	cursor and erasing cursor on partially visible stretch glyph on left.
	(x_draw_hollow_cursor): Compute x via get_phys_cursor_geometry.

	* macterm.c: Likewise.

	* w32term.c: Likewise.

2006-05-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macselect.c (mac_handle_apple_event):
	Return errAEEventNotHandled if key binding is not found.

2006-05-26  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (main) [PROFILING]: Enable also for __MINGW32__.
	[__MINGW32__]: MinGW-specific declaration of `etext'.

	* w32heap.c (etext, edata): Remove unused definitions.

2006-05-26  Chong Yidong  <cyd@stupidchicken.com>

	* fileio.c (Fcopy_file): Delete argument MUSTBENEW.
	Incorporate the exclusive file-opening functionality into the behavior
	when OK-IF-ALREADY-EXISTS is nil.
	(Frename_file): Call Fcopy_file without MUSTBENEW argument.

2006-05-26  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* sound.c (alsa_configure): Move get period/buffer_size after
	setting hwparams.

2006-05-26  Kenichi Handa  <handa@m17n.org>

	* coding.c (Ffind_operation_coding_system): Allow (FILENAME
	. BUFFER) in TARGET.

2006-05-25  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (png_load): Don't call fclose on NULL.

2006-05-25  Luc Teirlinck  <teirllm@auburn.edu>

	* fns.c (Fyes_or_no_p):
	* callint.c (Fcall_interactively): Fread_from_minibuffer now takes
	only seven args.

2006-05-25  Juri Linkov  <juri@jurta.org>

	* lisp.h (Fread_from_minibuffer): Decrement number of args.

	* minibuf.c (read_minibuf): Remove arg KEEP_ALL.  Callers changed.
	(Fread_from_minibuffer): Remove arg KEEP_ALL.  Callers changed.

	* buffer.c (mode-line-format): Fix docstring.

2006-05-25  Richard Stallman  <rms@gnu.org>

	* emacs.c (main, Fdump_emacs): Don't test __linux or __linux__.

2006-05-24  Luc Teirlinck  <teirllm@auburn.edu>

	* puresize.h (BASE_PURESIZE): Increase to 1210000.

2006-05-24  Alan Mackenzie  <acm@muc.de>

	* lread.c (Vload_history): Enhance doc-string to say that the file
	is the absolute truename of the loaded file.

	* lread.c (Vafter_load_alist): doc-string: state that an element
	now has a regexp to match file names, not a file name as such.

	* lread.c (readevalloop): Call file-truename on the name for
	load-history, except at preloading time.

	* lread.c (Fload): At preloading time, preserve the extension of
	the filename which goes into load-history.  New var hist_file_name.

	* lread.c (Fload): Do eval-after-load stuff by calling the lisp
	function do-after-load-evaluation.

2006-05-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (ae_attr_table): New variable.
	(syms_of_mac): Intern and staticpro its elements.
	(mac_aelist_to_lisp): Also convert Apple event attributes.
	(mac_ae_put_lisp): New function.
	(create_apple_event_from_event_ref) [MAC_OSX]: Use typeUTF8Text.

	* macfns.c (Fx_server_version): Use gestaltSystemVersionMajor etc.

	* macselect.c (Qemacs_suspension_id): New variable.
	(syms_of_macselect): Intern and staticpro it.
	(struct suspended_ae_info): New struct.
	(deferred_apple_events, defer_apple_events)
	(Fmac_process_deferred_apple_events): Use it.
	(suspended_apple_events): New variable.
	(mac_handle_apple_event_1): New function.
	(mac_handle_apple_event): Use it.  Don't process previously
	suspended events.
	(cleanup_suspended_apple_events, get_suspension_id)
	(cleanup_all_suspended_apple_events): New functions.
	(init_apple_event_handler): Call cleanup_all_suspended_apple_events
	at exit.
	(Fmac_cleanup_expired_apple_events, Fmac_ae_set_reply_parameter)
	(Fmac_resume_apple_event): New defuns.
	(syms_of_macselect): Defsubr them.

	* macterm.c (fn_keycode_to_keycode_table, XTread_socket) [MAC_OSX]:
	Fix last change.  Don't map `fn' modifier if pressed with F1 ... F12.

	* macterm.h (TYPE_FILE_NAME): Change from macro to enumerator.
	(KEY_EMACS_SUSPENSION_ID_ATTR): New enumerator.
	(keyReplyRequestedAttr) [MAC_OS_X_VERSION_MAX_ALLOWED < 1030]: Likewise.
	(gestaltSystemVersionMajor, gestaltSystemVersionMinor)
	(gestaltSystemVersionBugFix) [MAC_OS_X_VERSION_MAX_ALLOWED < 1040]:
	Likewise.
	(typeUTF8Text, kEventParamWindowMouseLocation)
	[MAC_OSX && MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Likewise.
	(x_get_focus_frame, mac_ae_put_lisp): Add externs.

2006-05-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (fn_keycode_to_xkeysym_table, convert_fn_keycode): Remove.
	(fn_keycode_to_keycode_table) [MAC_OSX]: New variable.
	(mac_set_unicode_keystroke_event) [TARGET_API_MAC_CARBON]: New function.
	(XTread_socket) [TARGET_API_MAC_CARBON]: Use it.
	(XTread_socket) [MAC_OSX]: Try 'uchr' Unicode keyboard-layout
	resource to backtranslate key with modifiers.
	(XTread_socket): Don't set read_socket_inev around AEProcessAppleEvent.

2006-05-23  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c: Remove declarations already in xterm.h

	* xterm.h: Add extern declarations for x_clear_errors,
	x_fully_uncatch_errors, x_catching_errors and
	x_alloc_lighter_color_for_widget.  Remove duplicated declarations.

2006-05-21  Richard Stallman  <rms@gnu.org>

	* xfaces.c (best_matching_font): Abort for best == NULL
	before we start to use it.

	* buffer.c (syms_of_buffer, Fmake_overlay): Doc fixes.

2006-05-20  Kim F. Storm  <storm@cua.dk>

	* xfaces.c (best_matching_font): Fix crash in 2006-05-17 change.

2006-05-20  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (convert_fn_keycode): Fix last change.

2006-05-19  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (init_environment): Perform the processing of environment
	variables on a copy of default variables and their values, not on
	the original.  Simplify code that calls ExpandEnvironmentStrings
	and make buf1[] and buf2[] more visible for easier debugging.

2006-05-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* frame.c (x_set_border_width): Remove #ifndef MAC_OS.

	* image.c [MAC_OS] (gif_load): Allocate Lisp string first.

	* macfns.c (Fx_focus_frame): Don't check dpyinfo->x_focus_frame.

	* macterm.c (XTread_socket) [TARGET_API_MAC_CARBON && MAC_OSX]:
	Forward keyUp events to toolbox_dispatcher.

	* window.c (foreach_window): Check WINDOWP (FRAME_ROOT_WINDOW (f)).

2006-05-18  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* config.in: Regenerated (HAVE_ALSA).

	* sound.c (alsa_sound_perror, alsa_open, alsa_period_size)
	(alsa_configure, alsa_close, alsa_choose_format, alsa_write)
	(snd_error_quiet, alsa_init): New functions.
	(vox_init): Return 0 if unable to open device.
	(Fplay_sound_internal): Test for alsa first and use vox (oss) as
	a fallback.
	(struct sound_device): Add period_size.
	(wav_play, au_play): Use period_size if set.

	* Makefile.in (CFLAGS_SOUND): New flags for ALSA
	(ALL_CFLAGS): Add CFLAGS_SOUND

2006-05-18  Kenichi Handa  <handa@m17n.org>

	* callproc.c (Fcall_process): Reject encoding arguments by
	ascii-incompatible coding systems (e.g. utf-16).

	* coding.c (Qascii_incompatible): New variable.
	(syms_of_coding): Setup Qascii_incompatible.
	(setup_coding_system): Be sure to initialize coding->common_flags.
	Check `ascii-incompatible' property of the coding system.

	* coding.h (CODING_ASCII_INCOMPATIBLE_MASK): New macro.

2006-05-18  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_tool_bar_line): Restore entire tool-bar
	geometry when backtracking in case last image doesn't fit on line.

2006-05-18  MIYOSHI Masanori  <miyoshi@meadowy.org>  (tiny change)

	* xdisp.c (display_tool_bar_line): Don't adjust tool-bar height by
	more than height of one frame default line.

2006-05-17  Richard Stallman  <rms@gnu.org>

	* xfaces.c (better_font_p): Any font beats no font.
	(best_matching_font): Simplify based on above change.

	* buffer.c (Fprevious_overlay_change, Fnext_overlay_change): Doc fixes.

2006-05-16  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent): Check that f is not NULL before
	calling x_kill_gs_process.

2006-05-14  Richard Stallman  <rms@gnu.org>

	* textprop.c (Fnext_single_char_property_change)
	(Fprevious_single_char_property_change): Don't allow returning
	value beyond LIMIT in any cases.
	(Fnext_char_property_change, Fprevious_char_property_change): Doc fix.

	* intervals.c (get_local_map): Abort if POSITION outside BEGV, ZV.

2006-05-14  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Check that f is not NULL before
	calling _XEditResCheckMessages.

2006-05-14  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent): Fix crash in 2006-03-24 change.

2006-05-13  Eli Zaretskii  <eliz@gnu.org>

	* frame.c (x_set_border_width): Fix error message to say "frame",
	not "window".

	* Makefile.in (SOME_MACHINE_LISP): Add fringe.elc.

2006-05-12  Chong Yidong  <cyd@stupidchicken.com>

	* intervals.c (set_point_both): Fix mixup before before and after
	in variable names.

	* editfns.c (Fline_beginning_position): Inhibit point-motion hooks
	while setting point temporarily.

2006-05-11  Richard Stallman  <rms@gnu.org>

	* lread.c (readevalloop): Abort if START non-nil for non-buffer input.

2006-05-11  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_tool_bar): Handle large tool-bar-border values.

2006-05-11  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): Fix for the case of IO error
	while handling replace operation.

2006-05-10  Kenichi Handa  <handa@m17n.org>

	* xfaces.c (realize_default_face) [HAVE_X_WINDOWS]: If the font
	chosen for the default face was different from the frame font,
	adjust the frame font.

2006-05-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (Qduration) [MAC_OS]: Undo previous change.
	(syms_of_image) [MAC_OS]: Likewise.
	[MAC_OS] (gif_load): Emulate Graphic Control Extension block.

	* macfns.c (x_to_mac_color): Fix shift amount change.
	(mac_set_font) [USE_MAC_FONT_PANEL]: Use x_get_focus_frame.
	[USE_MAC_FONT_PANEL] (Fmac_set_font_panel_visibility): Doc fix.

	* macselect.c (Vmac_service_selection) [MAC_OSX]: Rename from
	Vmac_services_selection.  All uses changed.
	(mac_store_service_event): Rename from mac_store_services_event in
	extern and calls.

	* macterm.c (Qservice) [MAC_OSX]: Rename from Qservices.  All uses
	changed.
	[MAC_OSX] (mac_store_service_event): Rename from
	mac_store_services_event.  All callers changed.
	[USE_MAC_FONT_PANEL] (mac_set_font_info_for_selection): Add args
	FACE_ID and C.  All callers changed.
	(x_free_frame_resources) [USE_MAC_FONT_PANEL]: Call
	mac_set_font_info_for_selection when focus frame is destroyed.
	(XTread_socket): Revert to FrontNonFloatingWindow/FrontWindow.

	* macterm.h (mac_set_font_info_for_selection): Add 2nd and 3rd
	args in extern.

2006-05-09  Chong Yidong  <cyd@stupidchicken.com>

	* keymap.c (describe_map): Avoid generating duplicate entries if
	the shadowed binding has the same definition.

2006-05-09  Kenichi Handa  <handa@m17n.org>

	* keymap.c (push_key_description): Handle invalid character key.

2006-05-08  Kenichi Handa  <handa@m17n.org>

	* callproc.c (Fcall_process): Use system_eol_type for encoding
	arguments if eol_type is not yet decided.

	* coding.h (system_eol_type): Extern it.

	* coding.c (setup_coding_system): For invalid coding-system, set
	coding->eol_type to CODING_EOL_UNDECIDED.
	(encode_coding): Cancel previous change.
	(shrink_encoding_region): Likewise.
	(code_convert_region1): Likewise.
	(code_convert_string1): Likewise.
	(code_convert_string_norecord): Likewise.

	* fileio.c (choose_write_coding_system): Use system_eol_type for
	encoding if eol_type is not yet decided.

	* process.c (setup_process_coding_systems): Use system_eol_type
	for encoding if eol_type is not yet decided.
	(read_process_output): Likewise.
	(send_process): Likewise.

2006-05-07  Juanma Barranquero  <lekktu@gmail.com>

	* minibuf.c (syms_of_minibuf) <history-length>: Fix typo in doc.

2006-05-07  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (Fmac_clear_font_name_table): Move defun to macfns.c.
	(syms_of_mac): Likewise for defsubr.

	* macfns.c (mac_set_font): New function.
	(mac_frame_parm_handlers, syms_of_macfns): Replace x_set_font with it.
	(mac_window) [TARGET_API_MAC_CARBON && MAC_OSX]: Specify
	kWindowToolbarButtonAttribute when creating window.
	(Fmac_clear_font_name_table): Move from macfns.c.
	(syms_of_macfns): Likewise for defsubr.
	[USE_MAC_FONT_PANEL] (Fmac_set_font_panel_visibility): New defun.
	(syms_of_macfns) [USE_MAC_FONT_PANEL]: Defsubr it.

	* macgui.h (USE_MAC_FONT_PANEL): Define to 1 if USE_ATSUI is set
	and build is done on Mac OS X 10.2 and later.

	* macselect.c (mac_do_receive_drag): Remove unused variable `index'.
	(mac_store_services_event): Change return type in extern.

	* macterm.c (XLoadQueryFont) [USE_ATSUI]: Set font->mac_fontnum to
	FMFontFamily value.
	[USE_MAC_FONT_PANEL] (mac_set_font_info_for_selection): New function.
	(x_new_focus_frame) [USE_MAC_FONT_PANEL]: Use it.
	(QCfamily, QCweight, QCslant, Qnormal, Qbold, Qitalic): Add extern.
	(QWindow) [MAC_OSX]: Likewise.
	(Qfont) [USE_MAC_FONT_PANEL]: Likewise.
	(Vmac_atsu_font_table) [USE_ATSUI]: New variable.
	(syms_of_macterm) [USE_ATSUI]: Defvar it.
	(Qtoolbar_switch_mode) [MAC_OSX]: New variable.
	(Qpanel_closed, Qselection) [USE_MAC_FONT_PANEL]: Likewise.
	(syms_of_macterm): Intern and staticpro them.
	(init_font_name_table) [USE_ATSUI]: Add data to Vmac_atsu_font_table.
	[TARGET_API_MAC_CARBON] (mac_store_event_ref_as_apple_event): New
	function.
	[USE_CARBON_EVENTS] (mac_handle_command_event): Use it.
	[MAC_OSX] (mac_store_services_event): Likewise.
	[USE_CARBON_EVENTS] (mac_handle_window_event) [MAC_OSX]: Handle
	kEventWindowToolbarSwitchMode event.
	(install_window_handler) [USE_CARBON_EVENTS && MAC_OSX]: Register it.
	[MAC_OSX] (mac_store_services_event): Change return type to OSStatus.
	[USE_MAC_FONT_PANEL] (mac_handle_font_event): New function.
	(install_window_handler) [USE_MAC_FONT_PANEL]: Install it.
	(XTread_socket): Select window on mouse click if x_focus_frame is NULL.

	* macterm.h (mac_set_font_info_for_selection): Add extern.

2006-05-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (Qduration) [MAC_OS]: New variable.
	(syms_of_image) [MAC_OS]: Intern and staticpro it.
	[MAC_OS] (gif_load): Save image extension data in img->data.lisp_val.
	[MAC_OSX] (image_load_quartz2d): Use cfstring_create_with_utf8_cstring
	instead of cfstring_create_with_string.

2006-05-06  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (xframe): Print frame name.
	(xlist): New command to print a list (max 10 elements).
	(xpr): Print lisp object of any type.
	(pitx): Print it->pixel_width.

2006-05-05  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (handle_composition_prop): Fix for the case of empty
	composition component.

2006-05-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (make_lispy_event) [MAC_OS]: Get Apple event info
	from event->arg.

	* termhooks.h (enum event_kind) [MAC_OS]: Update comment for
	MAC_APPLE_EVENT.

	* macterm.h (mac_make_lispy_event_code): Remove extern.
	(mac_post_mouse_moved_event): Add extern.
	(mac_aelist_to_lisp, mac_aedesc_to_lisp): Change arg 1 to
	`const AEDesc *' in externs.
	(create_apple_event_from_drag_ref) [TARGET_API_MAC_CARBON]: New extern.

	* mac.c (mac_aelist_to_lisp, mac_aedesc_to_lisp): Change arg 1 to
	`const AEDesc *'.
	[TARGET_API_MAC_CARBON] (create_apple_event): New function.
	[TARGET_API_MAC_CARBON] (create_apple_event_from_event_ref): Use it.
	Use xrealloc instead of repeated xmalloc/xfree.
	[TARGET_API_MAC_CARBON] (create_apple_event_from_drag_ref): New
	function.

	* macmenu.c (restore_menu_items, cleanup_popup_menu): Return a value.

	* macselect.c: Update copyright year.
	(mac_store_apple_event): Change return type to void in extern.
	(mac_handle_apple_event): Don't get return value from
	mac_store_apple_event.
	[TARGET_API_MAC_CARBON] (Vmac_dnd_known_types): New variable.
	(syms_of_macselect) [TARGET_API_MAC_CARBON]: Defvar it.
	[TARGET_API_MAC_CARBON] (mac_do_track_drag): Move function from
	macterm.c.  Use Vmac_dnd_known_types as acceptable flavors.
	[TARGET_API_MAC_CARBON] (mac_do_receive_drag): Likewise.  New
	implementation using create_apple_event_from_drag_ref.
	[TARGET_API_MAC_CARBON] (mac_do_track_dragUPP)
	(mac_do_receive_dragUPP): Move variables from macterm.c.
	(install_drag_handler, remove_drag_handler): New functions.

	* macterm.c (XTread_socket) [TARGET_API_MAC_CARBON]: Try window
	path select also for proxy icon click.
	[TARGET_API_MAC_CARBON] (mac_post_mouse_moved_event): New function.
	[USE_TOOLKIT_SCROLL_BARS] (scroll_bar_timer_callback): Use it.
	(xlfdpat_create): Remove unused label `error' and trailing sentences.
	(mac_do_track_drag, mac_do_receive_drag): Move functions to macselect.c.
	(mac_do_track_dragUPP, mac_do_receive_dragUPP): Move variables to
	macselect.c.
	(install_drag_handler, remove_drag_handler): Add extern.
	(mac_store_apple_event): Change return type to void.  All uses changed.
	Create Lisp object from Apple event and store it into input event.
	(mac_make_lispy_event_code): Remove function.
	[TARGET_API_MAC_CARBON] (mac_store_drag_event): New function.
	(install_window_handler): Call install_drag_handler.
	(remove_window_handler): Call remove_drag_handler.

2006-05-03  Richard Stallman  <rms@gnu.org>

	* sound.c (Fplay_sound_internal): Dynamically allocate
	current_sound_device and current_sound.
	(sound_cleanup): Free them.

	* minibuf.c (read_minibuf): Don't use read_minibuf_noninteractive
	when inside a keyboard macro.

2006-05-02  Andreas Schwab  <schwab@suse.de>

	* xmenu.c (restore_menu_items): Return a value.

2006-05-01  Martin Rudalics  <rudalics@gmx.at>

	* syntax.c (Fforward_comment): Detect generic comment at beginning of
	buffer when moving backwards.

2006-05-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispnew.c (update_window): Don't set changed_p when mode/header
	line is updated.

	* xdisp.c (prepare_menu_bars) [MAC_OS]: Call mac_update_title_bar.
	(get_glyph_face_and_encoding, get_char_face_and_encoding):
	Don't distinguish known faces from others.

	* mac.c (mac_coerce_file_name_ptr): Try typeFSRef if coercion
	through typeFileURL failed.

	* macfns.c (mac_update_title_bar): New function.
	[TARGET_API_MAC_CARBON] (mac_update_proxy_icon): New function.
	(show_hourglass, hide_hourglass) [USE_CG_DRAWING]:
	Call mac_prepare_for_quickdraw.

	* macgui.h (USE_ATSUI): Set default to 1 if MAC_OSX is defined.
	(USE_CG_DRAWING): Don't define if compiled on Mac OS X 10.1.
	(enum pcm_status): New enum.
	(XCHARSTRUCTROW_CHAR_VALID_P, XCHARSTRUCTROW_SET_CHAR_VALID)
	(XCharStructRow): Remove.  Now validity is represented by
	non-negativeness of sum of ascent and descent.
	(struct MacFontStruct): Change type of member `rows'.
	(struct _XGC) [USE_CG_DRAWING]: Add member `clip_rects'.

	* macterm.c (mac_draw_line, mac_draw_line_to_pixmap):
	Adjust endpoints of strictly horizontal/vertical lines.
	(mac_set_clip_rectangles) [USE_CG_DRAWING]: Set clip_rects.
	(pcm_init, pcm_get_status): New functions.
	(x_per_char_metric, XLoadQueryFont): Use them instead of
	XCharStructRow and related macros.
	(x_draw_relief_rect): Don't adjust arguments of mac_draw_line.
	(x_free_frame_resources) [TARGET_API_MAC_CARBON]: Free FRAME_FILE_NAME.
	(XTread_socket) [TARGET_API_MAC_CARBON]: Handle proxy icon drag
	and window path pop-up menu on title bar.
	(mac_use_core_graphics) [USE_CG_DRAWING]: Set default to 1.

	* macterm.h (mac_update_title_bar): Add extern.
	(struct mac_output) [TARGET_API_MAC_CARBON]: New member `file_name'.
	(FRAME_FILE_NAME): New macro.

	* unexmacosx.c (unexec): Error if trying unexec from dumped executable.

2006-04-30  Richard Stallman  <rms@gnu.org>

	* keymap.c (Fdefine_key): Improve error message
	when KEY begins with a non-prefix key.

2006-04-30  Martin Rudalics  <rudalics@gmx.at>

	* syntax.c (Fforward_comment): Don't forget to break out of the loop
	when we skipped backward over a generic comment.

2006-04-27  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit (pp1, pv1): Only print value as expression is now
	printed out by gud-print.
	(pv1): Correct doc string.

2006-04-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (store_in_keymap): Change `def' arg to not be `register'.
	Seems to trigger a bug in gcc-amd64 4.0.2 20051125 (Red Hat 4.0.2-8):
	keymap.c:895: error: address of register variable `def' requested.

2006-04-26  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (construct_mouse_wheel): Handle negative coordinates.

	* w32fns.c (w32_wnd_proc) <WM_LBUTTONDOWN, WM_RBUTTONDOWN>:
	<WM_LBUTTONUP, WM_RBUTTONUP>: Call signal_user_input in the cases
	where we preempt mouse_button_timer.

2006-04-25  Miles Bader  <miles@gnu.org>

	* editfns.c (Ffield_beginning, find_field): Undo change of 2006-04-23.

2006-04-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.h: Include headers for pid_t.

2006-04-24  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (fill_stretch_glyph_string): Set s->nchars = 1 for code which
	does last_glyph=s->first_glyph+s->nchars-1, e.g. if stretch has relief.
	(produce_stretch_glyph): Assume that face box height and width is
	already	included in stretch glyph size so caller doesn't have to
	consider the extra space otherwise added (fixes problem in ses.el).

	* frame.c (x_set_font): Clear f->n_tool_bar_rows and current frame
	matrices to force recalculation of tool-bar height after font change.

	* xdisp.c (tool_bar_lines_needed): New local `temp_row' for clarity.
	Clear it when done, so we don't accidentally draw a second copy of
	the tool-bar after resetting f->n_tool_bar_rows.
	(redisplay_tool_bar): Update tool-bar-lines frame parameter whenever
	we recalculate f->n_tool_bar_rows.

2006-04-23  Lars Hansen  <larsh@soem.dk>

	* editfns.c (find_field): Fix comment.
	(Ffield_beginning): Fix bug when POS is at field beginning.

2006-04-22  Eli Zaretskii  <eliz@gnu.org>

	* puresize.h (BASE_PURESIZE): Increase to 1205000.

2006-04-21  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): Fix last change.  Don't recenter if
	window start is at BEGV.

	* dispextern.h (struct image): New member `corners'.
	(TOP_CORNER, LEFT_CORNER, BOT_CORNER, RIGHT_CORNER): New macros.

	* image.c (four_corners_best): New arg CORNERS specifies what pixels
	to look at in case image has margin.
	(x_create_bitmap_mask): Pass NULL for CORNERS to four_corners_best.
	(image_background, image_background_transparent)
	(x_build_heuristic_mask): Pass img->corners to four_corners_best.
	(gif_load): Set img->corners according to image's margin spec.
	Use img->corners values directly where applicable.
	Save image extension data in img->data.lisp_val.
	(gif_clear_image): New function to free img->data.lisp_val.
	(gif_type): Use it instead of generic x_clear_image.
	(Fimage_extension_data): New defun.
	(syms_of_image): Defsubr it.

2006-04-21  John Sullivan  <john@wjsullivan.net>  (tiny change)

	* window.c (Fdisplay_buffer): Doc fix.

2006-04-21  Eli Zaretskii  <eliz@gnu.org>

	* s/ms-w32.h (SYSTEM_PURESIZE_EXTRA): Increase to 25000.

2006-04-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (xpm_load_image): Fill in background field
	while we have ximg handy.

	* macmenu.c (restore_menu_items, save_menu_items): New functions
	from xmenu.c.
	(set_frame_menubar, digest_single_submenu): Apply 2006-04-18
	changes for xmenu.c.

	* macterm.c (x_per_char_metric): Return NULL if glyph width is 0.
	(add_mac_font_name): New function.
	(init_font_name_table): Use it.  Adopt the first found font from
	those having the same family name.

2006-04-21  Nick Roberts  <nickrob@snap.net.nz>

	* xdisp.c (note_mouse_highlight): Use build_string.

2006-04-20  Lars Hansen  <larsh@soem.dk>

	* textprop.c (Fremove_list_of_text_properties):
	Ensure modify_region is called only when buffer is modified and that
	signal_after_change is allways called in that case.

	* print.c (PRINTFINISH): Call signal_after_change.

2006-04-20  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (redisplay_window): Fix last change.

	* xdisp.c (redisplay_window): If current window start is not at	the
	beginning of a line, select a new window start if buffer is modified
	and window start is in the modified region, but the first change is
	before window start.

2006-04-18  Richard Stallman  <rms@gnu.org>

	* xmenu.c (restore_menu_items, save_menu_items): New fns.
	(set_frame_menubar): Use save_menu_items.  Save updated vector in
	the frame before unwinding it.  Don't use unuse_menu_items.
	Don't use discard_menu_items.
	(digest_single_submenu): Abort if an item is not in a pane.
	(init_menu_items): Put the error check at the top.

	* keymap.c (describe_map): Make "shadowed" warning more verbose.

	* window.c (adjust_window_trailing_edge): Correctly distinguish
	series vs parallel cases, even when window has no parent.

	* abbrev.c (record_symbol): New function.
	(Finsert_abbrev_table_description): Sort the abbrevs alphabetically.

2006-04-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (x_create_bitmap_from_data) [MAC_OS]: Don't check return
	value of xmalloc.

	* mac.c (mac_coerce_file_name_ptr, mac_coerce_file_name_desc)
	(create_apple_event_from_event_ref, xrm_get_preference_database)
	(cfstring_create_normalized): Don't check return value of xmalloc.

	* macselect.c (get_scrap_target_type_list, defer_apple_events)
	(copy_scrap_flavor_data, mac_handle_service_event): Don't check
	return value of xmalloc/xrealloc.

	* macterm.c (XCreateGC, x_per_char_metric, xlfdpat_create)
	(init_font_name_table, init_font_name_table, mac_do_list_fonts)
	(XLoadQueryFont, mac_store_apple_event): Don't check return value
	of xmalloc.

2006-04-17  Kim F. Storm  <storm@cua.dk>

	* window.c (coordinates_in_window): On the vertical border,
	calculate the row number measured from the top of the window, not
	the top of the frame.
	(window_loop): Test w->dedicated with !NILP instead of EQ Qt.
	(window_scroll_pixel_based): Fix off-by-one bug in 2002-12-23 change.

2006-04-16  Eli Zaretskii  <eliz@gnu.org>

	* s/ms-w32.h (SYSTEM_PURESIZE_EXTRA): Reduce to 24000.

2006-04-16  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Decrement back to 1200000.

2006-04-16  Andreas Schwab  <schwab@suse.de>

	* puresize.h (PURESIZE_RATIO): Reduce to 10/6.

2006-04-15  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Increment to 1210000.

2006-04-13  Micha,Ak(Bl Cadilhac  <michael.cadilhac@lrde.org>

	* print.c (Fprin1_to_string): Mention in the `doc' that the
	behavior is modified by `print-level' and `print-length'.

2006-04-13  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): If eol-type is not yet decided
	and system_eol_type is not LF, set CODING_REQUIRE_ENCODING_MASK.
	If coding_system is nil, return 0.
	(code_convert_region1): Even if coding_system is nil, don't skip
	conversion if system_eol_type is not LF.
	(code_convert_string1): Likewise.
	(code_convert_string_norecord): Likewise.

2006-04-13  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): Fix previous change.
	(encode_coding): If eol_type is not yet decided, use system_eol_type.
	(shrink_encoding_region): If eol_type is not yet decided and
	system_eol_type is not LF, don't shrink.

2006-04-13  Nick Roberts  <nickrob@snap.net.nz>

	* xdisp.c (note_mouse_highlight): Add help echo for dragging vertical
	line.

2006-04-12  Richard Stallman  <rms@gnu.org>

	* keyboard.c (read_key_sequence): Explicitly avoid keybuf[-1].

	* process.c (conv_lisp_to_sockaddr): If FAMILY unknown, just return.
	(Fprocess_send_eof): Abort if fail to open null device.

2006-04-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* fns.c [HAVE_MENUS && MAC_OS]: Include macterm.h.

	* image.c [MAC_OS] (xpm_load_image): Add parentheses around
	assignment used as truth value.  Add explicit braces to avoid
	ambiguous `else'.
	[MAC_OS] (gif_load): Remove unused variable `gcpro1'.

	* lisp.h (syms_of_fontset, Fset_fontset_font): Put extern and
	EXFUN in #ifdef HAVE_WINDOW_SYSTEM.
	(syms_of_xfns, syms_of_xsmfns, syms_of_xselect, syms_of_xterm):
	Put externs in #ifdef HAVE_X_WINDOWS.
	(syms_of_macfns, syms_of_macselect, syms_of_macterm)
	(syms_of_macmenu, syms_of_mac) [MAC_OS]: Add externs.
	(init_mac_osx_environment) [MAC_OSX]: Add extern.

	* mac.c (init_process): Remove undef.
	(select) [MAC_OSX]: Undefine before including sysselect.h.
	(posix_pathname_to_fsspec, fsspec_to_posix_pathname) [MAC_OSX]:
	Remove functions and prototypes.
	(parse_value): Add parentheses around + inside shift.
	(path_from_vol_dir_name): Make static.
	(get_temp_dir_name): Remove unused variables `cpb' and `dir_name'.
	[!MAC_OSX] (get_path_to_system_folder): Likewise.
	(Fmac_get_file_creator, Fmac_get_file_type): Remove unused
	variable `cCode'.
	(Fmac_coerce_ae_data): Remove unused variables `fref' and `fs'.
	(Fmac_get_preference): Add explicit braces to avoid ambiguous `else'.

	* macfns.c (x_to_mac_color): Remove unused variable `tail'.
	(x_set_mouse_color): Remove unused variable `dpy'.
	(Fx_create_frame): Remove unused variable `x_frame_count'.
	(Fx_server_version): Add explicit braces to avoid ambiguous `else'.
	(x_sync): Move from macterm.c.
	(Fx_file_dialog): Remove unused variable `default_filter_index'.

	* macmenu.c (min_menu_id): Make element type explicit.

	* macselect.c (get_flavor_type_from_symbol): Remove unused
	variable `val'.
	(get_scrap_private_timestamp, x_get_foreign_selection)
	(copy_scrap_flavor_data): Add explicit braces to avoid ambiguous `else'.
	(Fmac_process_deferred_apple_events): Remove unused variables
	`keyword', `reply', `apple_event', `count', and `err'.

	* macterm.c: Don't include gnu.h.
	(x_io_error_quitter, x_draw_image_foreground_1): Remove prototypes.
	(x_sync): Move to macfns.c.
	[USE_CG_DRAWING] (mac_define_fringe_bitmap): Remove unused
	variable `mask_bits'.
	(mac_compute_glyph_string_overhangs): Avoid ambiguous `else'.
	(x_draw_image_glyph_string): Remove unused variable `pixmap'.
	(x_mac_to_emacs_modifiers): Remove function.
	(XTset_vertical_scroll_bar, mac_handle_visibility_change)
	(x_make_frame_visible, xlfdpat_create, mac_handle_command_event):
	Add explicit braces to avoid ambiguous `else'.
	(x_make_frame_visible): Remove unused variables `type',
	`original_top', and `original_left'.
	(mac_do_list_fonts, XTread_socket): Add parentheses around && within ||.
	(x_load_font): Remove unused variables `full_name', and `value'.
	(do_get_menus, do_init_managers, do_check_ram_size) [!MAC_OS8]:
	Remove functions.
	(do_zoom_window): Reorganize variables with respect to conditionals.
	(init_command_handler): Remove unused variable `err'.
	[MAC_OSX] (mac_check_bundle): Remove unused variable `child'.

	* macterm.h (x_set_mouse_position, x_set_mouse_pixel_position)
	(x_make_frame_invisible, x_iconify_frame, x_free_frame_resources)
	(x_destroy_window, x_wm_set_size_hint, x_delete_display, XFreeGC)
	(do_menu_choice, have_menus_p, x_real_positions)
	(x_set_menu_bar_lines, x_pixel_width, x_pixel_height, x_char_width)
	(x_char_height, x_sync, x_set_tool_bar_lines, x_activate_menubar)
	(free_frame_menubar): Add externs.

	* unexmacosx.c: Include config.h before using HAVE_MALLOC_MALLOC_H.
	(malloc, realloc, free): Add undefs.
	(read_load_commands): Remove unused variable `n' and `j'.
	(copy_data_segment): Remove unused variable `r'.

	* xdisp.c (get_glyph_string_clip_rects): Add parentheses around &&
	within ||.  Add explicit braces to avoid ambiguous `else'.
	(dump_glyph_row): Remove label for `inverse_p' from legend.

	* xfaces.c (Finternal_merge_in_global_face, try_font_list):
	Add explicit braces to avoid ambiguous `else'.

2006-04-11  Micha,Ak(Bl Cadilhac  <michael.cadilhac@lrde.org>

	* dispnew.c (init_display): Don't init X display if the user asked
	for a non-X display.

2006-04-12  Kenichi Handa  <handa@m17n.org>

	* coding.c (setup_coding_system): Use system_eol_type for default
	coding->eol_type.

2006-04-11  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (wrong_type_argument): Mark as NO_RETURN.

	* data.c (wrong_type_argument): Try to avoid compiler warnings due
	to the fact the function is now marked as NO_RETURN.

2006-04-10  Eli Zaretskii  <eliz@gnu.org>

	* s/ms-w32.h (pid_t) [_MSC_VER]: New typedef.

2006-04-10  Romain Francoise  <romain@orebokech.com>

	* xrdb.c (gethomedir): Use xstrdup.

2006-04-10  Andreas Schwab  <schwab@suse.de>

	* xrdb.c (gethomedir): Make sure to always return a pointer that
	can be passed to free.

2006-04-09  Richard Stallman  <rms@gnu.org>

	* lisp.h (Fkill_emacs): Undo previous change.

2006-04-08  Richard Stallman  <rms@gnu.org>

	* search.c (boyer_moore): Test ch >= 0400, not >.

2006-04-09  Dan Nicolaescu  <dann@ics.uci.edu>

	* puresize.h (pure_write_error): Mark as NO_RETURN.

	* lisp.h (args_out_of_range, args_out_of_range_3)

2006-04-08  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_wnd_proc) <WM_MOUSEMOVE>: Ignore mouse movements
	if a menu is active on this frame.

2006-04-08  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (report_file_error): Mark as NO_RETURN.

2006-04-08  Eli Zaretskii  <eliz@gnu.org>

	* alloc.c [STDC_HEADERS]: Include stddef.h.

	* lisp.h (PSEUDOVECSIZE): Fix last change.

2006-04-08  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.h (struct Lisp_Process): Replace Lisp_Objects `pid',
	`raw_status_high', and `raw_status_low' with plain integers, and move
	them to the end of the structure.

	* alloc.c (allocate_process): Use PSEUDOVECSIZE to initialize the
	pseudovector's size field so only the Lisp_Object fields get GC'd.

	* process.c (update_status, make_process, Fdelete_process)
	(Fprocess_status, list_processes_1, start_process_unwind)
	(create_process, Fmake_network_process, server_accept_connection)
	(wait_reading_process_output, send_process, Fprocess_running_child_p)
	(process_send_signal, proc_encode_coding_system, Fprocess_send_eof)
	(sigchld_handler, status_notify): Adjust to new non-Lisp fields for
	`pid' and `raw_status'.
	(Fprocess_id, Fsignal_process): Same, and additionally use floats when
	representing PIDs that are larger than most-positive-fixnum.

	* keymap.c (describe_map): Only use XINT if we checked INTEGERP.

	* lisp.h (OFFSETOF, PSEUDOVECSIZE): New macros.

2006-04-08  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (Fx_show_tip): Add 3 to the 5th arg of SetWindowPos.

2006-04-03  Paul Eggert  <eggert@cs.ucla.edu>

	* editfns.c (TM_YEAR_IN_ASCTIME_RANGE): New macro, identical to
	../lib-src/b2m.c and ../lib-src/editfns.c.
	(Fcurrent_time_string): Use it.
	Document that the year might not consume 4 columns if it's outside
	the range 1000-9999.
	Check for asctime failure.
	Don't assume that the output string length is always exactly 24.

2006-04-03  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (XTread_socket): Initialize variable `f' before its use.

2006-04-03  Kenichi Handa  <handa@m17n.org>

	* image.c: Include "charset.h" and "coding.h".
	(x_find_image_file): Return an encoded file name.

2006-04-01  Eli Zaretskii  <eliz@gnu.org>

	* configure: Regenerated.

2006-03-31  Kenichi Handa  <handa@m17n.org>

	* xfns.c (xg_set_icon): Delete superfluous UNGCPRO.

2006-03-30  Dan Nicolaescu  <dann@ics.uci.edu>

	* xdisp.c (syms_of_xdisp): Fix variable name.

2006-03-30  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_term_init): Delete superfluous UNGCPRO.

2006-03-29  Juanma Barranquero  <lekktu@gmail.com>

	* keyboard.c (process_tool_bar_item): Reorder dummy args.

2006-03-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keyboard.c (tool_bar_items): Use map_keymap.
	(process_tool_bar_item): Add dummy args to fit the required interface.

2006-03-25  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit (pr, pp, pp1, pv, pv1): Force print_output_debug_flag
	to zero before calling debug_print or safe_debug_print.

	* print.c (print_output_debug_flag): New global variable.
	(Fexternal_debugging_output) [WINDOWSNT]: Don't call
	OutputDebugString if print_output_debug_flag is zero.

2006-03-24  Paul Eggert  <eggert@cs.ucla.edu>

	* editfns.c (TM_YEAR_BASE): Move up, so the changes below can use it.
	(Fdecode_time, Fencode_time): Use TM_YEAR_BASE instead of 1900.
	(Fdecode_time): Cast tm_year to EMACS_INT.
	(Fcurrent_time_string): Report an invalid time specification if
	the argument is invalid.  Also, check for out-of-range time stamps.

2006-03-24  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent):
	* w32term.c (w32_read_socket):
	* macterm.c (XTread_socket): Don't let key-press clear mouse face
	on in toolbar window if mouse-highlight is an integer.

	* fns.c (sxhash_list): Include last non-nil CDR in hash.

2006-03-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (enum mac_menu_kind): New enum.
	(min_menu_id): New variable.
	(POPUP_SUBMENU_ID, MIN_POPUP_SUBMENU_ID, MIN_MENU_ID)
	(MIN_SUBMENU_ID): Remove defines.  All uses are replaced with
	min_menu_id and enumerators in enum mac_menu_kind.
	(fill_menu, dispose_menus, install_menu_quit_handler): New arg KIND.
	All uses changed.  Add range check for menu ID.
	(fill_menubar): Add range check for menu ID.
	[HAVE_CANCELMENUTRACKING] (menu_quit_handler): Check error code of
	GetEventParameter.
	(set_frame_menubar, mac_menu_show): Call install_menu_quit_handler
	for each menu kind.

2006-03-22  Kim F. Storm  <storm@cua.dk>

	* xdisp.c: Undo 2006-03-21 change.

	* term.c: Define aliases for append_glyph and produce_stretch_glyph
	when `static' is defined to avoid name clash with those in xdisp.c.

	* process.c (Faccept_process_output): Fix to comply with lisp
	reference.  Change arg "timeout" to "seconds" and allow both
	integer and float value.  Change arg "timeout-msec" to "millisec"
	and interpret" as milliseconds rather than microseconds.  Fix doc
	string accordingly.

2006-03-21  Ken Raeburn  <raeburn@raeburn.org>

	* xdisp.c (store_next_glyph): Rename from append_glyph.
	(generate_stretch_glyph): Rename from produce_stretch_glyph.
	All callers changed accordingly.

2006-03-21  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c: x_session_initialized new variable.
	(x_term_init): Use x_session_initialized to check if
	x_session_initialize should be called.
	(x_initialize): Initialize x_session_initialized.

2006-03-21  Kim F. Storm  <storm@cua.dk>

	* fringe.c (draw_fringe_bitmap): Don't calculate default overlay arrow
	bitmap here, but ...
	(update_window_fringes): ... here, so we can test if it has changed.

2006-03-20  Andreas Schwab  <schwab@suse.de>

	* dispnew.c (init_display): Check DISPLAY here.

	* emacs.c (main): Don't check here.

	* xterm.c (x_display_ok): Don't use DISPLAY env var.

2006-03-20  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (window_scroll_pixel_based): Yet another int/Lisp_Object
	mixup (YAILOM).

2006-03-20  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (main): Fix last change.

2006-03-20  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Fwrite_region): Set visit_file to Qnil before GCPRO it.

	* keymap.c (map_keymap): Set tail to Qnil before GCPRO it.

	* xfns.c (xg_set_icon): Remove unnecessary GCPRO.

	* xterm.c (x_term_init): Remove unnecessary GCPRO.

2006-03-19  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (set_cursor_from_row): Fix cursor property on overlay	string,
	so it doesn't associate overlay string with following glyph by default.
	Allow integer property value to specify explicit number of buffer
	positions associate with overlay string.

2006-03-18  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.c (x_display_ok): Fix minor bug and compilation warnings.

2006-03-18  Nozomu Ando  <nand@mac.com>

	* m/pmax.h (BROKEN_NOCOMBRELOC) [__NetBSD__]: Define.
	(LIB_STANDARD, START_FILES) [__NetBSD__]: Don't define.
	(START_FILES, RUN_TIME_REMAP, UNEXEC) [__NetBSD__, __OpenBSD__]:
	Don't redefine.

	* m/mips.h: Don't use unexmips on NetBSD.
	(LIBS_MACHINE): Move definition lower, so it doesn't use
	LD_SWITCH_MACHINE, START_FILES, LIB_STANDARD, LIBS_TERMCAP,
	C_SWITCH_MACHINE, and C_DEBUG_SWITCH.

	* unexelf.c [BROKEN_NOCOMBRELOC]: Include assert.h.
	(unexec) [BROKEN_NOCOMBRELOC]: Handle platforms whose nocombreloc
	option is broken (e.g., MIPS/NetBSD).

2006-03-18  Craig McDaniel  <craigmcd@gmail.com>  (tiny change)

	* sheap.c (STATIC_HEAP_SIZE): Enlarge STATIC_HEAP_SIZE to 12MB.
	Remove the HAVE_X_WINDOWS conditional.

2006-03-18  Vivek Dasmohapatra  <vivek@etla.org>  (tiny change)

	* emacs.c (main): If user asks for a display that is unavailable,
	simulate -nw.

	* xterm.c (x_display_ok): New function.

	* xterm.h: Add prototype for x_display_ok.

2006-03-18  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (Fw32_select_font): Doc fix.

2006-03-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (XPutPixel, XGetPixel)
	[!WORDS_BIG_ENDIAN && USE_CG_DRAWING]: Don't use specialized
	version when depth is 32.
	(mac_create_cg_image_from_image) [MAC_OS && USE_CG_DRAWING]:
	New function.
	(prepare_image_for_display) [MAC_OS && USE_CG_DRAWING]: Use it.
	(x_clear_image_1) [MAC_OS && USE_CG_DRAWING]: Release CGImage.

	* macterm.c (XCreatePixmap) [!WORDS_BIG_ENDIAN && USE_CG_DRAWING]:
	Create GWorld in ARGB pixel format.
	(mac_copy_area, mac_copy_area_with_mask) [USE_CG_DRAWING]:
	Remove functions.
	(x_draw_image_foreground) [USE_CG_DRAWING]: Use mac_draw_cg_image
	instead of mac_copy_area/mac_copy_area_with_mask.

2006-03-15  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (extend_face_to_end_of_line): Always add space glyph to
	empty row.  Fixes memory corruption revealed by 2006-03-02 change.
	(display_tool_bar_line): Skip empty tool-bar line if HEIGHT < 0.
	(tool_bar_lines_needed): Fix tool-bar display in case the tool-bar
	width is exactly the same as the window width.  Don't count a final
	empty tool-bar line (pass HEIGHT = -1 to display_tool_bar_line).

2006-03-15  Juanma Barranquero  <lekktu@gmail.com>

	* fringe.c (w32_init_fringe, w32_reset_fringes): Revert to being
	conditional on HAVE_NTGUI, not WINDOWS_NT.

2006-03-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispextern.h (mac_init_fringe) [MAC_OS]: Add prototype.

	* fringe.c (mac_init_fringe) [MAC_OS]: New function.

	* macterm.c (mac_initialize) [USE_CG_DRAWING]: Call mac_init_fringe.
	(max_fringe_bmp, fringe_bmp) [USE_CG_DRAWING]: New variables.
	(mac_define_fringe_bitmap, mac_destroy_fringe_bitmap)
	(mac_draw_cg_image) [USE_CG_DRAWING]: New functions.
	(mac_draw_bitmap) [USE_CG_DRAWING]: Remove function.
	(x_draw_fringe_bitmap) [USE_CG_DRAWING]: Use mac_draw_cg_image
	instead of mac_draw_bitmap.
	(x_redisplay_interface) [USE_CG_DRAWING]: Set handlers for
	define_fringe_bitmap and destroy_fringe_bitmap.

2006-03-14  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.c (x_uncatch_errors): Block input for entire function.

2006-03-12  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_create_frame): Remove call to
	Qface_set_after_frame_default (from xfns.c 2003-05-26).

	* w32menu.c (Fx_popup_menu): Call w32_free_menu_strings when
	finished with the menu.

	* w32term.c: Sync 2005-10-24 xterm.c changes.
	(last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(w32_mouse_position): Set last_mouse_glyph_frame.
	Remove OLD_REDISPLAY_CODE block.

2006-03-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h [USE_ATSUI && MAC_OSX]: Define USE_CG_TEXT_DRAWING to 1.

	* macterm.h (struct mac_output) [USE_CG_DRAWING]: New member cg_context.
	(mac_prepare_for_quickdraw) [USE_CG_DRAWING]: Add prototype.

	* mac.c (sys_select) [USE_CG_DRAWING]: Call mac_prepare_for_quickdraw.

	* macfns.c (x_create_tip_frame): Apply 2006-03-11 change for xfns.c.

	* macterm.c (mac_draw_rectangle, x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground)
	(x_draw_image_foreground): Undo previous changes.
	(x_draw_hollow_cursor): Likewise.  Subtract 1 from the last
	argument of mac_draw_rectangle.
	(CG_SET_FILL_COLOR, CG_SET_STROKE_COLOR): New macros.
	(mac_draw_string_common, mac_draw_image_string_cg): Use them.
	(FRAME_CG_CONTEXT) [USE_CG_DRAWING]: New macro.
	(mac_begin_cg_clip, mac_end_cg_clip, mac_prepare_for_quickdraw)
	[USE_CG_DRAWING]: New functions.
	(mac_draw_line, mac_erase_rectangle, mac_clear_window)
	(mac_fill_rectangle, mac_draw_rectangle, mac_draw_string_common)
	(mac_draw_image_string_cg) [USE_CG_DRAWING]: Add Quartz 2D drawing part.
	(mac_draw_bitmap, mac_invert_rectangle, mac_draw_string_common)
	(mac_copy_area, mac_scroll_area, x_scroll_bar_create)
	(x_scroll_bar_remove, XTset_vertical_scroll_bar, x_set_window_size)
	(XTread_socket) [USE_CG_DRAWING]: Call mac_prepare_for_quickdraw.

2006-03-12  L$,1 q(Brentey K,Aa(Broly  <lorentey@elte.hu>

	* xfns.c (x_icon): Disable redundant call to `x_wm_set_window_state'.

2006-03-11  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (signal_user_input): New function.
	(post_character_message): Use it for keyboard input.
	(w32_msg_pump): Use it for mouse input.

2006-03-11  Luc Teirlinck  <teirllm@auburn.edu>

	* window.c: Rename preserve_y to window_scroll_pixel_based_preserve_y.
	(window_scroll_pixel_based, syms_of_window): Adapt to above change.

2006-03-11  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_wnd_proc): Ignore middle and extra button events
	if a menu is already active (the menubar_active flag is on).

2006-03-11  David Ponce  <david@dponce.com>

	* xfns.c (x_create_tip_frame): Preserve received parms by copying them.

2006-03-11  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c: Add x_fully_uncatch_errors and x_catching_errors to
	the list of unused display error handling functions.

	* eval.c (unwind_to_catch): Call x_fully_uncatch_errors only if
	HAVE_X_WINDOWS.
	(internal_condition_case, internal_condition_case_1)
	(internal_condition_case_2): Call x_catching_errors only if
	HAVE_X_WINDOWS.

	* vm-limit.c [HAVE_GETRLIMIT]: Don't define unconditionally.
	Don't include sys/resource.h unless defined.

2006-03-11  Richard Stallman  <rms@gnu.org>

	* keymap.c (describe_map): Shorten string to indicate shadowed binding.

	* vm-limit.c (get_lim_data, lim_data, data_space_start):
	Move from mem-limits.h.
	(enum warnlevel): New data type.
	(check_memory_limits): Rewrite the logic about warnings.
	Use standard `struct rlimit'.  Check return values for nonsense.
	(memory_warnings): Always clear lim_data.

	* mem-limits.h (get_lim_data, lim_data, data_space_start):
	Move to vm-limit.c.

	* xterm.c (x_fully_uncatch_errors, x_catching_errors): New functions.

	* eval.c (unwind_to_catch): Call x_fully_uncatch_errors.
	(internal_condition_case_1, internal_condition_case_2):
	Abort if within unclosed x_catch_errors.

2006-03-11  Romain Francoise  <romain@orebokech.com>

	* process.c (Vprocess_adaptive_read_buffering): Doc fix.

2006-03-11  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* lisp.h: Remove duplicate prototypes.  Make the prototype of
	getloadavg be conditioned on HAVE_GETLOADAVG being undefined.

2006-03-11  Eli Zaretskii  <eliz@gnu.org>

	* xterm.c (x_draw_hollow_cursor): Subtract 1 from the last
	argument of XDrawRectangle.

	* xdisp.c (get_phys_cursor_geometry): Don't decrease height by 1.

	* macterm.c (mac_draw_rectangle): Don't add 1 to width and height.
	(x_draw_glyph_string_foreground)
	(x_draw_composite_glyph_string_foreground)
	(x_draw_image_foreground): Don't subtract 1 from width and height
	arguments to mac_draw_rectangle.
	(x_draw_hollow_cursor): Add 1 to w->phys_cursor_width.

2006-03-10  Kim F. Storm  <storm@cua.dk>

	* alloc.c (USE_POSIX_MEMALIGN): Fix last change.

2006-03-09  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (USE_POSIX_MEMALIGN): New macro.
	(ABLOCKS_BASE, lisp_align_malloc, lisp_align_free): Use it.

2006-03-09  Kenichi Handa  <handa@m17n.org>

	* coding.c (DECODE_EMACS_MULE_COMPOSITION_CHAR): Fix decoding
	ASCII component of a composition.

2006-03-08  Luc Teirlinck  <teirllm@auburn.edu>

	* window.c: Declare preserve_y as a static global variable.
	(window_scroll_pixel_based): No longer declare preserve_y;
	it is global now.
	(syms_of_window): Set preserve_y to -1.

2006-03-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (XPutPixel): Set alpha channel bits if pixmap
	depth is 32.
	[MAC_OS] (XGetPixel): Strip off alpha channel bits if pixmap
	depth is 32.

2006-03-06  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (handle_invisible_prop): Don't update it->position with
	a buffer position if we're in a display string.

2006-03-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.h (MAC_AQUA_VERTICAL_SCROLL_BAR_WIDTH)
	(MAC_AQUA_SMALL_VERTICAL_SCROLL_BAR_WIDTH): New defines.

	* macfns.c (x_default_scroll_bar_color_parameter)
	(x_set_scroll_bar_foreground, x_set_scroll_bar_background):
	Remove unnecessary prototypes.
	(x_set_scroll_bar_default_width):
	Use MAC_AQUA_VERTICAL_SCROLL_BAR_WIDTH.
	(mac_set_scroll_bar_width): New function.
	(mac_frame_parm_handlers): Set it as handler for scroll-bar-width.

	* macterm.c (get_control_part_bounds): Fix type of return value.
	(x_set_toolkit_scroll_bar_thumb, x_scroll_bar_create)
	(XTset_vertical_scroll_bar) [USE_TOOLKIT_SCROLL_BARS]: Don't show
	scroll bar if it is not tall enough to display scroll bar thumb.
	[USE_CARBON_EVENTS] (mac_convert_event_ref)
	(mac_handle_command_event, mac_handle_window_event)
	(mac_handle_mouse_event): Check error code of GetEventParameter.
	(convert_fn_keycode) [MAC_OSX]: Likewise.

2006-03-05  Andreas Schwab  <schwab@suse.de>

	* xselect.c (x_catch_errors_unwind): Fix missing return value.

2006-03-02  Kim F. Storm  <storm@cua.dk>

	* frame.h (struct frame): New member n_tool_bar_rows.

	* xdisp.c: Minimize the unpleasent visual impact of the requirement
	that non-toolkit tool-bars must occupy an integral number of screen
	lines, by distributing the rows evenly over the tool-bar screen area.
	(Vtool_bar_border): New variable.
	(syms_of_xdisp): DEFVAR_LISP it.
	(display_tool_bar_line): Add HEIGHT arg for desired row height.
	Make tool-bar row the desired height.  Use default face for border
	below tool-bar.
	(tool_bar_lines_needed): Add N_ROWS arg.  Use it to return number of
	actual tool-bar rows.
	(redisplay_tool_bar): Calculate f->n_tool_bar_rows initially.
	Adjust the height of the tool-bar rows to fill tool-bar screen area.
	(redisplay_tool_bar): Calculate f->n_tool_bar_rows when tool-bar area
	is resized.

2006-03-01  Luc Teirlinck  <teirllm@auburn.edu>

	* search.c (Fregexp_quote): Do not precede a literal `]' with two
	backslashes to try to make clear that it has a literal meaning; it
	does not do that.  (It could close a character alternative
	containing a backslash.)

2006-02-28  Chong Yidong  <cyd@stupidchicken.com>

	* xselect.c (x_catch_errors_unwind): New function.
	(x_reply_selection_request): Put x_uncatch_errors in an unwind.
	(Fx_get_atom_name): Call x_uncatch_errors earlier.

	* window.c (Qscroll_up, Qscroll_down): New syms.
	(window_scroll_pixel_based): Make preserve_y static to avoid
	getting point stuck when scrolling 1 line.

2006-02-26  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.h, xterm.c (x_uncatch_errors): Delete unneccessary argument.

	* xterm.c (x_load_font, x_term_init, XTmouse_position)
	(handle_one_xevent, x_connection_closed, x_list_fonts):
	No arg for x_uncatch_errors.

	* xselect.c (x_own_selection, x_decline_selection_request)
	(x_reply_selection_request, x_get_foreign_selection)
	(Fx_get_atom_name, Fx_send_client_event): Likewise.

	* xfns.c (x_real_positions, x_set_mouse_color, Fx_focus_frame):
	Likewise.

2006-02-26  Luc Teirlinck  <teirllm@auburn.edu>

	* lread.c: Declare Vload_file_rep_suffixes instead of
	deleted variable default_suffixes.
	(Fget_load_suffixes): New function.
	(Fload): Use Fget_load_suffixes and Vload_file_rep_suffixes.
	No longer use deleted variable default_suffixes.  Update docstring.
	(syms_of_lread): defsubr Sget_load_suffixes.
	Expand `load-suffixes' docstring.
	Delete default_suffixes and DEFVAR_LISP the new variable
	`load-file-rep-suffixes'.

	* w32.c (check_windows_init_file): Use Fget_load_suffixes instead
	of Vload_suffixes.

	* lisp.h: EXFUN Fget_load_suffixes.
	Extern Vload_file_rep_suffixes.

	* eval.c (specpdl_ptr): Remove volatile qualifier for consistency
	with lisp.h.

2006-02-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp.h (struct specbinding, specpdl_ptr): Remove the volatile
	qualifier which was trying to avoid the bug that was fixed by
	yesterday's changes to xterm.c.

2006-02-25  Chong Yidong  <cyd@stupidchicken.com>

	* xterm.h (x_catch_errors) Return value changed to void.
	(x_uncatch_errors): Delete unused count argument.

	* xterm.c (x_catch_errors): Don't use record_unwind_protect, since
	it can be called in a signal handler.
	(x_catch_errors_unwind): Function deleted.
	(x_uncatch_errors): Deallocate last x_error_message_stack struct.
	(x_check_errors): Call x_uncatch_errors before signalling error.

	(x_load_font, x_term_init, XTmouse_position, handle_one_xevent)
	(x_connection_closed, x_list_fonts): Use new versions of
	x_catch_errors and x_uncatch_errors.

	* xselect.c (x_own_selection, x_decline_selection_request)
	(x_reply_selection_request, x_get_foreign_selection)
	(Fx_get_atom_name, Fx_send_client_event): Likewise.

	* xfns.c (x_real_positions, x_set_mouse_color, Fx_focus_frame):
	Likewise.

	* eval.c (record_unwind_protect): Add an assertion.

2006-02-25  Stefan Monnier  <monnier@iro.umontreal.ca>

	* process.c (Fmake_network_process): Init the process's mark.

2006-02-25  Kim F. Storm  <storm@cua.dk>

	* buffer.c (modify_overlay): Force redisplay if we modify an
	overlay at the end of the buffer.

2006-02-24  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_image_for_pixmap): If x_find_image_file returns
	nil the image file has been removed, in that case use the (cached)
	pixmap.

2006-02-24  Kenichi Handa  <handa@m17n.org>

	* fileio.c (Finsert_file_contents): When a text is replaced
	partially, be sure to set point before the inserted characters.

2006-02-23  Zhang Wei  <id.brep@gmail.com>  (tiny change)

	* xfns.c (Fx_file_dialog): Return a decoded file name.

2006-02-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispnew.c (update_text_area): Avoid needless redraw of rightmost
	glyph whose face is extended to the text area end.

	* macterm.c (x_set_toolkit_scroll_bar_thumb): Don't set control
	values if control is not visible or values are not changed.

2006-02-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fwindow_list): Check `window' before doing XWINDOW.
	The default `window' should not be "on a different frame".

2006-02-22  Kim F. Storm  <storm@cua.dk>

	* indent.c (Fvertical_motion): Only try to move back if we can.

2006-02-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (struct _XGC) [!MAC_OSX || !USE_ATSUI]: New member
	n_clip_rects.

	* macmenu.c (digest_single_submenu): Apply 2006-02-19 change for
	xmenu.c.

	* macterm.c (GC_CLIP_REGION): Remove macro.
	(mac_begin_clip, mac_end_clip): Take arg GC instead of REGION.
	All uses changed.  Don't do clipping if n_clip_rects is zero.
	(mac_set_clip_rectangles): Use xassert instead of abort.
	Set n_clip_rects.  Don't make clip_region empty when number of
	clipping rectangles is zero.
	(mac_reset_clip_rectangles): Set n_clip_rects directly instead of
	calling mac_set_clip_rectangles.
	(x_set_toolkit_scroll_bar_thumb): Temporarily hide scroll bar to
	avoid multiple redraws.

2006-02-22  Kim F. Storm  <storm@cua.dk>

	* fringe.c (draw_fringe_bitmap): Fix overlay-arrow display.

2006-02-21  Kim F. Storm  <storm@cua.dk>

	* fringe.c (syms_of_fringe) <fringe-bitmaps>: Doc fix.

2006-02-21  Zhang Wei  <brep@newsmth.org>

	* xfns.c (Fx_file_dialog, Motif and GTK): DECODE_FILE before
	returning it.

2006-02-21  Giorgos Keramidas  <keramida@ceid.upatras.gr>  (tiny change)

	* fringe.c (horizontal_bar_bits): Rename from `horisontal_bar_bits'.
	(standard_bitmaps): Use it.

2006-02-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_draw_string_common): Remove arg MODE.  New arg
	BG_WIDTH.  All uses changed.  Draw background if BG_WIDTH is not zero.
	(mac_draw_image_string, mac_draw_image_string_16): New arg BG_WIDTH.
	[USE_CG_TEXT_DRAWING] (mac_draw_image_string_cg): Rename from
	mac_draw_string_cg.  New arg BG_WIDTH.  All uses changed.
	Draw background if BG_WIDTH is not zero.  Use float constants as
	divisors instead of double.  Use alloca instead of xmalloc/xfree.
	(x_draw_glyph_string_background, x_draw_glyph_string_foreground)
	[!MAC_OS8 || USE_ATSUI]: Background may be drawn using
	mac_draw_image_string* functions.
	(XLoadQueryFont) [MAC_OS8 && USE_ATSUI]: Don't adjust heights of
	some fonts when srcCopy text transfer mode might be used.
	(mac_begin_clip, mac_end_clip): Check if region is empty.
	(mac_set_clip_rectangles): When resetting clip region, make it
	empty instead of disposing of it.

2006-02-20  Kim F. Storm  <storm@cua.dk>

	* Makefile.in: Add fringe.elc to WINDOW_SUPPORT.

	* buffer.h (struct buffer): New members fringe_indicator_alist and
	fringe_cursor_alist.

	* buffer.c (init_buffer_once): Set dummy default values for
	fringe-indicator-alist and fringe-cursor-alist.  The proper
	default values are set by pre-loading fringe.el.
	(syms_of_buffer): defvar_per_buffer new fringe-indicator-alist and
	fringe-cursor-alist buffer-local variables and defvar_lisp_nopro
	corresponding default- variables.

	* fringe.c (enum fringe_bitmap_type): Remove.  Change all uses
	to use `int'.
	(NO_FRINGE_BITMAP, UNDEF_FRINGE_BITMAP, MAX_STANDARD_FRINGE_BITMAPS):
	Define explicitly.
	(Qtruncation, Qcontinuation, Qempty_line, Qtop_bottom)
	(Qhollow_small): New variables.
	(syms_of_fringe): Intern and staticpro them.
	(question_mark_bits): Rename from unknown_bits.
	(left_curly_arrow_bits): Rename from continuation_bits.
	(right_curly_arrow_bits): Rename from continued_bits.
	(left_triangle_bits): Rename from ov_bits.
	(right_triangle_bits): Add.
	(filled_rectangle_bits): Rename from filled_box_cursor_bits.
	(hollow_rectangle_bits): Rename from hollow_box_cursor_bits.
	(filled_square_bits): Add.
	(vertical_bar_bits): Rename from bar_cursor_bits.
	(horizontal_bar_bits): Rename from hbar_cursor_bits.
	(empty_line_bits): Rename from zv_bits.
	(standard_bitmaps): Update to use new names.
	(draw_fringe_bitmap_1): Make static.
	(get_logical_cursor_bitmap, get_logical_fringe_bitmap): New functions
	to map from logical cursors and indicators to physical bitmaps.
	(draw_fringe_bitmap): Resolve fringe cursor and overlay-arrow
	bitmaps using symbol names instead of bitmap numbers.
	(update_window_fringes): Use logical indicator symbol names
	instead of bitmap numbers for logical.  Add bitmap cache.
	(LEFT_FRINGE, RIGHT_FRINGE): New helper macros.

2006-02-20  Chong Yidong  <cyd@stupidchicken.com>

	* regex.c: Revert 2006-02-19 change.
	(xmalloc, xrealloc): Define these when not linked to Emacs.
	Redefine malloc -> xmalloc, realloc -> xrealloc as in Emacs case.

2006-02-19  Luc Teirlinck  <teirllm@auburn.edu>

	* regex.c (extend_range_table_work_area): Fix typo.

2006-02-19  Richard M. Stallman  <rms@gnu.org>

	* xterm.c (x_catch_errors): Use xmalloc.

	* regex.c (extend_range_table_work_area): Call xmalloc and xrealloc.
	(regex_compile): Likewise.
	(regcomp): Use xmalloc.

	* gtkutil.c (malloc_widget_value): Use xmalloc.

	* vm-limit.c [HAVE_GETRLIMIT]: Include sys/resource.h.
	(check_memory_limits) [HAVE_GETRLIMIT]: Use getrlimit.

	* xmenu.c (digest_single_submenu): When pane_string is empty,
	do initialize save_wv.

2006-02-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (update_menu_bar) [MAC_OS]: Don't set
	w->update_mode_line if arg F is not the selected frame.

	* macmenu.c (popup_activated_flag, submenu_id)
	(next_menubar_widget_id): Remove variables.
	(initialize_frame_menubar): Remove function.
	(pop_down_menu, mac_menu_show): Simplify save value.
	(dispose_menus): New function.
	(pop_down_menu, fill_menubar): Use it.
	(fill_submenu): Remove function.  All uses changed to fill_menu.
	(add_menu_item): Remove args SUBMENU and FORCE_DISABLE.  New arg
	POS.  Don't call SetMenuItemHierarchicalID here.
	(fill_menu): Add arg SUBMENU_ID.  Return submenu_id that is to be
	used next.  Call SetMenuItemHierarchicalID here.
	(fill_menubar): Add arg DEEP_P.  All uses changed.  Clean up menu
	objects if needed.  Reuse existing menu bar titles if possible.
	(set_frame_menubar): Don't clean up menu objects here.

2006-02-18  Chong Yidong  <cyd@stupidchicken.com>

	* window.c (window_min_size_1): Ensure room for the scroll bar and
	fringes.

2006-02-17  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Increment to 1200000.

2006-02-17  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (Fmake_symbol): Comment-out left-over assert from before the
	addition of the BLOCK_INPUTs.

2006-02-17  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fset_window_scroll_bars): Doc fix.

2006-02-17  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (display_mode_element): Call display_string with correct
	PREC arg (which must be a number of characters, not column width).

2006-02-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* frame.c (x_get_arg): Clear out PARAM in ALIST also on Mac.

	* macfns.c (x_set_menu_bar_lines): Menu bar is always shown on Mac.

	* macmenu.c (set_frame_menubar): Don't call DrawMenuBar.

2006-02-14  Richard M. Stallman  <rms@gnu.org>

	* frame.c (x_get_arg): Clear out all occurrences of PARAM in ALIST.

	* m/ibms390x.h: New file.

2006-02-14  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_tool_bar_detach_callback): Set show-arrow to the
	value of x-gtk-whole-detached-tool-bar.
	(xg_tool_bar_attach_callback): Set show-arrow to TRUE.

	* xfns.c (syms_of_xfns): New variable: x-gtk-whole-detached-tool-bar.

2006-02-14  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (x_x_to_emacs_modifiers): Make non-static.

	* xterm.h: Declare x_x_to_emacs_modifiers.

	* gtkutil.c (xg_tool_bar_button_cb): New function.
	(xg_tool_bar_callback): Call x_x_to_emacs_modifiers to
	store modifiers in event.
	(update_frame_tool_bar): Connect button-release-event to
	xg_tool_bar_button_cb.

2006-02-13  Richard M. Stallman  <rms@gnu.org>

	* .gdbinit (xwindow): Update the code to show the window box.

2006-02-13  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (note_mouse_movement): Check for NULL FRAME_X_OUTPUT (frame).

2006-02-12  Richard M. Stallman  <rms@gnu.org>

	* cmds.c (internal_self_insert): Handle weird auto-fill-function.

2006-02-11  Eli Zaretskii  <eliz@gnu.org>

	* keyboard.c (Venable_disabled_menus_and_buttons): New variable.
	(syms_of_keyboard): DEVFAR_LISP and initialize it.
	(parse_tool_bar_item, parse_menu_item): If that variable is
	non-nil, don't disable menu items and tool-bar buttons.

2006-02-11  Juanma Barranquero  <lekktu@gmail.com>

	* doc.c (Fsubstitute_command_keys): Doc fix.

2006-02-10  Thien-Thi Nguyen  <ttn@gnu.org>

	* data.c (Findirect_function): Rewrite docstring.
	Fix omission bug: Declare new arg NOERROR.

2006-02-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_set_mouse_color): Don't call rif->define_frame_cursor
	if window_desc is not set yet.
	(Fx_create_frame): Remove variable x_frame_name.  Apply 2005-12-07
	and 2006-01-26 changes for xfns.c.  Call x_iconify_frame if frame
	parameter `visibility' is `icon'.
	(Fx_create_frame, x_create_tip_frame): Use "fontset-standard"
	instead of "fontset-mac".
	(Fx_focus_frame): New defun.
	(syms_of_macfns): Defsubr it.

	* macterm.c (mac_define_frame_cursor): Don't change pointer shape
	for unfocused frame.
	(x_raise_frame): Call BringToFront instead of SelectWindow.
	(x_lower_frame): Use NULL instead of nil.
	(x_make_frame_visible): Don't call SelectWindow.
	(XTread_socket): Increment handling_signal at the start, decrement
	it at the end.
	[USE_CG_TEXT_DRAWING] (init_cg_text_anti_aliasing_threshold): Use
	CFPreferencesGetAppIntegerValue instead of Fmac_get_preference.

2006-02-10  Kim F. Storm  <storm@cua.dk>

	* data.c (Findirect_function): Add NOERROR arg.  All callers changed
	to pass Qnil for NOERROR.

	* keymap.c (current_minor_maps_error): Remove.
	(current_minor_maps): Pass Qt for NOERROR to Findirect_function
	instead of using internal_condition_case_1+current_minor_maps_error.

2006-02-09  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): Must note mouse movement even for nil
	frames for GTK, in that case it is the tool bar.  This is so that
	highlighted text get reset properly.

2006-02-09  Juanma Barranquero  <lekktu@gmail.com>

	* alloc.c (Fmake_bool_vector, Fpurecopy): Doc fixes.

2006-02-08  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* window.c (adjust_window_trailing_edge): Check that shrinking
	does not set a window to size zero or less.

2006-02-08  Miles Bader  <miles@gnu.org>

	* editfns.c (Fconstrain_to_field): Use Fget_char_property instead
	of Fget_text_property (other field functions work with overlays as
	well as text-properties).

2006-02-07  Kenichi Handa  <handa@m17n.org>

	* dispextern.h (unibyte_display_via_language_environment): Extern it.

	* xterm.h (unibyte_display_via_language_environment):
	* w32term.h (unibyte_display_via_language_environment):
	* macterm.h (unibyte_display_via_language_environment): Delete extern.

2006-02-07  Kenichi Handa  <handa@m17n.org>

	* term.c (append_glyph): Refer to it->char_to_display instead of it->c.
	(produce_glyphs): Set the character to print in
	it->char_to_display.  Handle unibyte-display-via-language-environment.
	(produce_stretch_glyph): Set character to print in it->char_to_display.

2006-02-06  Kenichi Handa  <handa@m17n.org>

	* lread.c (openp): Initialize encoded_fn before GCPRO it.

2006-02-05  Ken Raeburn  <raeburn@raeburn.org>

	* editfns.c (Fconstrain_to_field): Fix int/Lisp_Object mixup.

	* lisp.h (XPNTR) [!NO_UNION_TYPE && !HAVE_SHM && !DATA_SEG_BITS]:
	Cast bitfield value to EMACS_INT, to suppress gcc warning.

	* xrdb.c (malloc, realloc, free) [emacs]: Undefine macros before
	defining.

2006-02-03  Kim F. Storm  <storm@cua.dk>

	* xdisp.c: Cache last merged escape glyph face.
	(last_escape_glyph_frame, last_escape_glyph_face_id)
	(last_escape_glyph_merged_face_id): New variables.
	(get_next_display_element): Use/update them.
	(redisplay_internal): Reset them before redisplay.

	* xdisp.c (set_iterator_to_next): Optimize 2004-12-13 fix.
	Only recheck faces after displaying ellipsis.

2006-02-02  Kenichi Handa  <handa@m17n.org>

	* coding.c (decode_composition_emacs_mule): Fix handling of
	incorrect format data.

2006-01-31  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (update_frame_tool_bar): Use new tool bar functions
	(gtk_toolbar_insert) so we can have tool bars of different sizes.

2006-01-30  Luc Teirlinck  <teirllm@auburn.edu>

	* data.c (Flistp): Doc fix.

2006-01-30  Juanma Barranquero  <lekktu@gmail.com>

	* window.c (Fother_window, Fwindow_vscroll, Fset_window_vscroll):
	Fix typos in docstrings.

2006-01-28  Luc Teirlinck  <teirllm@auburn.edu>

	* data.c (Fcar, Fcdr): Add links to Elisp manual to the docstrings.

2006-01-27  Chong Yidong  <cyd@stupidchicken.com>

	* alloc.c (make_interval, allocate_string)
	(allocate_string_data, make_float, Fcons, allocate_vectorlike)
	(Fmake_symbol, allocate_misc): Use BLOCK_INPUT when accessing
	global variables.

2006-01-27  Eli Zaretskii  <eliz@gnu.org>

	* dired.c (DIRENTRY_NONEMPTY) [__CYGWIN__]: Don't use d_ino; use
	the MSDOS definition.

2006-01-26  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (check_pure_size): Make overflow message an "error message".

	* keymap.c (Fmap_keymap): Doc fix.

	* xfns.c (Fx_create_frame): Put all specified parms into f->param_alist
	unless they were cleared out.

	* frame.c (x_get_arg): "Clear out" the parm in ALIST if found there.

2006-01-26  L$,1 q(Brentey K,Aa(Broly  <lorentey@elte.hu>

	* editfns.c (Fconstrain_to_field): Fix behaviour on field boundaries.
	(find_field): Set before_field to after_field when pos is at BEGV.
	(Fline_beginning_position, Fline_end_position):
	Clarify confusing doc string.

	* cmds.c (Fbeginning_of_line, Fend_of_line): Clarify confusing doc
	string.

2006-01-26  Kenichi Handa  <handa@m17n.org>

	* callproc.c (Fcall_process): GCPRO error_file.  Encode infile,
	current_dir, and error_file.  On reporting an error, decode them
	back.

2006-01-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.c (IMMEDIATE_QUIT_CHECK): Use it with SYNC_INPUT as well.
	(re_match_2_internal) <on_failure_jump, on_failure_jump_smart>:
	Don't check for quit, since any loop will go through fail or jump.

2006-01-24  Chong Yidong  <cyd@stupidchicken.com>

	* alloc.c (allocate_string_data): Update next_free immediately, to
	reduce risk of memory clobberage.

2006-01-24  L$,1 q(Brentey K,Aa(Broly  <lorentey@elte.hu>

	* xdisp.c (handle_invisible_prop): Set it->position to fix cursor
	display when point moves across an ellipsis.  If there are
	adjacent invisible texts, don't lose the second one's ellipsis.
	(x_produce_glyphs): Doc fix.

2006-01-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_catch_errors_unwind): Yet another int/Lisp_Object mixup.

2006-01-23  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_single_display_spec): Fix handling of space
	property on char from string: set *position rather than
	it->current.pos.
	(produce_stretch_glyph): Reduce width of stretch glyphs so they
	don't get wider than the window (unless truncate-lines is on).

2006-01-22  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c: Avoid allocating Lisp data from a signal handler.
	(x_error_message): New var to replace x_error_message_string.
	(x_error_catcher, x_catch_errors, x_catch_errors_unwind)
	(x_check_errors, x_had_errors_p, x_clear_errors, x_error_handler)
	(syms_of_xterm): Use it instead of x_error_message_string.

	* alloc.c (lisp_align_free): Add an assertion.
	(make_interval, allocate_string, make_float, Fcons, Fmake_symbol)
	(allocate_misc): If ENABLE_CHECKING is on, check we're not called from
	a signal handler.

2006-01-21  Luc Teirlinck  <teirllm@auburn.edu>

	* dired.c (syms_of_dired) <completion-ignored-extensions>: Doc fix.

2006-01-21  Romain Francoise  <romain@orebokech.com>

	* xdisp.c (get_window_cursor_type): Fix last change.
	Update copyright year.

2006-01-20  Eli Zaretskii  <eliz@gnu.org>

	* lread.c (Fload): Don't leak the file descriptor returned by
	openp if we are going to signal an error.

	* w32.c (sys_close): If FD is outside [0..MAXDESC) limits, pass it
	directly to _close.
	(sys_dup): Protect against new_fd larger than fd_info[] can handle.
	(sys_read): If FD is outside [0..MAXDESC) limits, pass it directly
	to _read.
	(sys_write): If FD is outside [0..MAXDESC) limits, pass it
	directly to _write.

	* .gdbinit: Don't dereference Vsystem_type's Lisp_Symbol pointer
	if it is NULL.

2006-01-20  Kenichi Handa  <handa@m17n.org>

	* puresize.h (BASE_PURESIZE): Increment to 1190000.

2006-01-19  Chong Yidong  <cyd@stupidchicken.com>

	* xdisp.c (get_window_cursor_type): Use cursor type specified by
	the selected buffer for the echo area too.

2006-01-19  Richard M. Stallman  <rms@gnu.org>

	* keymap.c (Fmap_keymap): Doc fix.

	* s/irix6-5.h (GC_SETJMP_WORKS, GC_MARK_STACK): New definitions.

	* keyboard.c (echo_char): Don't omit the space between first two
	echoed chars.

	* minibuf.c (read_minibuf): Fix previous change.

2006-01-19  Kenichi Handa  <handa@m17n.org>

	* xterm.c (handle_one_xevent): Handle keysyms 0x1000000..0x10000FF.

2006-01-17  Richard M. Stallman  <rms@gnu.org>

	* frame.c (x_frame_get_and_record_arg): Don't record Qunbound
	value in f->param_alist.

2006-01-15  Andreas Schwab  <schwab@suse.de>

	* search.c (Freplace_match): Use UPPERCASEP instead of !NOCASEP.

2006-01-13  Richard M. Stallman  <rms@gnu.org>

	* Makefile.in: Define new macro WINDOW_SUPPORT.
	(lisp): Use it.
	(SOME_MACHINE_LISP): Add conditionally loaded files.

2006-01-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_ATSUI] (atsu_get_text_layout_with_text_ptr)
	[MAC_OS_X_VERSION_MAX_ALLOWED >= 1020]: Specify kATSLineUseQDRendering.
	(XLoadQueryFont) [USE_ATSUI]: Display diacritical marks in
	decomposed form.

	* process.c [HAVE_INTTYPES_H]: Include inttypes.h.
	(ifflag_table): Fix typo (IFF_OACTIV -> IFF_OACTIVE).
	(Fnetwork_interface_info): Use HAVE_STRUCT_IFREQ_IFR_NETMASK
	macro.  Also try member ifr_addr when getting netmask.

2006-01-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Fexpand_file_name): Remove redundant tests.
	Fix elimination of // so that it doesn't prevent elimination of an
	immediately following /. or /..

2006-01-09  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_toggle_notify_cb): New function.
	(xg_toggle_visibility_cb): Move setting of x_gtk_show_hidden_files to
	xg_toggle_notify_cb.
	(xg_get_file_with_chooser): Add callback to xg_toggle_notify_cb when
	parameter value changes so the toggle button gets updated.

2006-01-06  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit: Fix typo.

2006-01-05  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Fix last change.

2006-01-05  Kim F. Storm  <storm@cua.dk>

	* process.c (Fmake_network_process): Use AF_INET instead of
	AF_UNSPEC when AF_INET6 is not defined.

2006-01-05  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (mac_coerce_file_name_ptr, mac_coerce_file_name_desc):
	Don't check that the other type is known file-related one.

	* macfns.c (Fx_server_version): Use gestaltSystemVersionMajor,
	gestaltSystemVersionMinor, and gestaltSystemVersionBugFix on Mac
	OS X 10.4 and later.

2006-01-04  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_image_for_pixmap): If the image is from a file,
	let GTK do all image processing.  Importing Emacs own pixmaps to GTK
	looks bad for inactive tool bar items with some Gnome themes.

2006-01-04  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Avoid a warning message when x_error_quitter is not
	compiled in.

	* process.c [WINDOWSNT]: Undef AF_INET6 to disable IPv6 support
	for w32.

2006-01-04  Kim F. Storm  <storm@cua.dk>

	* process.c: Add IPv6 support.
	(Qipv4, Qipv6): New vars.
	(syms_of_process): Intern and staticpro them.
	(Fformat_network_address): Handle 9 or 8 element vector as IPv6 address
	with or without port number.  Handle 4 element vector as IPv4 address
	without port number.
	(conv_sockaddr_to_lisp, get_lisp_to_sockaddr_size)
	(conv_lisp_to_sockaddr): Handle IPv6 addresses.
	(Fmake_network_process): Use :family 'ipv4 and 'ipv6 to explicitly
	request that address family only.  :family nil or omitted means to
	determine address family from the specified :host and :service.
	(ifflag_table): Add missing OpenBSD IFF_ flags.
	(server_accept_connection): Handle IPv6 addresses.
	(init_process): Add (:family ipv4) and (:family ipv6) sub-features.

	* .gdbinit: Undo last change.  Instead, look at Vsystem_type to
	determine which breakpoints to set.

2006-01-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* keymap.c (describe_map_compare): Yet another int/Lisp_Object mixup.

	* window.h (Fwindow_minibuffer_p): Declare (for use in minibuf.c).

2006-01-03  Romain Francoise  <romain@orebokech.com>

	* emacs.c (main): Update copyright year.

2006-01-03  Ken Raeburn  <raeburn@gnu.org>

	* callproc.c (delete_temp_file): Bind file-name-handler-alist to
	nil for the call to internal_delete_file.

2006-01-01  Ken Raeburn  <raeburn@gnu.org>

	* callproc.c (Fcall_process_region): Bind file-name-handler-alist
	to nil for the call to Fwrite_region.

2005-12-31  Richard M. Stallman  <rms@gnu.org>

	* minibuf.c (read_minibuf): Clear out all other minibuffer windows.

2005-12-31  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (gdb_pvec_type): A dummy variable for GDB's sake.

2005-12-30  Luc Teirlinck  <teirllm@auburn.edu>

	* textprop.c (set_text_properties): Reword description of return value.
	Return Qnil if caller wants to remove all text properties from a
	string and the string already has no intervals.

2005-12-30  Stefan Monnier  <monnier@iro.umontreal.ca>

	* term.c (visible_cursor): New boolean var.
	(set_terminal_modes, tty_show_cursor): Use "vs" or "ve" depending on
	visible_cursor.
	(syms_of_term): Export the new var as "visible-cursor".

2005-12-30  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Tell users not to worry about GDB warnings that some
	functions do not exist in the binary.

2005-12-30  Andreas Schwab  <schwab@suse.de>

	* process.c (Fnetwork_interface_info): Correctly terminate the
	loop over ifflag_table.

2005-12-29  Richard M. Stallman  <rms@gnu.org>

	* lread.c (readevalloop): Test for reading a whole buffer
	before actually reading anything.  Handle all cases, including
	START = END = nil and an already-narrowed buffer.
	Convert END to a marker if it is a number.

	* keymap.c (describe_map): Put sparse map elements into an array,
	sort them, then output a sequence of identical bindings on one line.
	(struct describe_map_elt): New data type.
	(describe_map_compare): New function.

2005-12-28  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_file_with_chooser): Change message shown
	in file chooser.

2005-12-27  Richard M. Stallman  <rms@gnu.org>

	* lread.c (readevalloop): Set PT and ZV in the proper buffer,
	not the current one.

	* minibuf.c (Fminibuffer_message): Doc fix.
	(read_minibuf): Set current_buffer->enable_multibyte_characters sooner.

	* eval.c (do_autoload): Ignore elements of Vautoload_queue
	where car is not symbol.

2005-12-27  Kenichi Handa  <handa@m17n.org>

	* charset.c (lisp_string_width): Check multibyteness of STRING.

2005-12-27  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c: x_show_hidden_files, new variable.
	(syms_of_xfns): Defvar it.

	* gtkutil.c (xg_toggle_visibility_cb): New function.
	(xg_get_file_with_chooser): Add toggle hidden files and a message
	to the new file chooser dialog.  Show hidden files if
	x_show_hidden_files is non-zero.

2005-12-26  Richard M. Stallman  <rms@gnu.org>

	* keyboard.h: Undo previous change.

	* Makefile.in (undo.o): Undo previous change.

	* undo.c: Undo previous change.

2005-12-26  Luc Teirlinck  <teirllm@auburn.edu>

	* keyboard.h: extern last_point_position_window.

	* undo.c: include keyboard.h.

	* Makefile.in (undo.o): Depend on keyboard.h.

2005-12-26  Richard M. Stallman  <rms@gnu.org>

	* commands.h (last_point_position_window): Declare.

	* undo.c: Depend on window.h.
	(record_point): Save old point from the correct window.

	* keyboard.c (last_point_position_window): New variable.
	(command_loop_1): Set last_point_position_window.
	(syms_of_keyboard): Init it.

	* Makefile.in (undo.o): Depend on window.h.

2005-12-25  Richard M. Stallman  <rms@gnu.org>

	* eval.c (un_autoload): Expect (0 . OFEATURES) in Vautoload_queue
	to undo a `provide'.

	* fns.c (Fprovide): Store (0 . OFEATURES) in Vautoload_queue.

2005-12-25  Giorgos Keramidas  <keramida@ceid.upatras.gr>

	* m/amdx86-64.h [__FreeBSD__] (START_FILES, LIB_STANDARD):
	define for FreeBSD on this platform.

2005-12-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.h (TYPE_FILE_NAME): New define.
	(posix_pathname_to_fsspec, fsspec_to_posix_pathname): Remove externs.

	* mac.c (posix_pathname_to_fsspec, fsspec_to_posix_pathname):
	Add prototypes.  Make static.
	(mac_aedesc_to_lisp): Initialize err to noErr.
	(mac_coerce_file_name_ptr, mac_coerce_file_name_desc)
	(init_coercion_handler): New functions.
	(Fmac_coerce_ae_data): Use coercion of Apple event data for
	translation from/to file names.

	* macterm.c: Don't include sys/param.h.
	(init_coercion_handler): Add extern.
	[MAC_OS8] (main): Call init_coercion_handler.
	(mac_initialize) [MAC_OSX]: Likewise.
	[TARGET_API_MAC_CARBON] (mac_do_receive_drag): Use coercion of
	Apple event data for translation from/to file names.

	* macfns.c [TARGET_API_MAC_CARBON] (Fx_file_dialog): Likewise.

	* image.c [MAC_OS] (find_image_fsspec): Likewise.

2005-12-23  Martin Rudalics  <rudalics@gmx.at>

	* insdel.c (insert, insert_and_inherit, insert_before_markers)
	(insert_before_markers_and_inherit): Make sure FROM is correct
	when `after-change-functions' are called.

2005-12-23  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (Fx_uses_old_gtk_dialog): New function.

	* gtkutil.c (xg_uses_old_file_dialog): New function.
	(xg_get_file_name): Use xg_uses_old_file_dialog.

	* gtkutil.h: Declare xg_uses_old_file_dialog.

2005-12-22  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (xmenu_show): Call inhibit_garbage_collection.

2005-12-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (Fmac_coerce_ae_data) [MAC_OSX]: Fix memory leak.

	* macgui.h (XCharStruct): Remove member `valid_p'.
	(STORE_XCHARSTRUCT): Don't set member `valid_p'.
	(XCharStructRow): New typedef.
	(XCHARSTRUCTROW_CHAR_VALID_P, XCHARSTRUCTROW_SET_CHAR_VALID):
	New macros.
	(struct MacFontStruct): Add member `bounds'.  Remove member
	`per_char'.  All uses for QuichDraw Text fonts are changed to
	`bounds.per_char'.  ATSUI font bounds are represented as an array
	`bounds.rows' of XCharStructRow's, each of which consists of a
	bitmap of valid entries and an array of char bounds.

	* macterm.c (mac_per_char_metric): Add prototype.
	(x_per_char_metric) [USE_CG_TEXT_DRAWING]: Remove prototype.
	(mac_query_char_extents): New function.
	(x_per_char_metric): Use it.
	(XLoadQueryFont): Likewise.  Consolidate min/max_bounds calculations.
	[USE_CG_TEXT_DRAWING] (mac_draw_string_cg):
	Use mac_per_char_metric instead of x_per_char_metric.
	(mac_text_extents_16): New function.
	(mac_compute_glyph_string_overhangs): Use it.
	(mac_unload_font): Free member `bounds' in struct MacFontStruct.

2005-12-21  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (Fdisplay_completion_list): Use XCAR/XCDR.
	(Fminibuffer_completion_help): Remove duplicates before display.

2005-12-21  L$,1 q(Brentey K,Aa(Broly  <lorentey@elte.hu>

	* print.c (print_preprocess): Don't lose print_depth levels while
	iterating.

2005-12-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macmenu.c (Qmac_apple_event): Add extern.
	(set_frame_menubar, mac_menu_show keymp_panes)
	(single_keymap_panes, list_of_panes, list_of_item)
	(single_menu_item): Add argument types to prototypes.
	(mac_dialog_show) [HAVE_DIALOGS]: Likewise.
	(struct skp): New struct (from xmenu.c).
	(single_keymap_panes, single_menu_item, list_of_panes)
	(list_of_item): Sync with xmenu.c.
	(Fx_popup_menu, Fx_popup_dialog): Likewise.  Don't get window from
	POSITION if it is mac-apple-event event.
	(menubar_selection_callback): Don't use menu_command_in_progress.
	(set_frame_menubar): First parse all submenus, then make
	widget_value trees from them.  Don't allocate any widget_value
	objects until we are done with the parsing.
	(parse_single_submenu, digest_single_submenu): New functions.
	(single_submenu): Function deleted, replaced by those two.
	(install_menu_quit_handler) [HAVE_CANCELMENUTRACKING]: Don't
	create or dispose of EventHandlerUPP.  Install hander to all submenus.
	(mac_menu_show) [!HAVE_MULTILINGUAL_MENU]: Use ENCODE_MENU_STRING
	instead of ENCODE_SYSTEM.
	(free_frame_menubar, fill_submenu, fill_menu): Don't use NULL for
	integer values.
	[HAVE_DIALOGS] (mac_dialog_show): Sync with xdialog_show (in xmenu.c).
	(add_menu_item) [TARGET_API_MAC_CARBON]: Use CFString functions to
	format menu item string.  Don't use NULL for integer value.

	* macterm.h (struct mac_output): Remove unused member
	menu_command_in_progress.

2005-12-20  Juri Linkov  <juri@jurta.org>

	* xmenu.c (Fx_popup_menu): Set Vmenu_updating_frame to f if
	position is non-nil, else set it to nil.

	* macmenu.c (Fx_popup_menu): Add `else' to set
	Vmenu_updating_frame to nil only if position is nil.

	* w32menu.c (Fx_popup_menu): Add `else' to set
	Vmenu_updating_frame to nil only if position is nil.

2005-12-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (make_lispy_event): Drag-and-drop items are now
	stored in member `args' of struct input_event.

	* termhooks.h (struct input_event): Fix comment for DRAG_N_DROP_EVENT.

	* xselect.c (x_handle_dnd_message): Drag-and-drop items are now
	stored in member `args' of struct input_event.

	* w32term.c (construct_drag_n_drop): Likewise.

	* macterm.c (mac_do_receive_drag): Likewise.
	(x_use_underline_position_properties): Undo 2005-07-13 change.
	(syms_of_macterm) <x-use-underline-position-properties>: Likewise.
	(mac_use_core_graphics, mac_wheel_button_is_mouse_2)
	(mac_pass_command_to_system, mac_pass_control_to_system):
	New boolean variables renamed from Lisp_Object ones
	Vmac_use_core_graphics, Vmac_wheel_button_is_mouse_2,
	Vmac_pass_command_to_system, and Vmac_pass_control_to_system.
	All uses changed.
	(syms_of_macterm): DEFVAR_BOOL them.  Remove previous DEFVAR_LISPs.
	Make them user options.
	(mac_handle_command_event, mac_store_services_event):
	Call create_apple_event_from_event_ref without 5th argument.
	(backtranslate_modified_keycode): Mask off modifier keys that are
	mapped to some Emacs modifiers before passing it to KeyTranslate.
	(syms_of_macterm): Make variables `mac-emulate-three-button-mouse',
	`mac-wheel-button-is-mouse-2', and `mac-*-modifier' user options.
	Fix docstrings of `mac-*-modifier'.

	* mac.c (create_apple_event_from_event_ref): Remove arg `types'.
	(do_applescript): Change argument types to Lisp_Object.
	All uses changed.

	* macterm.h (create_apple_event_from_event_ref): Remove 5th
	argument from extern.

2005-12-18  Dan Nicolaescu  <dann@ics.uci.edu>

	* xfns.c (Fx_backspace_delete_keys_p): In case we cannot determine
	the answer, return `lambda', not nil.

2005-12-17  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in (bootstrap-temacs): Warn that parts of commands
	enclosed in $(ARGQUOTE)s should not be split between two lines, as
	that will break with GNU Make >3.80, when sh.exe is used and
	arg quoting is with '..'.

2005-12-17  Chong Yidong  <cyd@stupidchicken.com>

	* print.c (print_preprocess): Just signal an error if print_depth
	is exceeded.

2005-12-17  Eli Zaretskii  <eliz@gnu.org>

	* .gdbinit: Set a breakpoint on w32_abort.

2005-12-16  Juri Linkov  <juri@jurta.org>

	* minibuf.c (Fminibuffer_completion_contents): New Lisp function
	created from minibuffer_completion_contents.
	(minibuffer_completion_contents): Remove.
	(do_completion, Fminibuffer_complete_word)
	(Fminibuffer_completion_help): Replace minibuffer_completion_contents
	with Fminibuffer_completion_contents.
	(syms_of_minibuf): Add Sminibuffer_completion_contents.
	(Fdisplay_completion_list): Doc fix.
	(display_completion_list_1): Use `nil' for second arg of
	`Fdisplay_completion_list'.

2005-12-14  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (compute_tip_xy): Handle negative dx and dy.

	* w32fns.c (compute_tip_xy): Ditto.

	* macfns.c (compute_tip_xy): Ditto.

2005-12-14  Chong Yidong  <cyd@stupidchicken.com>

	* print.c (print_preprocess): Go to a deeper print_depth to avoid
	print_object loop.

2005-12-14  Kyotaro HORIGUCHI  <horiguti@meadowy.org>  (tiny change)

	* coding.c (code_convert_region_unwind): GCPRO arg.

2005-12-12  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfns.c (compute_tip_xy): Calculate root_y the same way as root_x,
	i.e. dy is offset from top of frame instead of bottom.

	* macfns.c (compute_tip_xy): Ditto.

	* w32fns.c (compute_tip_xy): Ditto.

	* gtkutil.c (SSDATA): New macro to remove compiler warnings.
	(xg_get_image_for_pixmap, xg_create_frame_widgets)
	(xg_get_file_with_chooser): Use SSDATA instead of SDATA.

	* xmenu.c (menubar_selection_callback): Do nothing if the callback
	is for an unselected radio menu item.

2005-12-11  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (syms_of_xdisp) <blink-cursor-alist>: Doc fix.

	* lisp.h [! NO_UNION_TYPE] (EQ): Use == so args are computed just once.

	* keymap.c (Fset_keymap_parent, store_in_keymap): Use CHECK_IMPURE.
	(Flookup_key): Doc fix.
	(syms_of_keymap) <function-key-map>: Doc fix.

	* fns.c (Frequire): Treat evaluating from a source file
	like loading the file.

	* floatfns.c (Flog): Doc fix.

	* fileio.c (Finsert_file_contents): Set Vdeactivate_mark
	when we change the buffer.

2005-12-11  Juri Linkov  <juri@jurta.org>

	* minibuf.c (display_completion_list_1):
	Call `minibuffer_completion_contents' instead of using `nil' as
	second arg of `Fdisplay_completion_list'.
	(keys_of_minibuf): Unbind SPC in
	Vminibuffer_local_filename_completion_map (see also related
	change on 2005-12-06).

2005-12-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main) [MAC_OS8]: Undo previous change.

	* macselect.c (syms_of_macselect) <mac-apple-event-map>:
	Initialize to nil.  Keymap is now created in lisp/term/mac-win.el.

2005-12-10  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (macselect.o): Depend on keymap.h.

	* emacs.c (main) [MAC_OS8]: Call syms_of_keymap before
	syms_of_macselect.

	* image.c (init_image) [MAC_OS]: Don't call EnterMovies.
	[!HAVE_GIF && MAC_OS] (gif_load): Call EnterMovies.

	* keyboard.c (Qmac_apple_event) [MAC_OS]: New variable.
	(syms_of_keyboard) [MAC_OS]: Initialize it.
	(make_lispy_event) [MAC_OS]: Build lisp event for MAC_APPLE_EVENT.

	* mac.c (Qundecoded_file_name): New variable.
	(syms_of_mac): Initialize it.
	(mac_aelist_to_lisp, mac_aedesc_to_lisp): New functions.
	[TARGET_API_MAC_CARBON] (create_apple_event_from_event_ref): New fun.
	(Fmac_coerce_ae_data): New defun.
	(syms_of_mac): Defsubr it.

	* macselect.c: Include keymap.h.
	(mac_ready_for_apple_events): New variable.
	(Vmac_apple_event_map, Qmac_apple_event_class)
	(Qmac_apple_event_id): New variables.
	(syms_of_macselect): Initialize them.
	(Qundefined, mac_store_apple_event): Add externs.
	(struct apple_event_binding): New struct.
	(find_event_binding_fun, find_event_binding)
	(mac_find_apple_event_spec, defer_apple_events)
	(mac_handle_apple_event, init_apple_event_handler)
	(copy_scrap_flavor_data): New functions.
	(Fmac_process_deferred_apple_events): New defun.
	(syms_of_macselect): Defsubr it.
	(mac_store_services_event): Fix extern.
	(mac_handle_service_event): Don't allocate Lisp objects during
	asynchronous input processing.  Use mac_store_services_event
	instead of mac_store_application_menu_event.

	* macterm.c (Qmac_ready_for_drag_n_drop, Qapplication, Qabout)
	(Qpreferences): Remove variables.
	(syms_of_macterm) : Don't initialize them.
	(Qhicommand) [USE_CARBON_EVENTS]: New variable.
	(syms_of_macterm) [USE_CARBON_EVENTS]: Initialize it.
	(init_required_apple_events, do_ae_open_application)
	(do_ae_print_documents, do_ae_open_documents)
	(do_ae_quit_application): Remove functions and prototypes.
	(mac_ready_for_apple_events, Qundefined, init_apple_event_handler)
	(mac_find_apple_event_spec): Add externs.
	(mac_store_application_menu_event): Remove function.
	(mac_store_apple_event, mac_make_lispy_event_code): New functions.
	(mac_handle_command_event): Create Apple event from Carbon event.
	Use mac_store_apple_event instead of mac_store_application_menu_event.
	[MAC_OSX] (mac_store_services_event): Likewise.
	(struct SelectionRange, SelectionRange): Remove struct and typedef.
	[MAC_OS8] (main): Call init_apple_event_handler instead of
	init_required_apple_events.
	(mac_initialize) [MAC_OSX]: Likewise.
	[!USE_CARBON_EVENTS] (mac_wait_next_event):
	Use mac_ready_for_apple_events instead of Qmac_ready_for_drag_n_drop.

	* macterm.h (mac_make_lispy_event_code, mac_aedesc_to_lisp):
	Add externs.
	(create_apple_event_from_event_ref) [TARGET_API_MAC_CARBON]: Likewise.
	(Fmac_get_preference): Add EXFUN.

	* termhooks.h (enum event_kind) [MAC_OS]: Add new MAC_APPLE_EVENT
	event.

2005-12-09  Richard M. Stallman  <rms@gnu.org>

	* xfns.c (Fx_create_frame): Reinstate previous change.

2005-12-09  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_abort) [__GNUC__]: Add instructions for attaching
	GDB to the abort dialog.

2005-12-09  Kyotaro HORIGUCHI  <horiguti@meadowy.org>  (tiny change)

	* indent.c (Fvertical_motion): Force move if starting on
	stretch glyph.

2005-12-08  Richard M. Stallman  <rms@gnu.org>

	* lread.c (read_escape) <\s>: Don't treat strings specially.

	* xfns.c (Fx_create_frame): Comment out previous change.

2005-12-07  L$,1 q(Brentey K,Aa(Broly  <lorentey@elte.hu>

	* xfns.c (Fx_create_frame): Initialize Vdefault_minibuffer_frame,
	when needed.

2005-12-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* minibuf.c (keys_of_minibuf): Just unbind SPC in
	Vminibuffer_local_filename_completion_map rather than forcing it
	explicitly to the same binding as the global map.

2005-12-06  Ken Raeburn  <raeburn@gnu.org>

	* buffer.c (Fkill_buffer): Avoid dangerous side effects in NILP args.
	* bytecode.c (Fbyte_code): Likewise.
	* fileio.c (internal_delete_file, Fread_file_name_internal): Likewise.
	* minibuf.c (Fminibuffer_complete_and_exit): Likewise.
	* undo.c (truncate_undo_list): Likewise.

2005-12-05  Richard M. Stallman  <rms@gnu.org>

	* window.c (enlarge_window): Eliminate arg preserve_before.
	Assume it is 0.  All callers changed.
	(Fenlarge_window, Fshrink_window): Likewise.

2005-12-02  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (compute_tip_xy): Put tip above pointer if it doesn't
	fit below.

2005-12-02  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.h: Add prototype for xg_set_icon_from_xpm_data.

	* xfns.c (x_real_positions): int ign => unsigned int.
	(xg_set_icon_from_xpm_data): Remove unused variable err.
	(x_set_name_internal, Fx_create_frame, xg_set_icon): Add cast
	to remove compiler warning.
	(compute_tip_xy): Put tip above pointer if it doesn't fit below.

2005-12-02  David Reitter  <david.reitter@gmail.com>

	* minibuf.c (Fcompleting_read): If Vminibuffer_completing_file_name is
	non-nil, use the new keymaps Vminibuffer_local_filename_completion_map
	and Vminibuffer_local_must_match_filename_map keymaps.
	(keys_of_minibuf): Bind SPC in the new file-name completion keymaps.

	* keymap.c (Vminibuffer_local_filename_completion_map)
	(Vminibuffer_local_must_match_filename_map): New variables.
	(syms_of_keymap): DEFVAR_LISP them, initialize them, and set their
	parent to be Vminibuffer_local_completion_map and
	Vminibuffer_local_must_match_map, respectively.

	* commands.h (Vminibuffer_local_filename_completion_map)
	(Vminibuffer_local_must_match_filename_map): Declare the new keymaps.

2005-12-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fset_window_configuration): Don't accidentally copy the
	window-point of one window to another.

2005-11-30  L$,1 q(Brentey K,Aa(Broly  <lorentey@elte.hu>

	* buffer.c (Fpop_to_buffer): Remove superfluous call to record_buffer.

2005-11-30  Kim F. Storm  <storm@cua.dk>

	* alloc.c: Include fcntl.h.  Define O_WRONLY if not defined.
	(valid_lisp_object_p) [!GC_MARK_STACK]: Validate pointer by
	passing it to `emacs_write'.

2005-11-29  Ari Roponen  <arjuropo@cc.jyu.fi>  (tiny change)

	* atimer.c (stop_other_atimers): Fix loop to correctly compute `prev'.

2005-11-27  Richard M. Stallman  <rms@gnu.org>

	* window.c (adjust_window_trailing_edge): New function.
	(Fadjust_window_trailing_edge): New function.
	(syms_of_window): Defsubr it.
	(window_deletion_count): New variable.
	(delete_window): Update window_deletion_count.

2005-11-26  Eli Zaretskii  <eliz@gnu.org>

	* minibuf.c (syms_of_minibuf): Mention the extension of
	`completion-auto-help's meaning by complete.el.

2005-11-26  Henrik Enberg  <henrik.enberg@telia.com>

	* xfaces.c (Finternal_set_lisp_face_attribute_from_resource):
	Handle :inherit property as a lisp expression.

2005-11-24  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (Qcontrol): Rename from Qctrl.  All uses changed.
	(syms_of_macterm): Staticpro Qcontrol, Qmeta, Qalt, Qhyper,
	Qsuper, and Qmodifier_value.
	(Vmac_control_modifier, Vmac_option_modifier)
	(Vmac_command_modifier, Vmac_function_modifier)
	(Vmac_emulate_three_button_mouse, Vmac_wheel_button_is_mouse_2)
	(Vmac_pass_command_to_system, Vmac_pass_control_to_system)
	(Vmac_charset_info_alist): Doc fixes.

2005-11-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* emacs.c (main) [MAC_OSX]: Change working directory to home
	directory if `-psn_*' option is specified.

	* mac.c (DECODE_UTF_8): Remove macro.
	[TARGET_API_MAC_CARBON] (cfstring_to_lisp_nodecode): New function
	created from cfstring_to_lisp.
	[TARGET_API_MAC_CARBON] (cfstring_to_lisp): Use it.
	(xrm_get_preference_database) [TARGET_API_MAC_CARBON]: Likewise.

	* macterm.h (cfstring_to_lisp_nodecode) [TARGET_API_MAC_CARBON]:
	Add prototype.

2005-11-21  Ken Raeburn  <raeburn@gnu.org>

	* keymap.c (shadow_lookup): Use make_number to pass a number to
	Fsubstring.

2005-11-21  Juri Linkov  <juri@jurta.org>

	* puresize.h (BASE_PURESIZE): Increment to 1180000.

2005-11-20  Chong Yidong  <cyd@stupidchicken.com>

	* xfaces.c (Finternal_set_lisp_face_attribute):
	Use :ignore-defface for new frame defaults when `unspecified' is
	supplied.
	(Finternal_get_lisp_face_attribute): Hide :ignore-defface.
	(merge_face_vectors): Don't do :ignore-defface overwriting here.
	(Finternal_merge_in_global_face): Do it here.

2005-11-20  Juri Linkov  <juri@jurta.org>

	* charset.c (invalid_character): Use Lisp-readable syntax
	for octal and hex.  Reorder decimal, octal and hex values.

2005-11-20  Nick Roberts  <nickrob@snap.net.nz>

	* lisp.h: Use typedef when Lisp_Object is EMACS_INT so that
	this type is recognised when debugging.

2005-11-19  Andreas Schwab  <schwab@suse.de>

	* .gdbinit (nextcons, xcdr, xfloat): Update for changes in
	Lisp_Cons and Lisp_Float.

2005-11-19  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_CG_TEXT_DRAWING] (cg_text_anti_aliasing_threshold):
	New variable.
	[USE_CG_TEXT_DRAWING] (init_cg_text_anti_aliasing_threshold): New fun.
	(init_font_name_table) [USE_ATSUI && USE_CG_TEXT_DRAWING]: Use it.
	[USE_CG_TEXT_DRAWING] (mac_draw_string_cg): Don't do antialiasing if
	font size is smaller than or equal to cg_text_anti_aliasing_threshold.

2005-11-17  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (x_create_bitmap_from_xpm_data): Free attributes on fail.

	* xfaces.c (Qignore_defface): New variable.
	(syms_of_xfaces): Provide `:ignore-defface'.
	(IGNORE_DEFFACE_P): New macro.
	(check_lface_attrs, lface_fully_specified_p)
	(Finternal_set_lisp_face_attribute)
	(Fface_attribute_relative_p, Fmerge_face_attribute):
	Handle Qignore_defface as a possible value.
	(merge_face_vectors): The merged face is `unspecified' if the
	mergee specifies `:ignore-defface'.

2005-11-16  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (readevalloop): Add missing GCPROs.

2005-11-16  Chong Yidong  <cyd@stupidchicken.com>

	* xfns.c (xg_set_icon_from_xpm_data): New function.

	* gnu.h (gnu_xpm_bits): Rename from gnu_bits.
	(gnu_xbm_bits): Rename from gnu_bits (xbm version).

	* xterm.c (x_bitmap_icon): Use the xpm if available.

	* image.c (x_create_bitmap_from_xpm_data): New function.
	(x_create_bitmap_from_xpm_data): Initialize XpmAttributes.

2005-11-15  Luc Teirlinck  <teirllm@auburn.edu>

	* Makefile.in (lisp, shortlisp): Add rfn-eshadow.

2005-11-16  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit: Make SIGTSTP work like SIGINT normally does.

2005-11-15  Andreas Schwab  <schwab@suse.de>

	* lisp.h (struct Lisp_Cons): Make cdr a union.
	(XCDR_AS_LVALUE): Adjust.
	(struct Lisp_Float): Make data a union.
	(XFLOAT_DATA): Adjust.

	* alloc.c (free_float): Make free list chaining aliasing-safe.
	(make_float): Likewise.
	(free_cons): Likewise.
	(Fcons): Likewise.
	(check_cons_list): Likewise.
	(Fmake_symbol): Likewise.
	(allocate_misc): Likewise.
	(free_misc): Likewise.
	(gc_sweep): Likewise.

2005-11-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c (HASHKEY_QUERY_CACHE): New define.
	(xrm_create_database, xrm_q_put_resource): Empty query cache.
	(xrm_get_resource): Use query cache.

	* image.c (init_image) [MAC_OS]: Don't call EnterMovies if
	inhibit_window_system is set.

2005-11-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (USE_CG_TEXT_DRAWING): New define.
	(struct MacFontStruct) [USE_CG_TEXT_DRAWING]: New members cg_font
	and cg_glyphs.

	* macterm.c [USE_CG_TEXT_DRAWING] (mac_draw_string_cg): New function.
	(x_draw_glyph_string_foreground) [USE_CG_TEXT_DRAWING]: Use it.
	(XLoadQueryFont) [USE_CG_TEXT_DRAWING]: Set members cg_font and
	cg_glyphs in struct MacFontStruct if synthesized bold or italic is
	not used and font substitution never occurs for ASCII and Latin-1
	characters.
	(XLoadQueryFont): Maximum and minimum metrics are now those among
	ASCII characters.
	(XLoadQueryFont) [!MAC_OS8 || USE_ATSUI]: Apply WebKit-style
	height adjustments for Courier, Helvetica, and Times.

	* s/darwin.h (LIBS_CARBON) [!HAVE_CARBON]: Remove `-framework Carbon'.

2005-11-11  David Reitter  <david.reitter@gmail.com>

	* macterm.c (syms_of_macterm): Remove macCtrlKey, macShiftKey,
	macMetaKey, macAltKey.  Introduce Qctrl, Qmeta,
	Vmac_control_modifier / mac-control-modifier,
	Vmac_option_modifier / mac-option-modifier,
	Vmac_command_modifier / mac-command-modifier.
	(mac_to_emacs_modifiers): Use the new style modifier
	variables.  Return UInt32 (modifiers are longs now.)
	(backtranslate_modified_keycode): New function (refactoring).
	(XTread_socket): Use new modifier variables and refactored function.
	(mac_determine_quit_char_modifiers): Remove macMetaKey (there is
	no dedicated meta key.  Not in use anyway.)
	(convert_fn_keycode): Map Fn-keys to their original keycode
	using a table (english keyboard only).

2005-11-11  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Fix output format if n_overlay_strings > 0.
	Add post hook to "backtrace" to always dump lisp call stack to
	increase chance of people sending it to us when reporting bugs.

	* doc.c (Fsubstitute_command_keys): Doc fix.

	* dispextern.h (struct it): New member ignore_overlay_strings_at_pos_p.

	* xdisp.c (handle_stop): Skip overlay string handling if
	ignore_overlay_strings_at_pos_p is set.
	(set_iterator_to_next): At end of display vector, set
	ignore_overlay_strings_at_pos_p if dpvec came from an overlay
	string, so we skip those overlay strings at current pos.

2005-11-10  Lars Hansen  <larsh@soem.dk>

	* fileio.c (file-regular-p): Doc fix.

2005-11-10  Kim F. Storm  <storm@cua.dk>

	* alloc.c (valid_lisp_object_p): New function to validate that
	an object is really a valid Lisp_Object.

	* lisp.h (valid_lisp_object_p): Add prototype.

	* print.c (safe_debug_print): New function to be called from gdb
	to print Lisp objects; use valid_lisp_object_p to avoid crashing
	if user tries to print something which is not a Lisp object.

	* .gdbinit (pp, pp1): Use safe_debug_print.
	(pv, pv1): New commands to print value of a lisp variable.

2005-11-10  Nick Roberts  <nickrob@snap.net.nz>

	* .gdbinit (pp1): New user-defined function.

2005-11-09  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OSX] (image_load_quartz2d): Fix memory leak.

	* mac.c [MAC_OSX] (init_mac_osx_environment): Reinitialize locale
	related variables for dumped executable.

	* unexmacosx.c (unexec_write_zero): New function.
	(copy_data_segment): Clear uninitialized local variables in
	statically linked libraries.

	* s/darwin.h (C_SWITCH_SYSTEM): Remove -fno-common.

2005-11-09  Juri Linkov  <juri@jurta.org>

	* keymap.c (shadow_lookup): If Flookup_key returns a number,
	call it again with a sub-key-sequence, and if its return value
	is non-nil (sub-key is bound), return nil.

2005-11-08  Kim F. Storm  <storm@cua.dk>

	* process.c (Fsignal_process): Recognize signal names with and
	without SIG prefix, e.g. SIGHUP and HUP.

	* search.c (search_buffer): No need to initialize base_pat.

2005-11-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fget_lru_window, Fget_largest_window, window_loop):
	Don't abuse the `mini' arg.  Use the `obj' arg instead.

2005-11-04  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (show_mouse_face): Clear mouse face to eol.

2005-11-03  Dan Nicolaescu  <dann@ics.uci.edu>

	* Makefile.in (lisp, shortlisp): Add emacs-lisp/syntax.elc,
	font-lock.elc and jit-lock.elc.

2005-11-03  Richard M. Stallman  <rms@gnu.org>

	* window.c (Fenlarge_window): Rename SIDE to HORIZONTAL.
	(enlarge_window): Rename WIDTHFLAG to HORIZ_FLAG.
	(CURBEG, CURSIZE): Use HORIZ_FLAG instead of WIDTHFLAG.

	* sheap.c (STATIC_HEAP_SIZE): Increment both definitions.

	* alloc.c (refill_memory_reserve): Move decl out of conditionals.

2005-11-03  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Fdisplay_buffer): Fix last change to not use
	a dedicated window.

2005-11-01  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Undo 2005-10-27 change.
	Instead, rotate the bottom angle bitmap 180 degrees to indicate
	that the bottom row does not end in a newline.

2005-11-01  Andreas Schwab  <schwab@suse.de>

	* unexelf.c (unexec): Handle .plt section in BSS segment.

2005-11-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lread.c (readevalloop): Yet another int/Lisp_Object mixup (YAILOM).

	* window.c (window_loop): For LRU and LARGEST, let the `mini' argument
	determine whether to consider dedicated windows as well.
	(Fget_lru_window, Fget_largest_window): Add `dedicated' argument.
	(Fdisplay_buffer): Do consider dedicated windows in those cases where
	we will split the window rather than reuse it.
	Don't try to use windows on other displays.

2005-10-31  Dan Nicolaescu  <dann@ics.uci.edu>

	* puresize.h (BASE_PURESIZE): Increment to 1170000.

2005-10-31  Romain Francoise  <romain@orebokech.com>

	* macfns.c: Update copyright year.
	* m/gould.h: Likewise.

2005-10-30  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_line): Restore it->current_x and call
	extend_face_to_end_of_line when last glyph doesn't fit on line.
	(set_glyph_string_background_width): Remove specific tests here
	to see if face background should extend to end of line.  Simplify.

2005-10-30  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (BYTES_USED): Use uordblks, not arena.
	(bytes_used_when_reconsidered): New variable.
	(emacs_blocked_free): Set that.

2005-10-29  Chong Yidong  <cyd@stupidchicken.com>

	* alloc.c (emacs_blocked_free): Fix typo.

2005-10-29  Richard M. Stallman  <rms@gnu.org>

	* data.c (Fmake_variable_frame_local): Doc fix.

	* xdisp.c (handle_fontified_prop): Do nothing if memory full.
	(format_mode_line_unwind_data): New arg SAVE_PROPTRANS
	controls whether to save and restore mode_line_proptrans_alist.
	Callers changed.
	(unwind_format_mode_line): Work with that feature.
	(redisplay_internal): Don't call prepare_menu_bars if memory full.
	(move_elt_to_front): New function.
	(display_mode_element): Use move_elt_to_front.
	Don't bother munging text props on a null string.
	Delete obsolete elts from mode_line_proptrans_alist.
	(decode_mode_spec): Test Vmemory_full, not spare_memory.
	(Fformat_mode_line): Clear mode_line_proptrans_alist after saving.

	* lisp.h (memory_full_cons_threshold): Declare.
	(internal_lisp_condition_case): Declare.

	* alloc.c (syms_of_alloc) <memory-full>: Doc fix.
	(Fmemory_full_p): Function deleted.
	(syms_of_alloc): Don't defsubr it.
	(memory_full_cons_threshold): New variable.
	(spare_memory): Now a vector of 7 elts.
	(buffer_memory_full): Don't set Vmemory_full here.
	(xfree): Don't try to refill here.
	(emacs_blocked_free): Record BYTES_USED in local var.
	(memory_full): Now free all the slots in spare_memory.
	(refill_memory_reserve): Allocate each slot in spare_memory.
	(init_alloc_once): Call refill_memory_reserve.

	* keyboard.c (command_loop_1): Don't set Vmemory_full here.

	* eval.c (internal_lisp_condition_case): New function.
	(Fcondition_case): Use internal_lisp_condition_case.
	(Feval): Test Vmemory_full and memory_full_cons_threshold.
	(Ffuncall): Likewise.

	* bytecode.c (Fbyte_code): Use internal_lisp_condition_case.

2005-10-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (Fparse_partial_sexp): Fix docstring.

2005-10-28  Romain Francoise  <romain@orebokech.com>

	* puresize.h (BASE_PURESIZE): Increment to 1130000.

2005-10-28  Richard M. Stallman  <rms@gnu.org>

	* xfns.c (syms_of_xfns): Provide `x' as feature.

	* xdisp.c (decode_mode_spec): Define %e to indicate memory full.

	* editfns.c (Fformat): Don't include string padding
	between info[n].start and info[n].end.

	* alloc.c (spare_memory): No longer static.
	(xfree) [!SYSTEM_MALLOC]: Call refill_memory_reserve.

	* puresize.h (BASE_PURESIZE): Increment to 1120000.

2005-10-27  Chong Yidong  <cyd@stupidchicken.com>

	* data.c (Fmake_variable_frame_local): Add clarification to docstring.

	* fringe.c (update_window_fringes): Handle case where buffer ends
	with a newline.

2005-10-27  Kenichi Handa  <handa@m17n.org>

	* coding.h (DECODE_SYSTEM): Fix argument name; name->str.

2005-10-24  Kenichi Handa  <handa@m17n.org>

	* charset.h (charset_mule_unicode_0100_24ff)
	(charset_mule_unicode_2500_33ff, charset_mule_unicode_e000_ffff):
	Extern them.

	* charset.c (charset_mule_unicode_0100_24ff)
	(charset_mule_unicode_2500_33ff, charset_mule_unicode_e000_ffff):
	New variables.
	(Fsetup_special_charsets): Initialize them.

	* xterm.c (handle_one_xevent): Handle keysyms directly mapped to
	supported Unicode characters.

2005-10-25  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (w32_to_x_font): Avoid forcing font widths.

2005-10-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c [MAC_OS] (image_load_qt_1): Check image size.
	Use GraphicsImportGetImageDescription instead of
	GraphicsImportGetNaturalBounds.
	[MAC_OSX] (image_load_quartz2d): Check image size.
	[MAC_OS] (xpm_load_image): Likewise.

	* macterm.c (last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(XTmouse_position): Set last_mouse_glyph_frame.
	(XTread_socket): Clear last_mouse_glyph_frame on mouse up/down event.
	(mac_draw_string_common) [USE_ATSUI && WORDS_BIG_ENDIAN]: Fix typo.
	Use EndianU16_BtoN.
	(mac_draw_string_common) [MAC_OSX]: Don't use ATSUClearLayoutControls.
	(x_per_char_metric, XLoadQueryFont)
	[MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Use device origins to get
	glyph bounds.
	(mac_to_x_fontname, mac_do_list_fonts)
	(mac_initialize_display_info): Change screen resolutions to 72dpi.

2005-10-25  Masatake YAMATO  <jet@gyve.org>

	* minibuf.c (Fdisplay_completion_list): Small doc fix.

2005-10-24  Kim F. Storm  <storm@cua.dk>

	* xterm.c: Undo 2005-10-23 change.
	(last_mouse_glyph_frame): New var.
	(note_mouse_movement): Say mouse moved if current frame differs
	from last_mouse_glyph_frame, and update last_mouse_glyph_frame.
	(XTmouse_position): Set last_mouse_glyph_frame.
	(handle_one_xevent): Clear last_mouse_glyph_frame [instead of
	last_mouse_glyph] on mouse up/down event.

	* editfns.c (Fcompare_buffer_substrings): Fix last change.

2005-10-23  Stefan Monnier  <monnier@iro.umontreal.ca>

	* editfns.c (Fcompare_buffer_substrings): Handle multibyte chars.

2005-10-23  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (note_mouse_movement): Always call note_mouse_highlight
	so tool tips don't interfere with press on tool bar button.

2005-10-23  Richard M. Stallman  <rms@gnu.org>

	* casetab.c (Fset_case_table): Doc fix.

	* lread.c (build_load_history): Replace STREAM arg with ENTIRE.
	(readevalloop): Compute ENTIRE properly.
	(syms_of_lread) <load-history>: Doc fix.

2005-10-21  Richard M. Stallman  <rms@gnu.org>

	* lread.c (Fload): Simplify gcpro structure.
	Gcpro FOUND as well as FILE, but not EFOUND.
	Unless preloading, record FOUND instead of FILE in Vload_history.
	Rename repeat local FILE to MSG_FILE.
	(syms_of_lread) <load-history>: Doc fix.

2005-10-21  Kenichi Handa  <handa@m17n.org>

	* search.c (boyer_moore): Add parens to fix and/or precedence bug.

2005-10-20  Kim F. Storm  <storm@cua.dk>

	* buffer.c (clone_per_buffer_values): Remove unused var tem.
	(init_buffer): Remove unused vars dotstat, pwdstat.

	* ccl.c (check_ccl_update): Remove unused var vp.

	* fileio.c (auto_save_error): Call SAFE_FREE.

	* fns.c (Fchar_table_range): Remove unused var i.

	* minibuf.c (display_completion_list_1): New wrapper function
	for Fdisplay_completion_list.
	(Fminibuffer_completion_help): Use it.

	* term.c (encode_terminal_code): Remove unused var src_start.

	* window.c (Fwindow_tree): Remove unused var alist.

	* xterm.c (x_calc_absolute_position): Remove unused vars win_x, win_y.

2005-10-20  Aubrey Jaffer  <agj@alum.mit.edu>  (tiny change)

	* unexelf.c (unexec): Fix calls to `fatal' with less than 3 arguments.

2005-10-20  Olli Savia  <ops@iki.fi>  (tiny change)

	* syssignal.h [__Lynx__]: Undef SIGPOLL along with SIGIO.

2005-10-20  Andreas Schwab  <schwab@suse.de>

	* minibuf.c (Fdisplay_completion_list): Doc fix.

2005-10-19  Kim F. Storm  <storm@cua.dk>

	* image.c (check_image_size): Handle integer Vmax_image_size value
	directly as max pixel value.  Use default frame size for null frame.
	(syms_of_image) <max-image-size>: Describe integer value.

2005-10-19  Romain Francoise  <romain@orebokech.com>

	* emacs.c (main): Update copyright year.

2005-10-18  Chong Yidong  <cyd@stupidchicken.com>

	* image.c (Vmax_image_size): New variable.
	(check_image_size): New function.
	(xbm_read_bitmap_data, pbm_load, png_load, jpeg_load, tiff_load)
	(gif_load, gs_load): Use it.
	(lookup_image): Try loading again if previous load failed.
	(xbm_read_bitmap_data): Add a new argument, a pointer to the frame
	to display in, NULL if none.
	(xbm_load_image, xbm_file_p): Pass xbm_read_bitmap_data the new
	argument.

2005-10-18  Richard M. Stallman  <rms@gnu.org>

	* search.c (Fstring_match): Doc fix.

2005-10-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (note_mouse_movement): Use PtInRect.
	(XTread_socket): Also ignore mouse motion just before a button
	release event.  Don't process button release event when mouse is
	not grabbed.

2005-10-16  Masatake YAMATO  <jet@gyve.org>

	* minibuf.c (Fdisplay_completion_list): Add new optional
	argument COMMON_SUBSTRING.  Bind `completion-common-substring'
	to the optional argument during running `completion-setup-hook'.

2005-10-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [TARGET_API_MAC_CARBON] (get_cfstring_encoding_from_lisp):
	Allow nil as argument.
	 [TARGET_API_MAC_CARBON] (Fmac_code_convert_string): Regard nil
	for encoding arguments as UTF-16 in native byte order, no BOM.

	* macfns.c (Fx_create_frame): Add debugging code.
	(Fx_show_tip): Set frame pixel width and height.

	* macterm.c (MAC_WINDOW_NORMAL_GC): Remove macro.
	(FRAME_NORMAL_GC): New macro.
	(mac_draw_line, mac_clear_area, mac_clear_window)
	(mac_fill_rectangle, mac_draw_string, mac_draw_string_16)
	(mac_draw_image_string, mac_draw_image_string_16): Rename from
	XDrawLine, XClearArea, XClearWindow, XFillRectangle, XDrawString,
	XDrawString16, XDrawImageString, and XDrawImageString16, respectively.
	All uses changed.
	(mac_draw_line, mac_erase_rectangle, mac_clear_area)
	(mac_clear_window, mac_draw_bitmap, mac_draw_rectangle)
	(mac_invert_rectangle, mac_draw_string_common, mac_draw_string)
	(mac_draw_string_16, mac_draw_image_string)
	(mac_draw_image_string_16, mac_copy_area, mac_copy_area_with_mask)
	(mac_scroll_area): Drawing functions now take frame as destination.
	All uses changed.
	(mac_draw_string_common): Get port height with FRAME_PIXEL_HEIGHT.
	(x_draw_fringe_bitmap): Set clipping area in face->gc.

	* macterm.h (mac_clear_area): Add extern.

2005-10-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (note_mouse_movement, XTread_socket): Apply 2005-10-14
	changes for xterm.c.

	* w32term.c (note_mouse_movement, w32_read_socket): Likewise.

2005-10-14  Kenichi Handa  <handa@m17n.org>

	* search.c (search_buffer): Give up BM search on case-fold-search
	if one of a target character has a case-equivalence of different
	charset even if that target charcter is an ASCII.

	* casefiddle.c (casify_object): Fix for the case that case
	conversion change the byte length.

2005-10-14  Kim F. Storm  <storm@cua.dk>

	* xterm.c (note_mouse_movement): Return 1 if mouse moved; 0 otherwise.
	(handle_one_xevent): Only clear help_echo_string; restore it if
	note_mouse_movement didn't record any mouse movement.

	* xdisp.c (pos_visible_p): Convert w->hscroll to pixels before use.
	(remember_mouse_glyph): Clear RECT if mouse is over an image glyph.

	* keyboard.c (make_lispy_position): Adjust wx for left margin if
	ON_TEXT.
	(Fposn_at_x_y): Fix calculation of x coordinate.
	(Fposn_at_point): Return nil if point is hscrolled out of view.

2005-10-13  Andreas Schwab  <schwab@suse.de>

	* sysdep.c (request_sigio, unrequest_sigio): Do nothing in
	non-interactive mode.

2005-10-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xterm.c, w32term.c, macterm.c (note_mouse_movement): Undo last change.

2005-10-12  Kim F. Storm  <storm@cua.dk>

	* xterm.c (handle_one_xevent): Clear last_mouse_glyph on mouse up/down.

2005-10-12  Romain Francoise  <romain@orebokech.com>

	* buffer.c (init_buffer): Rename `rc' to `len' for clarity.

2005-10-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* xdisp.c (remember_mouse_glyph): Use MATRIX_BOTTOM_TEXT_ROW to
	get end of text rows.  Obtain header-line/mode-line rows directly.

	* xterm.c, w32term.c, macterm.c (note_mouse_movement):
	Restore help_echo_string if mouse is moved inside last_mouse_glyph.

2005-10-12  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (remember_mouse_glyph): New generic version based on
	glyph_rect and remember_mouse_glyph from xterm.c enhanced to
	properly handle all different window areas.

	* dispextern.h (remember_mouse_glyph): Add prototype.

	* xterm.c (glyph_rect, remember_mouse_glyph): Remove X versions.
	(note_mouse_movement, XTmouse_position): Use generic
	remember_mouse_glyph, add last_mouse_glyph arg.

	* w32term.c (note_mouse_movement): Fix last_mouse_glyph check.
	(glyph_rect, remember_mouse_glyph): Remove w32 specific versions.
	(note_mouse_movement, w32_mouse_position): Use generic
	remember_mouse_glyph, add last_mouse_glyph arg.

	* macterm.c (note_mouse_movement): Add call to remember_mouse_glyph.
	(glyph_rect, remember_mouse_glyph): Remove mac specific versions.
	(XTmouse_position): Adapt to use generic remember_mouse_glyph
	instead of pixel_to_glyph_coords.

	* window.c (coordinates_in_window): Fix x position for ON_RIGHT_MARGIN.
	Fix x position for ON_TEXT when left margin width > 0.

2005-10-11  Kim F. Storm  <storm@cua.dk>

	* window.c (coordinates_in_window): Fix y position for ON_SCROLL_BAR.

	* keyboard.c (make_lispy_position): Fix buffer calculations for
	mouse click or movement in right fringe and the margins.

2005-10-11  Juanma Barranquero  <lekktu@gmail.com>

	* image.c (fn_jpeg_stdio_src): Don't define it.
	(init_jpeg_functions): Don't initialize `fn_jpeg_stdio_src'.
	(our_common_init_source): Rename from `our_init_source'.
	(our_common_term_source): Rename from `our_term_source'.
	(our_memory_fill_input_buffer): Rename from
	`our_fill_input_buffer'.
	(our_memory_skip_input_data): Rename from `our_skip_input_data'.
	(jpeg_memory_src): Use the new names.
	(struct jpeg_stdio_mgr): New struct.
	(JPEG_STDIO_BUFFER_SIZE): New constant.
	(our_stdio_fill_input_buffer, our_stdio_skip_input_data)
	(jpeg_file_src): New functions.
	(jpeg_load): Use `jpeg_file_src' instead of `fn_jpeg_stdio_src'.

2005-10-11  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (PER_CHAR_METRIC): Remove unused macro.
	(fm_font_family_alist): New variable.
	(syms_of_macterm): Initialize and staticpro it.
	(decode_mac_font_name): Replace '-' in family name with '_' if it
	occurs just once.  Lower family name.
	(parse_x_font_name): Rename from x_font_name_to_mac_font_name.
	All uses changed.  Remove argument MF and code conversion for it.
	Add argument SIZE.  Rename argument MF_DECODED to FAMILY, and CS
	to CHARSET.  Parse font size.  Lower family name.  Return integer
	value for status of parsing.
	(init_font_name_table) [USE_ATSUI]: Use decode_mac_font_name.
	Don't use Fdowncase because family name is already lowered by
	decode_mac_font_name.
	(init_font_name_table): Always call decode_mac_font_name.
	Add pair of family name and its reference to fm_font_family_alist.
	(mac_clear_font_name_table): Clear fm_font_family_alist.
	(XLoadQueryFont): Move font size parsing part to parse_x_font_name.
	Lookup fm_font_family_alist to get font family reference.
	(XLoadQueryFont) [USE_ATSUI]: Don't use Fdowncase because family
	name is already lowered by parse_x_font_name.

2005-10-11  Kim F. Storm  <storm@cua.dk>

	* xterm.c (glyph_rect): Return 0 if position is outside text area.

	* keyboard.c (make_lispy_position): Fix buffer position calculation for
	mouse click or movement in fringe.

2005-10-10  Jason Rumney  <jasonr@gnu.org>

	* xterm.c (remember_mouse_glyph): New function.
	(note_mouse_movement): Use it to remember the current glyph if changed.
	(XTmouse_position): Fix calculation of fake glyph under mouse.
	Move code to calculate glyph under mouse into remember_mouse_glyph.

2005-10-10  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* emacs.c (USAGE3, standard_args): -nb => -nbi.

2005-10-10  Juanma Barranquero  <lekktu@gmail.com>

	* frame.c (Fredirect_frame_focus): Fix typos in docstring.
	(next_frame, prev_frame, set_term_frame_name): Make static.

	* window.c (Fwindow_tree): Fix spelling.

2005-10-09  Romain Francoise  <romain@orebokech.com>

	* window.c (Fwindow_end): Don't try to redisplay if non-interactive.

2005-10-09  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* emacs.c (standard_args): Remove options -i, -itype, --icon-type.
	Add options -nb, --no-bitmap-icon.

	* xfns.c (Fx_create_frame): Make bitmapIcon have default on.

2005-10-08  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (MAX_CLIP_RECTS): New define.
	(struct _XGC): New member clip_region.
	(struct _XGC) [MAC_OSX && USE_ATSUI]: New members n_clip_rects and
	clip_rects.

	* macterm.c (GC_CLIP_REGION): New macro.
	(saved_port_clip_region): New variable.
	(mac_begin_clip, mac_end_clip): New functions.
	(XDrawLine, mac_erase_rectangle, mac_draw_bitmap, XFillRectangle)
	(mac_draw_rectangle, mac_draw_string_common, mac_copy_area)
	(mac_copy_area_with_mask, mac_scroll_area): Use them.
	(mac_set_clip_rectangle, mac_reset_clipping): Remove functions.
	[USE_ATSUI] (atsu_get_text_layout_with_text_ptr)
	[MAC_OS_X_VERSION_MAX_ALLOWED < 1020]: Specify kATSLineFractDisable.
	(mac_draw_string_common) [MAC_OSX && USE_ATSUI]: Clip to clipping
	rectangles stored in gc.
	(XFreeGC): Dispose of clipping region.
	(mac_set_clip_rectangles, mac_reset_clip_rectangles): New functions.
	(x_draw_fringe_bitmap, x_set_glyph_string_clipping)
	(x_draw_relief_rect, x_draw_box_rect, x_draw_stretch_glyph_string)
	(x_draw_glyph_string, x_clip_to_row, x_draw_hollow_cursor)
	(x_draw_bar_cursor): Use them.
	(x_set_glyph_string_clipping): Use get_glyph_string_clip_rects to
	get multiple clipping rectangles.

	* macterm.h (mac_term_init): Add types to extern.
	(struct mac_output): Remove members mWP and pending_menu_activation.
	Put members scroll_bar_foreground_pixel and
	scroll_bar_background_pixel in #if 0.
	(FRAME_MAC_WINDOW, FRAME_X_WINDOW): Use window_desc.

	* xfaces.c (x_create_gc, x_free_gc) [MAC_OS]: Add BLOCK_INPUT.
	Add debugging code.

2005-10-08  Kim F. Storm  <storm@cua.dk>

	* window.c (window_tree, Fwindow_tree): Rename fns added 2005-10-04.

2005-10-07  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (redraw_overlapped_rows, redraw_overlapping_rows)
	[!HAVE_WINDOW_SYSTEM]: Don't declare them...
	(update_window) [!HAVE_WINDOW_SYSTEM]: ...and don't call them.

2005-10-07  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* dispextern.h (struct glyph_string): Rename member for_overlaps_p
	to for_overlaps.  Now occupy 3 bits.
	(OVERLAPS_PRED, OVERLAPS_SUCC, OVERLAPS_BOTH)
	(OVERLAPS_ERASED_CURSOR): New defines.
	(struct redisplay_interface): Add new OVERLAPS arg to member
	fix_overlapping_area.
	(x_fix_overlapping_area): Add new OVERLAPS arg.
	(get_glyph_string_clip_rects): Add extern.

	* dispnew.c (redraw_overlapping_rows):
	Call rif->fix_overlapping_area with new OVERLAPS arg as redrawn part.

	* xdisp.c: Rename member for_overlaps_p in struct glyph_string to
	for_overlaps.
	(get_glyph_string_clip_rects): New function created from
	get_glyph_string_clip_rect.  Set clipping rectangles according to the
	value of for_overlaps.  Enable to store multiple clipping rectangles.
	(get_glyph_string_clip_rect): Use get_glyph_string_clip_rects.
	(fill_composite_glyph_string, fill_glyph_string, draw_glyphs):
	Rename argument OVERLAPS_P to OVERLAPS.  All uses in macros changed.
	(x_fix_overlapping_area): Add OVERLAPS arg.  Pass it to draw_glyphs.
	(draw_phys_cursor_glyph): Set width of erased cursor to use it for
	calculating clipping rectangles later.  Call x_fix_overlapping_area
	with new OVERLAPS arg to draw only erased cursor area.
	(expose_overlaps): Call x_fix_overlapping_area with new OVERLAPS arg
	to draw overlaps in both preceding and succeeding rows.

	* xterm.c, w32term.c, macterm.c: Rename member for_overlaps_p in
	struct glyph_string to for_overlaps.

2005-10-04  Richard M. Stallman  <rms@gnu.org>

	* alloc.c (refill_memory_reserve): Conditionalize the body,
	not the function's existence.

2005-10-04  Kim F. Storm  <storm@cua.dk>

	* window.c (window_split_tree): New function.
	(Fwindow_split_tree): New defun.
	(syms_of_window): Defsubr it.

2005-10-04  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_invert_rectangle): New function.
	(XTflash): Use it.

2005-10-04  Stefan Monnier  <monnier@iro.umontreal.ca>

	* regex.h (re_char): Don't expose it in the interface.
	(re_set_whitespace_regexp): Adjust the arg's type to not use it.

	* regex.c (re_char): Move it back here.
	(re_set_whitespace_regexp): Change the arg's type to not use it.

	* keyboard.c (make_lispy_event): If point has moved between down and up
	event, make it a drag, not a click, to mirror what
	mouse-drag-region expects.

2005-10-02  Dan Nicolaescu  <dann@ics.uci.edu>

	* lisp.h (fatal): Undo previous change.
	* term.c (fatal): Undo previous change.

2005-10-01  Richard M. Stallman  <rms@gnu.org>

	* xfaces.c (face_color_gray_p): Colors close to black count as gray.

2005-10-01  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (try_window): Skip scroll-margin check if ZV is visible.

2005-10-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (init_keyboard) [MAC_OSX]: Don't install SIGINT handler.

	* macfns.c (start_hourglass): Apply 2005-05-07 change for xfns.c.
	(x_create_tip_frame) [GLYPH_DEBUG]: Uncomment debugging code.
	(Fx_create_frame, x_create_tip_frame) [USE_ATSUI]:
	Try ATSUI-compatible 12pt Monaco font first.

	* macgui.h (struct _XCharStruct): New member valid_p.
	(STORE_XCHARSTRUCT): Set valid_p.
	(struct MacFontStruct) [USE_ATSUI]: New member mac_style.

	* macterm.c (mac_draw_string_common, x_per_char_metric)
	(mac_compute_glyph_string_overhangs, init_font_name_table)
	(XLoadQueryFont, mac_unload_font) [USE_ATSUI]: Add ATSUI support.
	(atsu_get_text_layout_with_text_ptr) [USE_ATSUI]: New function.
	(x_draw_glyph_string_background)
	(x_draw_glyph_string_foreground) [MAC_OS8 && USE_ATSUI]: Don't use
	XDrawImageString.  Always draw background and foreground separately.
	(x_draw_glyph_string_foreground) [USE_ATSUI]: Don't use 8-bit
	functions for one-byte chars when using ATSUI-compatible fonts.
	(atsu_font_id_hash) [USE_ATSUI]: New variable.
	(syms_of_macterm) [USE_ATSUI]: Initialize and staticpro it.
	(XLoadQueryFont): Set min_byte1, max_byte1, min_char_or_byte2, and
	max_char_or_byte2 more in detail.
	(quit_char_comp, mac_check_for_quit_char) [MAC_OSX]: Remove functions.

2005-09-30  Dan Nicolaescu  <dann@ics.uci.edu>

	* image.c (slurp_file, xbm_read_bitmap_data): Cast to the correct type.
	* xterm.c (handle_one_xevent, handle_one_xevent): Likewise.

	* unexelf.c (fatal): Fix prototype.

	* term.c (fatal): Implement using varargs.

	* regex.c (re_char): Move typedef ...
	* regex.h (re_char): ... here.
	(re_iswctype, re_wctype, re_set_whitespace_regexp): New prototypes.

	* emacs.c (malloc_set_state): Fix return type.
	(endif): Fix type.

	* lisp.h (fatal): Add argument types.

	* dispextern.h (fatal): Delete prototype.

	* systime.h (make_time): Prototype moved from ...
	* editfns.c (make_time): ... here.

	* editfns.c: Move systime.h include after lisp.h.
	* dired.c:
	* xsmfns.c:
	* process.c: Likewise.

	* alloc.c (old_malloc_hook, old_realloc_hook, old_realloc_hook):
	Add parameter types.
	(__malloc_hook, __realloc_hook, __free_hook): Fix prototypes.
	(emacs_blocked_free): Change definition to match __free_hook.
	(emacs_blocked_malloc): Change definition to match __malloc_hook.
	(emacs_blocked_realloc): Change definition to match __realloc_hook.

2005-09-30  Romain Francoise  <romain@orebokech.com>

	* minibuf.c (Fread_buffer): Follow convention for reading from the
	minibuffer with a default value.  Doc fix.

2005-09-29  Juri Linkov  <juri@jurta.org>

	* editfns.c (Fmessage, Fmessage_box, Fmessage_or_box):
	Rename argument name `string' to `format-string'.
	(Fformat): Doc fix.

2005-09-28  Kim F. Storm  <storm@cua.dk>

	* image.c (gif_load): Fix size of allocated image buffer
	for images where a sub-image may be larger than the image's
	total height/width specifications.

2005-09-28  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macgui.h (struct _XCharStruct): Each member now takes short value.

2005-09-27  Dan Nicolaescu  <dann@ics.uci.edu>

	* xfaces.c (lookup_derived_face): Add parameter type.

	* xdisp.c (cursor_row_fully_visible_p): Add parameter type.

	* marker.c (verify_bytepos): Add parameter type.

	* process.c (get_operating_system_release): Move prototype ...

	* systime.h (get_operating_system_release): ... here.

	* xterm.c (handle_one_xevent): Refer to union field to match the
	type required by the function definition.
	(set_vertical_scroll_bar): Move prototype ...

	* xterm.h: ... here.

	* fns.c (internal_equal, seed_random): Fix prototypes.
	(internal_equal): Add missing parameter.

2005-09-25  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (update_menu_bindings): Variable deleted.
	(syms_of_keyboard): Don't defvar it.
	(parse_menu_item): Don't test it.

2005-09-23  Richard M. Stallman  <rms@gnu.org>

	* editfns.c (Fformat): Explicitly test for end of format string
	and don't use `index'.

2005-09-23  Dan Nicolaescu  <dann@ics.uci.edu>

	* s/aix4-2.h (BROKEN_GET_CURRENT_DIR_NAME):
	Define BROKEN_GET_CURRENT_DIR_NAME.

	* sysdep.c (get_current_dir_name): Also define if
	BROKEN_GET_CURRENT_DIR_NAME.

	* m/ibmrs6000.h: Test for USG5, not USG5_4.

2005-09-22  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (message_dolog): Add warning about GC and Lisp strings.
	(message2): Fix commentary.  Ok to use alloca'ed memory.
	Still not ok to use Lisp string data (because of GC).
	(set_message): Add comment why GC cannot happen.

2005-09-22  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (xlfdpat_block_match_1): Fix assertion.
	(init_font_name_table) [TARGET_API_MAC_CARBON]: Don't add style
	variants for a scalable font multiple times.

2005-09-21  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* process.c (create_process) [RTU || UNIPLUS || DONT_REOPEN_PTY]:
	Setup slave tty options before forking.

2005-09-20  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_set_geometry): Do a gtk_window_move if program
	positions have been set for the frame (as is done for frames in
	special-display-buffer-names).

2005-09-19  Kim F. Storm  <storm@cua.dk>

	* editfns.c (Fformat): Don't scan past end of format string that
	ends in %.  Reported by: Johan Bockg,Ae(Brd.

2005-09-18  Andreas Schwab  <schwab@suse.de>

	* window.h (struct window): Remove height_fixed_p, no longer set.

	* window.c (make_window): Don't initialize height_fixed_p.
	(window_fixed_size_p): Don't use it.

2005-09-18  John Paul Wallington  <jpw@pobox.com>

	* data.c (Fdefalias): Signal an error if SYMBOL is not a symbol.

2005-09-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* Makefile.in (SOME_MACHINE_OBJECTS): Undo previous change.

	* macfns.c (image_cache_refcount, dpyinfo_refcount) [GLYPH_DEBUG]:
	New variables.
	[TARGET_API_MAC_CARBON] (Fx_file_dialog): Don't allow multiple
	file selection.

	* sysdep.c [MAC_OS8]: Don't include stdlib.h.  Include sys/param.h.

2005-09-17  Eli Zaretskii  <eliz@gnu.org>

	* Makefile.in (XMENU_OBJ) [!HAVE_CARBON]: Reinstate variable.
	(obj): Use XMENU_OBJ, not a literal xmenu.o.

2005-09-16  Romain Francoise  <romain@orebokech.com>

	* fileio.c (syms_of_fileio) <write-region-inhibit-fsync>: Doc fix.

2005-09-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (overlay_arrow_at_row): Add HAVE_WINDOW_SYSTEM conditional.
	(display_mode_element): Instead of `lisp_string' and `this',
	record `offset' and increment that.
	`last_offset' replaces `last'.

	* Makefile.in (XMENU_OBJ): Variable deleted.
	(obj): Use xmenu.o unconditionally.
	(SOME_MACHINE_OBJECTS): Delete xmenu.o.

	* emacs.c (main): Don't conditionalize syms_of_xmenu on HAVE_XMENU.

2005-09-15  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (move_it_vertically): Don't try to fetch byte BEGV-1.
	(reseat_at_next_visible_line_start): Likewise (in xassert).

2005-09-14  Romain Francoise  <romain@orebokech.com>

	* fileio.c (write_region_inhibit_fsync): New variable.
	(Fwrite_region): Use it to skip call to fsync.
	(syms_of_fileio): Initialize it.

2005-09-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (code_convert_region_unwind): Argument format changed.
	(run_pre_post_conversion_on_str): If pre-write-conversion function
	changed the current buffer, delete the new buffer.
	(run_pre_write_conversin_on_c_str): Likewise.

	* fileio.c (Fexpand_file_name): Check multibyteness of
	default_directory.

2005-09-13  Kenichi Handa  <handa@m17n.org>

	* composite.c (compose_chars_in_text): Delete it.

	* composite.h (compose_chars_in_text): Delete extern.

2005-09-13  Kim F. Storm  <storm@cua.dk>

	* print.c (print_error_message): Fix last change.

2005-09-12  Kim F. Storm  <storm@cua.dk>

	* composite.c (compose_chars_in_text): Fix setup of `pend'.
	Unconditionally reload `ptr' and `pend' after eval.

	* xdisp.c (message3): Pass copy of lisp string to message_dolog.

	* print.c (print_error_message): Pass copy of caller name to
	message_dolog.

	* fileio.c (auto_save_error): Pass copy of lisp string to message2.

2005-09-12  Kenichi Handa  <handa@m17n.org>

	* xdisp.c (display_mode_element): Be sure to make variables THIS
	and LISP_STRING point into a string data of ELT.

2005-09-12  Kim F. Storm  <storm@cua.dk>

	* editfns.c (Ftranslate_region_internal): Reload `tt' after
	signal_after_change that may have GC'ed.
	(Fmessage, Fmessage_box, Fmessage_or_box): Doc fix.

	* keymap.c (Fdescribe_buffer_bindings): Reload `translate'
	after insert while runs signal_after_change.

	* minibuf.c (Fminibuffer_complete_word): Move `completion_string'
	declaration to where it is used.

	* w32.c (check_windows_init_file): Fix allocation of error buffer.

	* xfns.c (x_encode_text): Declare static.  Add FREEP arg.
	(x_set_name_internal): Call x_encode_text with new FREEP arg to
	know if xfree is needed instead of guessing.

	* xterm.h (x_encode_text): Remove prototype.

2005-09-11  Chris Prince  <cprince@gmail.com>  (tiny change)

	* w32term.c (x_bitmap_icon): Load small icons too.

2005-09-10  Romain Francoise  <romain@orebokech.com>

	* buffer.c (init_buffer): Grow buffer to add directory separator
	and terminal zero.  Fix typos.

2005-09-10  Eli Zaretskii  <eliz@gnu.org>

	* buffer.c (init_buffer): Fix error message for failed call to
	get_current_dir_name.
	(get_current_dir_name): Remove prototype.

	* xsmfns.c (get_current_dir_name): Remove prototype.

	* lisp.h (get_current_dir_name) [!HAVE_GET_CURRENT_DIR_NAME]:
	Add prototype.

	* sysdep.c [WINDOWSNT]: Add prototype for getwd.
	Don't #undef NULL after including blockinput.h.

	* config.in: Regenerated.

2005-09-10  Giuseppe Scrivano  <gscrivano@gmail.com>

	Remove the MAXPATHLEN limitations:

	* sysdep.c (get_current_dir_name) [!HAVE_GET_CURRENT_DIR_NAME]:
	New function.

	* buffer.c (init_buffer): Use it.

	* xsmfns.c (smc_save_yourself_CB): Ditto.

2005-09-09  Kim F. Storm  <storm@cua.dk>

	* doc.c (Fsubstitute_command_keys): Lookup key binding for
	commands that are remapped from some other command.

	* xdisp.c (try_window_reusing_current_matrix): Clear mode_line_p
	flag in disabled rows below the window.

	* frame.h (struct frame): New member updated_p.

	* xdisp.c (redisplay_internal): Mark updated frames in new updated_p
	member.  Remove local `updated' array and associated variables.

2005-09-07  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (handle_display_prop): Respect overlay window property.

	* xdisp.c (try_window): Remove superfluous cursor_height calculation.
	Fixes crash reported by YAMAMOTO Mitsuharu.

2005-09-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (struct xlfdpat_block, struct xlfdpat): New structs.
	(xlfdpat_destroy, xlfdpat_create, xlfdpat_exact_p)
	(xlfdpat_block_match_1, xlfdpat_match): New functions.
	(xlfdpat_block_match): New macro.
	(mac_to_x_fontname): Don't use tolower for non-ASCII characters.
	(x_font_name_to_mac_font_name): Set coding.dst_multibyte to 0.
	(add_font_name_table_entry): Increase font_name_table_size more
	rapidly.
	(mac_c_string_match): Remove function.
	(mac_do_list_fonts): Use XLFD pattern match instead of regular
	expression match.

	* xfaces.c (xstrlwr): Don't use tolower for non-ASCII characters.

2005-09-03  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (redisplay_internal): Make UPDATED as long as needed.
	(move_it_in_display_line_to): Stop after last char on line even
	on a windowing terminal, if that's the specified stop position.

	* fns.c (Fsort): Doc fix.

	* editfns.c (Fpropertize): Don't insist that properties be symbols.

2005-09-02  Stefan Monnier  <monnier@iro.umontreal.ca>

	* dired.c (directory_files_internal_unwind, directory_files_internal)
	(file_name_completion): Use a Save_Value object rather than a cons of
	two 16bit ints to store the DIR*.
	(directory_files_internal, file_name_completion): Handle both EINTR and
	EAGAIN consistently after `readdir'.

2005-09-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* intervals.c (update_interval): Add position info in error.

	* dispnew.c (window_to_frame_hpos, update_window):
	Avoid gcc warning about unused variable `f'.

2005-08-31  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (add_menu_item): If unicode_append_menu returns an
	error, revert to using AppendMenu.

2005-08-31  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* image.c (PIX_MASK_DRAW, PIX_MASK_RETAIN): Remove argument.
	All uses changed.
	[MAC_OS] (XPutPixel, XGetPixel): Add efficient versions for common
	cases.
	(x_create_x_image_and_pixmap) [MAC_OS]: Don't call x_destroy_x_image.
	[MAC_OS] (find_image_fsspec) [!MAC_OSX]: Don't use FSRef.
	Use posix_pathname_to_fsspec.
	[MAC_OS] (xpm_load_image): Fill in background_transparent field
	while we have mask.

	* macgui.h [!TARGET_API_MAC_CARBON] (GetPixDepth): New define.

	* macterm.h (PIX_MASK_DRAW, PIX_MASK_RETAIN): Move defines to image.c.

2005-08-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* syntax.c (update_syntax_table): Properly reproduce the special +1
	setting of e_property at the end of the buffer when bumping into the
	INTERVALS_AT_ONCE limit.

2005-08-27  Eli Zaretskii  <eliz@gnu.org>

	* emacs.c (USAGE1): Fix the description of the -Q option.

2005-08-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (pos_visible_p): Yet another int/Lisp_Object mixup (YAILOM).

2005-08-26  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (resize_mini_window): Fix 2005-08-20 change.
	Don't move PT to new window start.

2005-08-25  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* keyboard.c (kbd_buffer_get_event) [MAC_OS]: Make events for
	ICONIFY/DEICONIFY_EVENT.

	* macterm.c (mac_copy_area, mac_copy_area_with_mask):
	Restore background color.
	(mac_handle_visibility_change): New function.
	(x_make_frame_invisible, x_iconify_frame)
	(XTread_socket) [!USE_CARBON_EVENTS]: Use it.
	[USE_CARBON_EVENTS] (mac_handle_window_event)
	(install_window_handler): Handle visibility change events.
	(x_make_frame_visible): Don't reposition window if it is iconified
	or asked for visible before.  Select and uncollapse window when it
	is made visible.
	(x_make_frame_invisible): Don't reset x_highlight_frame.
	(x_iconify_frame): Likewise.  Make invisible frame visible before
	it is iconified.
	(read_socket_inev): Move variable outside #if USE_CARBON_EVENTS.
	(do_window_update): Don't change visibility of invisible frame.

2005-08-22  Juri Linkov  <juri@jurta.org>

	* term.c (turn_on_face): Check for TS_set_foreground and
	TS_set_background depending on standout_mode.  Simplify.

2005-08-21  Kim F. Storm  <storm@cua.dk>

	* fringe.c (update_window_fringes): Only put TOP and BOTTOM
	bitmaps on fully visible rows.

	* fringe.c (update_window_fringes): Replace FORCE_P arg with
	KEEP_CURRENT_P arg; if non-zero, don't update current row fringes,
	and return 0.

	* xdisp.c (redisplay_window): Call update_window_fringes with
	KEEP_CURRENT_P non-0 if we are going to refresh fringes later.

2005-08-20  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (display_echo_area_1): Get display start pos from w->start.
	(resize_mini_window): Set w->start, and PT, so as to display the tail
	end of the buffer, if it doesn't all fit.

2005-08-18  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (calc_pixel_width_or_height): Use actual display
	resolution when available instead of Vdisplay_pixels_per_inch.

2005-08-17  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (pos_visible_p): Adjust X value if window is hscrolled.

	* dispnew.c (buffer_posn_from_coords): Check that target row is
	within matrix.

2005-08-16  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (x_wm_set_icon_pixmap): Move GTK specific code to
	xg_set_frame_icon and call it.

	* gtkutil.c (xg_set_frame_icon): New function.

	* gtkutil.h (xg_set_frame_icon): Declare it.

2005-08-16  Kim F. Storm  <storm@cua.dk>

	* dispnew.c (increment_row_positions): Skip non-enabled rows.

	* window.c (SAVED_WINDOW_VECTOR_SIZE): Remove dangerous define.
	(Fcurrent_window_configuration): Use VECSIZE macro instead.

2005-08-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (message3_nolog): Clear echo_message_buffer.

2005-08-15  Kim F. Storm  <storm@cua.dk>

	* lisp.h (QUIT) [!SYNC_INPUT]: Throw t to Vthrow_on_input.

	* process.c (deactivate_process, status_notify, read_process_output)
	(update_status, status_convert, decode_status, allocate_pty)
	(make_process, remove_process, list_processes_1)
	(create_process_1, unwind_request_sigio, read_process_output)
	(send_process, keyboard_bit_set): Declare static.
	(Fdelete_process): Simplify.  Pass process to status_notify, so we
	don't try to read output from it.
	(status_notify): New arg deleting_process--don't try to read
	output from that process.

	* lisp.h (deactivate_process, status_notify, read_process_output):
	Remove prototypes.

2005-08-14  Richard M. Stallman  <rms@gnu.org>

	* image.c (syms_of_image): Init Qxbm, Qpbm before calling
	define_image_type.

2005-08-13  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_get_pixbuf_from_pix_and_mask): New function.
	(xg_get_image_for_pixmap): Move some code to
	xg_get_pixbuf_from_pix_and_mask, and call it.

	* gtkutil.h (xg_get_pixbuf_from_pix_and_mask): Declare.

	* xterm.c (x_wm_set_icon_pixmap): Call xg_get_pixbuf_from_pix_and_mask
	to get an GTK icon and set it with GTK functions to avoid having GTK
	override an icon set with just X functions.

2005-08-11  Richard M. Stallman  <rms@gnu.org>

	* image.c (syms_of_image): Init image_types here, and call
	define_image_type.
	(init_image): Not here.

2005-08-09  Richard M. Stallman  <rms@gnu.org>

	* bytecode.c (BYTE_CODE_QUIT): Throw t to Vthrow_on_input.

	* lisp.h (QUIT): Throw t to Vthrow_on_input.

2005-08-09  Thien-Thi Nguyen  <ttn@gnu.org>

	* floatfns.c (Fexpt): Use floats for negative exponent.

2005-08-08  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* gtkutil.c (xg_modify_menubar_widgets): Remove semicolon that
	should not be there, causing menu display errors with GTK 2.6.9.

2005-08-07  Richard M. Stallman  <rms@gnu.org>

	* floatfns.c (Fexpt): Undo previous change.

	* dispnew.c (Fframe_or_buffer_changed_p): Take an arg
	so it can be used with various state vectors.

	* emacs.c (endif): Convert -script into -scriptload.
	(standard_args): Add -scriptload.  Allow -basic-display with one dash.

	* fns.c (syms_of_fns): Add `emacs' to features.

	* term.c (set_terminal_modes): If no TS_termcap_modes string,
	output newlines to scroll the old screen contents off the screen.

2005-08-06  Thien-Thi Nguyen  <ttn@gnu.org>

	* floatfns.c (Fexpt): Use floats for negative exponent.
	Reported by D Goel.

2005-08-02  Richard M. Stallman  <rms@gnu.org>

	* frame.c (Fframe_char_width): Doc fix.

2005-07-30  Juanma Barranquero  <lekktu@gmail.com>

	* xdisp.c (syms_of_xdisp) <redisplay-end-trigger-functions>:
	Defvar it.

2005-07-28  Juanma Barranquero  <lekktu@gmail.com>

	* w32fns.c (my_set_window_pos, my_show_window): Don't declare.
	(my_create_window, my_create_tip_window): Make static.

	* w32term.c (my_show_window, my_set_window_pos, my_set_focus)
	(my_set_foreground_window, my_destroy_window): Make static.

2005-07-26  Paul Eggert  <eggert@cs.ucla.edu>

	Merge gnulib getopt implementation into Emacs.

	* s/cygwin.h (C_SWITCH_SYSTEM): Remove, since gettext.h is
	now part of lib-src.

2005-07-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* eval.c (Fdefvar): Allow (defvar enable-multibyte-characters).

2005-07-25  Jason Rumney  <jasonr@gnu.org>

	* w32menu.c (w32_menu_display_help): Suppress tooltip when
	navigating menus with the keyboard.

2005-07-23  Richard M. Stallman  <rms@gnu.org>

	* insdel.c (syms_of_insdel): staticpro combine_after_change_buffer.

	* bytecode.c (MAYBE_GC): Test gc_cons_threshold and
	gc_relative_threshold, one by one.

	* keyboard.c (read_char): Test gc_cons_threshold.
	(syms_of_keyboard): staticpro Qecho_area_clear_hook.

	* eval.c (Feval, Ffuncall): Test gc_cons_threshold and
	gc_relative_threshold, one by one.

	* alloc.c (gc_cons_threshold): Not static.
	(gc_cons_combined_threshold): Var deleted.
	(gc_relative_threshold): New variable.
	(Fgarbage_collect, init_alloc_once): Compute gc_relative_threshold
	instead of gc_cons_combined_threshold.

	* lisp.h (gc_cons_threshold, gc_relative_threshold): Declare.
	(gc_cons_combined_threshold): Declaration deleted.

2005-07-23  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c: Don't include stdlib.h or string.h.
	(Fdo_applescript, Fmac_file_name_to_posix)
	(Fmac_file_name_to_posix): Doc fixes.
	[TARGET_API_MAC_CARBON] (Fmac_get_preference)
	(Fmac_code_convert_string): Likewise.
	[MAC_OSX] (init_mac_osx_environment): Fall back on terminal mode
	if the executable is not contained in a bundle.

	* macfns.c: Don't include stdlib.h or string.h.  Include atimer.h.
	(gray_width, gray_height): Remove defines.
	(gray_bits, gray_bitmap_width, gray_bitmap_height)
	(gray_bitmap_bits): Remove variables.
	(lispy_function_keys): Remove extern.
	(free_frame_menubar): Add extern.
	(x_window_to_frame): Remove function.
	(unwind_create_tip_frame): Add declaration.
	(x_set_name_internal): New function.
	(x_set_name, x_set_title): Use it.
	(Fx_create_frame, Fx_display_grayscale_p, Fx_display_pixel_width)
	(Fx_display_pixel_height, Fx_display_planes)
	(Fx_display_color_cells, Fx_server_max_request_size)
	(Fx_server_vendor, Fx_server_version, Fx_display_screens)
	(Fx_display_mm_height, Fx_display_mm_width)
	(Fx_display_backing_store, Fx_display_visual_class)
	(Fx_display_save_under, Fx_synchronize, Fx_show_tip): Doc fixes.

	* macmenu.c (Fx_popup_menu, Fx_popup_dialog): Doc fixes.

	* macselect.c (Fx_own_selection_internal): Follow error conventions.
	(Fx_get_selection_internal, Fx_selection_owner_p)
	(Fx_selection_exists_p): Doc fixes.
	(syms_of_macselect) <selection-converter-alist>: Likewise.

2005-07-21  Juanma Barranquero  <lekktu@gmail.com>

	* buffer.c (syms_of_buffer) <cursor-type>: Doc fix.

	* ccl.c (Fregister_ccl_program): Fix typos in docstring.
	(Fccl_execute_on_string): Likewise; add usage info.

	* composite.c (Fcompose_region_internal)
	(Fcompose_string_internal):
	Improve argument/docstring consistency.

	* minibuf.c (Fminibuffer_prompt_end, Feval_minibuffer):
	Fix typos in docstrings.

	* textprop.c (Fnext_char_property_change)
	(Fprevious_char_property_change): Doc fixes.

	* window.c (Fset_window_margins, Fset_window_fringes):
	Improve argument/docstring consistency.

	* xfaces.c (Finternal_lisp_face_p): Doc fix.

2005-07-21  Andreas Schwab  <schwab@suse.de>

	* eval.c (restore_stack_limits): Return a value.

2005-07-20  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fdefvar): Doc fix.

2005-07-20  Kim F. Storm  <storm@cua.dk>

	* fileio.c (Fdo_auto_save, do_auto_save_unwind):
	Use make_save_value to unwind protect stream.

	* lread.c (Fload, load_unwind):
	Use make_save_value to unwind protect stream.

2005-07-19  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fprog2, Fcalled_interactively_p),
	(syms_of_eval) <debug-on-quit>: Doc fixes.
	(syms_of_eval) <max-specpdl-size>:
	(Finteractive_p): Fix typos in docstrings.

2005-07-19  Kim F. Storm  <storm@cua.dk>

	* w32fns.c (Vx_hand_shape): Variable removed.
	(syms_of_w32fns): Intern and staticpro Qw32_charset_default.

2005-07-19  Kenichi Handa  <handa@m17n.org>

	* fns.c (Fstring_as_multibyte): Escape backslashes in the docstring.

2005-07-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* buffer.h (Fgenerate_new_buffer_name): Declare (for use in coding.c).

2005-07-18  Kim F. Storm  <storm@cua.dk>

	* frame.h (struct frame): New member already_hscrolled_p.

	* xdisp.c (redisplay_internal): Only try to hscroll each frame once
	to avoid redisplay looping hscrolling back and forth ad infinitum.

2005-07-18  Juri Linkov  <juri@jurta.org>

	* buffer.c (scroll-up-aggressively, scroll-down-aggressively):
	* keymap.c (Fminor_mode_key_binding):
	* macterm.c (mac-emulate-three-button-mouse):
	Delete duplicate duplicate words.

2005-07-18  Ken Raeburn  <raeburn@gnu.org>

	* minibuf.c (Ftest_completion): Fix odd syntax in test.

2005-07-18  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macfns.c (x_set_cursor_color): Use XSetBackground and XSetForeground.

	* macgui.h (struct _XGC): New struct.
	(GC): Use it.
	(GCForeground, GCBackground, GCFont): Use X11 mask values.
	(XCreateGC, XParseGeometry): Move externs to macterm.h.

	* macterm.c (x_bitmap_icon, x_make_frame_visible): Remove declarations.
	(XSetFont): Add declaration.
	(mac_set_forecolor, mac_set_backcolor, mac_set_colors):
	Remove functions.
	(GC_FORE_COLOR, GC_BACK_COLOR, GC_FONT, MAC_WINDOW_NORMAL_GC):
	New defines.
	(XDrawLine, mac_draw_line_to_pixmap, XClearWindow)
	(mac_draw_bitmap, XCreatePixmapFromBitmapData, XFillRectangle)
	(mac_draw_rectangle, mac_draw_string_common, mac_scroll_area):
	Use them.
	(mac_erase_rectangle): New function.
	(XClearArea, x_draw_fringe_bitmap, x_clear_glyph_string_rect)
	(x_draw_stretch_glyph_string): Use it.
	(XChangeGC, XCreateGC, XGetGCValues, XSetForeground)
	(XSetBackground, XSetFont): Adjust for new GC implementation.
	(x_draw_fringe_bitmap, x_draw_box_rect): Use GC to set colors.
	(XTset_vertical_scroll_bar): Clear area under scroll bar.

	* macterm.h (struct mac_display_info): Change types of
	scratch_cursor_gc black_relief.gc, and white_relief.gc to GC.
	(XCreateGC, XParseGeometry): Move externs from macgui.h.

	* xfaces.c [MAC_OS] (XCreateGC): Remove extern.

2005-07-16  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (Fmake_overlay): Doc fix.

2005-07-16  Eli Zaretskii  <eliz@gnu.org>

	* w32proc.c (syms_of_ntproc): staticpro Qhigh, Qlow,
	Vw32_valid_locale_ids, and Vw32_valid_codepages.

2005-07-16  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [TARGET_API_MAC_CARBON] (Fmac_code_convert_string):
	Use Fstring_as_unibyte instead of string_make_unibyte.

2005-07-15  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (select_frame_for_redisplay): Use find_symbol_value.

2005-07-15  Kim F. Storm  <storm@cua.dk>

	* xdisp.c: Fix redisplay loop in last change.
	(IT_POS_VALID_AFTER_MOVE_P): New macro.
	(move_it_vertically_backward, move_it_by_lines): Use it.

2005-07-14  Jason Rumney  <jasonr@gnu.org>

	* w32.c (init_environment): Default HOME directory to user's
	appdata directory if possible.

2005-07-14  Kim F. Storm  <storm@cua.dk>

	* .gdbinit (pitx): Fix output format.  Print string charpos.

	* lread.c (syms_of_lread): Initialize seen_list.

	* search.c (syms_of_search): Staticpro searchbuf.whitespace_regexp.

	* syntax.c (syms_of_syntax): Staticpro lisp objects in gl_state.
	Staticpro re_match_object.

2005-07-14  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macselect.c (get_scrap_target_type_list): Avoid NULL pointer
	dereference.

	* macterm.c (mac_window_to_frame): Remove duplicate define.

2005-07-14  Kenichi Handa  <handa@m17n.org>

	* coding.c (code_convert_region_unwind): ARG is changed to a cons.
	(code_convert_region): Adjust for the above change.
	(set_conversion_work_buffer): If the work buffer is already in
	use, generate a new buffer and return it.  Otherwise return Qnil.
	(run_pre_post_conversion_on_str): Adjust for the above change.
	(run_pre_write_conversin_on_c_str): Likewise.

2005-07-13  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (start_display): Don't reseat to next visible line start
	if current start position is in a string or image.
	(move_it_vertically_backward): Be sure to move out of strings and
	images when moving it2 forward.
	(move_it_by_lines): When moving forward, move to next buffer
	position if we end up in a string or image.  When moving backward,
	count rows moved over when moving to start of current row in case
	row starts in middle of a string or image.  Also move further
	backward if we end up in a string or image.
	(try_cursor_movement): If overlay string spans multiple lines,
	move backward to set cursor on start of an overlay string.
	(cursor_row_p): Row is ok if cursor is at newline from string, but
	string starts on this line (so we always position cursor at start
	of string).

	* indent.c (Fvertical_motion): If start position is on an image,
	don't move back if we move too far (that's almost certain to happen).

	* xdisp.c (cursor_row_fully_visible_p): Allow partially visible
	row in minibuffer windows.
	(try_window): Don't check margins in minibuffer windows.

2005-07-13  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c: Don't include stdlib.h or composite.h.
	(x_use_underline_position_properties, last_mouse_press_frame)
	(x_noop_count, Qvendor_specific_keysyms): Remove unused variables.
	(syms_of_macterm, mac_initialize): Don't initialize them.
	(waiting_for_input, initial_argv, initial_argc)
	(Vcommand_line_args, Vx_no_window_manager, errno, window_scroll)
	(set_frame_menubar, path_from_vol_dir_name): Remove externs.
	(extra_keyboard_modifiers): Fix type in extern.
	(x_window_to_frame, x_window_to_scroll_bar): Remove declarations.
	(x_scroll_bar_report_motion): Add argument types to declaration.
	(mac_compute_glyph_string_overhangs): Add declaration.
	(disable_mouse_highlight): Remove unused variable.
	[USE_TOOLKIT_SCROLL_BARS] (construct_scroll_bar_click)
	(x_scroll_bar_handle_press, x_scroll_bar_handle_release)
	(x_scroll_bar_handle_drag): Remove argument `timestamp'.
	All callers changed.
	[USE_TOOLKIT_SCROLL_BARS] (construct_scroll_bar_click): Don't set
	timestamp.
	[USE_CARBON_EVENTS] (mac_handle_mouse_event): Likewise.
	(x_scroll_bar_create, XTset_vertical_scroll_bar): Show scroll bar
	only when its width is less than the height.
	(XTredeem_scroll_bar): Sync with xterm.c.
	(font_name_table, font_name_table_size, font_name_count):
	Make static.
	(drag_and_drop_file_list): Remove variable.  Previous use is now
	local to function.
	(do_ae_open_documents): Move DRAG_N_DROP event construction part
	from XTread_socket.
	(XTread_socket): Consolidate setting of event timestamp.
	Move DRAG_N_DROP event construction part to do_ae_open_documents.
	Support extra_keyboard_modifiers.

	* xfaces.c (try_font_list) [MAC_OS]: Try font family name
	beginning with that for ASCII.

2005-07-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* alloc.c (gc_cons_combined_threshold, Vgc_cons_percentage): New vars.
	(Fgarbage_collect, init_alloc_once): Set gc_cons_combined_threshold.
	(syms_of_alloc): Declare gc-cons-percentage.

	* eval.c (Feval, Ffuncall):
	* keyboard.c (read_char):
	* bytecode.c (MAYBE_GC): Use gc_cons_combined_threshold.

	* lisp.h (gc_cons_combined_threshold): Declare.

2005-07-12  Kim F. Storm  <storm@cua.dk>

	* coding.c (Qprocess_argument):
	* coding.h (Qprocess_argument): Remove unused var.

	* xselect.c (intern): Remove dup. intern and staticpro for QTIMESTAMP.

2005-07-12  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* mac.c [!TARGET_API_MAC_CARBON]: Include charset.h, coding.h, and
	Endian.h.
	[!MAC_OSX] (fchmod, fchown): New functions.
	(mac_get_code_from_arg): Don't accept Lisp integer as argument.
	Use SBYTES and EndianU32_BtoN.
	(mac_get_object_from_code): Return 4 byte string even if argument
	is 0.  Use make_unibyte_string and EndianU32_NtoB.
	(Fmac_get_file_creator, Fmac_get_file_type, Fmac_set_file_creator)
	(Fmac_set_file_type): Fix documents and argument declarations.
	Don't specify kFSCatInfoNodeFlags.  Support Mac OS Classic.

2005-07-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* window.c (Frecenter): Yet another int/Lisp_Object mixup (YAILOM).

2005-07-11  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xfaces.c (x_update_menu_appearance): Use fontSet resource for
	Lucid if X_I18N, font otherwise.

2005-07-10  Steven Tamm  <steventamm@mac.com>

	* mac.c (Fmac_get_file_type, Fmac_get_file_creator): Add.
	(Fmac_set_file_type, Fmac_set_file_creator): Add.
	(mac_get_object_from_code, mac_get_code_from_arg): Add.

2005-07-10  Richard M. Stallman  <rms@gnu.org>

	* lread.c (Qeval_buffer_list, Veval_buffer_list): New vars.
	(syms_of_lread): Set up eval-buffer-list.
	(Feval_buffer, Feval_region): Bind eval-buffer-list.

2005-07-08  Richard M. Stallman  <rms@gnu.org>

	* eval.c (Fdefvar): Allow defvaring a constant to itself quoted.

2005-07-08  Kim F. Storm  <storm@cua.dk>

	* keyboard.c (menu_bar_items): Don't GCPRO menu_bar_items_vector here.
	(syms_of_keyboard): Initialize and staticpro menu_bar_items_vector.

2005-07-07  Kim F. Storm  <storm@cua.dk>

	* window.c (Frecenter): Fix last change (set iarg before use).

2005-07-06  Richard M. Stallman  <rms@gnu.org>

	* window.c (Frecenter): When arg is inside the scroll margin,
	move it out of the margin.

2005-07-06  Jason Rumney  <jasonr@gnu.org>

	* w32console.c (initialize_w32_display): Detect when the console
	dimensions are insane, and default to 80x25 instead.
	(w32_use_full_screen_buffer): Default to NIL.

2005-07-06  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_draw_vertical_window_border): Use foreground of
	VERTICAL_BORDER_FACE_ID for vertical border line.
	(mac_encode_char): Call check_ccl_update in advance.
	(mac_to_x_fontname, x_font_name_to_mac_font_name)
	(init_font_name_table, mac_do_list_fonts, XLoadQueryFont):
	Don't assume that font family length is less than 32.
	(x_compute_min_glyph_bounds): Make static.
	(x_load_font): Never set fonts_changed_p to zero.

2005-07-04  Lute Kamstra  <lute@gnu.org>

	* Update FSF's address in GPL notices.

2005-07-03  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (try_window): Fix previous change in how it handles
	a partially-visible line or one only partly past the margin.

	* window.c (window_scroll_pixel_based): Take account
	of this_scroll_margin when finding point when scrolling up.

2005-06-29  Ralf Angeli  <angeli@iwi.uni-sb.de>

	* window.c (window_scroll_pixel_based, window_scroll_line_based):
	Handle `scroll-preserve-screen-position' non-nil, non-t specially.
	(syms_of_window) <scroll-preserve-screen-position>: Doc fix.

2005-07-02  Juri Linkov  <juri@jurta.org>

	* w32term.c (w32_draw_vertical_window_border): Use foreground of
	VERTICAL_BORDER_FACE_ID for vertical border line.

2005-07-02  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Fcopy_file): Rearrange the code that calls fchown and
	fchmod so that chmod doesn't get called on MSDOS before the file
	is closed.

2005-07-01  Jason Rumney  <jasonr@gnu.org>

	* w32term.c (cleartype_active): New flag for enabling sub-pixel
	workaround.
	(w32_initialize): Initialize it.
	(w32_native_per_char_metric): Allow a couple of extra pixels when
	Cleartype is active.

	* w32term.c (w32_initialize): Move check for screen reader here
	from syms_of_w32term.

2005-06-30  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* xterm.c (handle_one_xevent): bzero compose_status when nbytes
	is not zero.

2005-07-01  Masatake YAMATO  <jet@gyve.org>

	* emacs.c (main): Passing ADD_NO_RANDOMIZE to `personality'.

2005-06-30  Juri Linkov  <juri@jurta.org>

	* xdisp.c (x_draw_vertical_border): If left fringe is not present
	decrease x coord of vertical border by 1 pixel to not occupy text
	area of the right window.

	* xterm.c (x_draw_vertical_window_border): Use foreground of
	VERTICAL_BORDER_FACE_ID for vertical border line.

	* term.c (turn_on_face): In standout mode apply specified
	fg to bg, and specified bg to fg (this makes the logic of
	inversion on terminal consistent with X).

2005-06-29  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (user_variable_p_eh): New function.
	(Fuser_variable_p): Use it.  Clarify docstring.
	Return t for aliases of user options, nil for alias loops.

2005-06-27  Richard M. Stallman  <rms@gnu.org>

	* eval.c (Fdefvar): Improve error message.

2005-06-27  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c [USE_CARBON_EVENTS] (mac_convert_event_ref): Fix last
	change.

2005-06-27  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fdefvar): Don't try to set constant symbols.

2005-06-25  Richard M. Stallman  <rms@gnu.org>

	* macfns.c (Fx_show_tip): Pass new arg to try_window.

	* w32fns.c (Fx_show_tip): Pass new arg to try_window.

	* xfns.c (Fx_show_tip): Pass new arg to try_window.

	* xdisp.c (try_window): New arg CHECK_MARGINS.  Calls changed.
	(redisplay_window): Handle try_window reporting point in scroll margin.

	* dispextern.h (try_window): Declare new arg.

	* fileio.c (Fcopy_file): New arg PRESERVE_UID_GID.
	Use fchmod to copy the file modes.
	(Frename_file): Don't copy UID and GID here;
	instead, specify t for PRESERVE_UID_GID when calling Fcopy_file.

	* eval.c (call_debugger): Take full care of extending stack limits
	to make space for the debugger, and restore the change afterward.
	Bind debug-on-error to nil.
	(restore_stack_limits): New subroutine.
	(Fsignal): Extend specpdl bound along with eval depth bound,
	for calling edebug.  Don't do either one, for calling debugger.
	(find_handler_clause): Don't bind debug-on-error here.
	Don't unbind anything either.
	Temporarily advance max_specpdl_size for calling
	internal_with_output_to_temp_buffer.
	(grow_specpdl): Don't alter max_specpdl_size before signaling
	an error.
	(syms_of_eval) <max-specpdl-size>: Doc fix.

	* lread.c (read1): 0.0e+NaN should make a "positive" NaN.

2005-06-24  Eli Zaretskii  <eliz@gnu.org>

	* fileio.c (Frename_file): Undo last change: no need to ifdef away
	chown on DOS_NT platforms.

	* w32.c (sys_chown): New function.

	* s/ms-w32.h (chown): New; define to sys_chown.

2005-06-24  Juanma Barranquero  <lekktu@gmail.com>

	* xdisp.c (syms_of_xdisp) <nobreak-char-display>: Doc fix.
	(syms_of_xdisp) <void-text-area-pointer>: Doc fix.

	* fileio.c (Frename_file)[!DOS_NT]: Don't call chown on MSDOS/Windows.

2005-06-23  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): Finish reversing the tests of
	Vnobreak_char_display.

	* xdisp.c (Vnobreak_char_display): Rename from Vshow_nonbreak_escape.
	All uses changed.
	(Qnobreak_space): Rename from Qno_break_space.  All uses changed.
	(syms_of_xdisp): Define nobreak-char-display and nobreak-space.

	* fileio.c (Frename_file): Preserve owner and group, if possible,
	when copying.

2005-06-23  Juanma Barranquero  <lekktu@gmail.com>

	* abbrev.c (Funexpand_abbrev):
	* category.c (Fmake_category_set):
	* dispnew.c (Fsleep_for, Fsit_for):
	* editfns.c (Fsubst_char_in_region):
	* eval.c (Fdefvar, Fdefconst, Feval, Ffuncall):
	* frame.c (make_frame_without_minibuffer):
	* lread.c (read_vector):
	* macfns.c (check_x_frame):
	* process.c (Fstop_process, Fcontinue_process):
	* search.c (Freplace_match):
	* syntax.c (Fstring_to_syntax):
	* w32fns.c (check_x_frame, check_x_display_info):
	* xfaces.c (x_supports_face_attributes_p):
	* xselect.c (Fx_own_selection_internal): Follow error conventions.

	* image.c (fn_png_init_io): Don't define it.
	(init_png_functions) [HAVE_NTGUI]: Don't initialize fn_png_init_io.
	(png_read_from_file): New function, based on png_read_from_memory.
	(png_load): Use it, instead of fn_png_init_io.

2005-06-23  Kim F. Storm  <storm@cua.dk>

	* search.c (Fmatch_data): Remove evaporate option.
	(Fset_match_data): Do not mention evaporate option in doc string.
	Add commentary explaining evaporate arg (for internal use only).
	(unwind_set_match_data): Add comment on evaporate use.

2005-06-22  Miles Bader  <miles@gnu.org>

	* xfaces.c (Qvertical_border): Rename from `Qvertical_divider'.
	(realize_basic_faces, syms_of_xfaces): Update references to it.
	* dispextern.h (enum face_id): Rename `VERTICAL_DIVIDER_FACE_ID'
	to `VERTICAL_BORDER_FACE_ID'.
	* dispnew.c (build_frame_matrix_from_leaf_window): Update references.

2005-06-21  Juri Linkov  <juri@jurta.org>

	* dispextern.h: Add extern Qframe_set_background_mode.

	* xfaces.c: Rename obsolete function Qframe_update_face_colors to
	Qframe_set_background_mode.

	* frame.c (Fmodify_frame_parameters):
	Call frame-set-background-mode after changing the background color
	on non-window non-dos branch.

2005-06-21  Juanma Barranquero  <lekktu@gmail.com>

	* fns.c (Fchar_table_range):
	* process.c (Fmake_network_process): Fix spellings.

2005-06-20  Kim F. Storm  <storm@cua.dk>

	* fns.c (Fsort): Doc fix.

2005-06-20  Miles Bader  <miles@gnu.org>

	* xfaces.c (Qvertical_divider): New variable.
	(realize_basic_faces): Realize its face.
	(syms_of_xfaces): Initialize it.

	* dispextern.h (enum face_id): Add `VERTICAL_DIVIDER_FACE_ID'.

	* dispnew.c (build_frame_matrix_from_leaf_window): Display vertical
	window-separator on ttys using `vertical-divider' face by default.

2005-06-17  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element):
	Reverse test of Vshow_nonbreak_escape.

	* term.c (produce_special_glyphs): Use spec_glyph_lookup_face.
	(Ftty_no_underline): New function.
	(syms_of_term): defsubr it.

	* keyboard.c (read_char): Call restore_getcjmp after jump occurs.

	* dispnew.c (spec_glyph_lookup_face): New function.
	(build_frame_matrix_from_leaf_window): Use it.

	* dispextern.h (spec_glyph_lookup_face): Add declaration.

	* buffer.c (syms_of_buffer) <cursor-type>: Doc fix.

2005-06-12  Richard M. Stallman  <rms@gnu.org>

	* keyboard.c (read_char): After catching a longjmp,
	call restore_getcjmp.

2005-06-17  Juanma Barranquero  <lekktu@gmail.com>

	* xselect.c (lisp_data_to_selection_data): Fix spelling.

2005-06-15  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_compute_glyph_string_overhangs): Don't set
	overhangs unless the given glyph type is noncomposite CHAR_GLYPH.
	[USE_CARBON_EVENTS] (mac_convert_event_ref): Convert dead key down
	events.
	(XTread_socket): Don't pass keyboard events with the option
	modifier to the system when Vmac_command_key_is_meta is nil or
	Vmac_option_modifier is non-nil.
	[USE_CARBON_EVENTS] (read_socket_inev): New variable.
	[USE_CARBON_EVENTS] (init_command_handler): Fix argument.
	[USE_CARBON_EVENTS] (mac_handle_mouse_event): New Carbon event
	handler function.
	(install_window_handler) [USE_CARBON_EVENTS]: Install it.
	(XTread_socket) [USE_CARBON_EVENTS]: Move mouse wheel event
	handler part to mac_handle_mouse_event.

2005-06-14  Juanma Barranquero  <lekktu@gmail.com>

	* eval.c (Fdefvaralias): Rename arguments SYMBOL and ALIASED to
	NEW-ALIAS and BASE-VARIABLE, respectively.

2005-06-13  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xdisp.c (note_mode_line_or_margin_highlight): Lisp_Object/int mixup.
	(get_phys_cursor_geometry, format_mode_line_unwind_data)
	(get_line_height_property, x_produce_glyphs): Remove unused vars.

	* coding.c (run_pre_post_conversion_on_str): Remove unused var `buf'.

2005-06-13  Eli Zaretskii  <eliz@gnu.org>

	* w32term.c (x_use_underline_position_properties): New variable.
	(x_draw_glyph_string): Remind in a comment to change doc string of
	x-use-underline-position-properties if/when underline positioning
	is implemented.
	(syms_of_w32term): DEFVAR_BOOL x-use-underline-position-properties,
	and initialize it to nil.

2005-06-12  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (NEWOPENFILENAME): New struct.
	(Fx_file_dialog): Use it to trick the system into giving us up to
	date dialogs on systems that are documented to support it.
	Do not set OFN_FILEMUSTEXIST flag if looking for a directory.

2005-06-12  Eli Zaretskii  <eliz@gnu.org>

	* w32fns.c (w32_abort): Use the MB_YESNO dialog instead of
	MB_ABORTRETRYIGNORE.  Never return, even if DebugBreak does.

2005-06-11  Eli Zaretskii  <eliz@gnu.org>

	* image.c (x_create_x_image_and_pixmap) [HAVE_NTGUI]: Cast 4th arg
	to CreateDIBSection to avoid a compiler warning.
	(pbm_load): Cast 3rd arg to IMAGE_BACKGROUND to avoid a compiler
	warning.
	(png_load): Cast return values of fn_png_create_read_struct and
	fn_png_create_info_struct, to avoid compiler warnings on W32.
	Cast 3rd arg to IMAGE_BACKGROUND and image_background_transparent
	to avoid compiler warnings.
	(jpeg_load): Cast return value of fn_jpeg_std_error to avoid a
	compiler warning on W32.  Cast 3rd arg to IMAGE_BACKGROUND to
	avoid a compiler warning.
	(tiff_load): Cast return values of fn_TIFFOpen and
	fn_TIFFClientOpen to avoid compiler warning on W32.  Cast 3rd arg
	to IMAGE_BACKGROUND to avoid a compiler warning.
	(gif_load): Cast return values of fn_DGifOpenFileName and
	fn_DGifOpen to avoid compiler warnings on W32.  Cast 3rd arg to
	IMAGE_BACKGROUND to avoid a compiler warning.
	(DrawText) [HAVE_NTGUI || MAC_OS]: If already defined, undef
	before redefining.

	* w32bdf.c (create_offscreen_bitmap): Cast `bitsp' to `void **' in
	the call to CreateDIBSection, to avoid a compiler warning.

2005-06-11  Jason Rumney  <jasonr@gnu.org>

	* w32fns.c (Fx_file_dialog): Unblock input before falling back to
	minibuffer.
	* macfns.c (Fx_file_dialog): Likewise.

2005-06-10  Eli Zaretskii  <eliz@gnu.org>

	* makefile.w32-in ($(TEMACS)): Depend on addsection.exe.

2005-06-10  Juanma Barranquero  <lekktu@gmail.com>

	* process.c (syms_of_process) [ADAPTIVE_READ_BUFFERING]:
	* w32fns.c (syms_of_w32fns): Fix spellings.

2005-06-10  Eli Zaretskii  <eliz@gnu.org>

	* unexw32.c (COPY_CHUNK, COPY_PROC_CHUNK): Add a new argument
	`verbose'; print diagnostic messages only if it is non-zero.
	All callers changed to pass a zero value unless DEBUG_DUMP is defined
	in the environment.
	(copy_executable_and_dump_data): Print section names with %.8s.

2005-06-10  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Call clear_mouse_face
	when mouse_face is not given.

2005-06-09  Luc Teirlinck  <teirllm@auburn.edu>

	* window.c (Fselect_window): Adapt call to Fselect_frame.

	* lisp.h: Update EXFUN of Fselect_frame.

	* keyboard.c (command_loop_1): Adapt call to Fselect_frame.

	* frame.c (Fhandle_switch_frame, Fselect_frame): Delete unused arg
	no_enter.
	(Fset_mouse_position, Fset_mouse_pixel_position, Ficonify_frame):
	Adapt to above change.

2005-06-10  Juanma Barranquero  <lekktu@gmail.com>

	* fns.c (Fmemq, Fmaphash): Doc fixes.

2005-06-09  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Fdisplay_supports_face_attributes_p):
	Fix typo in docstring.

2005-06-08  Steven Tamm  <steventamm@mac.com>

	* unexmacosx.c (copy_data_segment): Copy __la_sym_ptr2 section
	used by gcc4 on intel mac.

2005-06-09  Kim F. Storm  <storm@cua.dk>

	* search.c (Fmatch_data): Add optional RESEAT arg.  Unchain markers
	in REUSE list if non-nil; free them if equal to evaporate.
	(Fset_match_data): Add optional RESEAT arg.  Unchain markers in	LIST
	if non-nil; free them if equal to evaporate.  Use XCAR/XCDR.
	(restore_search_regs): Rename from restore_match_data.  Uses changed.
	(unwind_set_match_data): New function.
	(record_unwind_save_match_data): New function like save-match-data.

	* lisp.h (Fmatch_data, Fset_match_data): Fix EXFUN.
	(record_unwind_save_match_data): Add prototype.
	(restore_search_regs): Rename from restore_match_data.

	* composite.c (compose_chars_in_text):
	* eval.c (do_autoload):
	* macmenu.c (set_frame_menubar):
	* process.c (read_process_output, exec_sentinel):
	* xmenu.c (set_frame_menubar):
	* xdisp.c (prepare_menu_bars, update_menu_bar, update_tool_bar):
	* w32menu.c (set_frame_menubar):
	Use record_unwind_save_match_data.

2005-06-08  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (get_next_display_element): Alter previous change:
	Distinguish Vshow_nonbreak_escape = t or not t.
	For t, use escape_glyph once again, as before previous change.
	Use space or hyphen for display, instead of the non-ASCII char.
	(syms_of_xdisp) <show-nonbreak-escape>: Doc fix.

	* process.c (Fstart_process): Don't touch command_channel_p slot.

	* process.h (struct process): Delete command_channel_p.

2005-06-07  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight):
	Check the overlapping of re-rendering area to avoid flickering.
	(note_mouse_highlight): Call clear_mouse_face if PART
	is not ON_MODE_LINE nor ON_HEADER_LINE.

2005-06-07  Kim F. Storm  <storm@cua.dk>

	* process.c: Improve commentary for adaptive read buffering.

2005-06-06  Stefan Monnier  <monnier@iro.umontreal.ca>

	* xterm.c (x_create_toolkit_scroll_bar): Use XtNarrowScrollbars
	if available.

2005-06-06  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* macmenu.c (menu_quit_handler, install_menu_quit_handler):
	New functions for popping down menus on C-g.
	(set_frame_menubar, mac_menu_show): Call install_menu_quit_handler.

	* macterm.c: Make mac_quit_char_modifiers and mac_quit_char_keycode
	non-static.

	* config.in: Add HAVE_CANCELMENUTRACKING.

2005-06-06  Eli Zaretskii  <eliz@gnu.org>

	* w32heap.h (OFFSET_TO_RVA, RVA_TO_OFFSET, RVA_TO_PTR): Remove macros.

	* unexw32.c (RVA_TO_PTR): Move here from w32heap.h.

	* w32proc.c (RVA_TO_PTR): New macro.

	* w32heap.c (RVA_TO_PTR): No need to #undef now.

	* makefile.w32-in ($(BLD)/emacs.$(O), $(BLD)/w32select.$(O)):
	Depend on w32heap.h.

2005-06-06  Luc Teirlinck  <teirllm@auburn.edu>

	* keyboard.c (command_loop_1): Update Vthis_original_command.

2005-06-06  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (popup_get_selection): Undo previous change.

2005-06-06  Juri Linkov  <juri@jurta.org>

	* xdisp.c (Qno_break_space): New variable.
	(syms_of_xdisp): Initialize it.
	(get_next_display_element): Add no-break space and soft hypen
	codes for iso8859-2 and iso8859-5.  Don't add `\' for them.
	Use `no-break-space' face for no-break spaces.

2005-06-06  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* window.c (delete_window): Handle the case where a h/vchild has
	a h/vchild.

2005-06-05  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (sys_setsockopt): Change arg 4 to `const void *'.  In the
	call to pfn_setsockopt, cast optval to `const char *'.

2005-06-04  Eli Zaretskii  <eliz@gnu.org>

	* w32.c (gettimeofday): Use struct _timeb, not struct timeb.
	(open_unc_volume): Cast return value of map_w32_filename, to avoid
	compiler warnings.

	* s/ms-w32.h (fileno): Don't define if already defined.

	* emacs.c: Include w32heap.h, to avoid compiler warning about sbrk.

	* makefile.w32-in (DOC): Define to point to the generated DOC-X.

2005-06-04  Richard M. Stallman  <rms@gnu.org>

	* xmenu.c (popup_get_selection): Click not in menu deactivates menu.

2005-06-04  Jan Dj,Ad(Brv  <jan.h.d@swipnet.se>

	* macmenu.c (cleanup_popup_menu): New function.
	(Fx_popup_menu): Unwind protect cleanup_popup_menu in case
	mac_menu_show Quit:s.
	(mac_menu_show): Quit on cancel if not popped up on click (i.e.
	a dialog).

2005-06-04  Kim F. Storm  <storm@cua.dk>

	* coding.c (decode_coding_string): Handle CODING_FINISH_INTERRUPT.

	* callproc.c (Fcall_process): Don't use alloca to gradually
	increase size of buf, as it effectively uses twice the necessary
	space on the stack.  Instead, pre-allocate buf of full size, and
	gradually increase the read size.

	* bytecode.c (BYTE_CODE_QUIT): Check Vthrow_on_input.

	* eval.c (unbind_to): Preserve value of Vquit_flag.

	* xterm.c (handle_one_xevent): Also ignore mouse motion just
	before a button release event.

2005-06-03  Juanma Barranquero  <lekktu@gmail.com>

	* xfaces.c (Finternal_lisp_face_equal_p): Really report
	on faces in a frame, if the argument FRAME is non-nil.
	Improve argument/docstring consistency.

2005-06-02  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (MODE_LINE_NOPROP_LEN): New macro.
	(x_consider_frame_title, Fformat_mode_line): Save offset into
	mode_line_noprop_buf rather than pointer, in case buffer is relocated.

2005-06-01  Kim F. Storm  <storm@cua.dk>

	* fns.c (mapcar1): Maybe exit loop if original sequence was modified.

2005-06-01  YAMAMOTO Mitsuharu  <mituharu@math.s.chiba-u.ac.jp>

	* macterm.c (mac_to_x_fontname, mac_do_list_fonts): Set XLFD
	resolution fields for scalable fonts to 0.

	* xfaces.c (build_scalable_font_name): Round pixel size to the
	nearest integer.

2005-06-01  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (display_mode_line): Support nested calls to redisplay
	and format-mode-line.  Set mode_line_target to MODE_LINE_DISPLAY.

2005-05-31  Stefan Monnier  <monnier@iro.umontreal.ca>

	* fileio.c (Finsert_file_contents):
	* xdisp.c (note_mode_line_or_margin_highlight): Lisp_Object/int mixup.

2005-05-31  Kim F. Storm  <storm@cua.dk>

	* xdisp.c (mode_line_noprop_buf, mode_line_noprop_buf_end)
	(mode_line_noprop_ptr): Rename from frame_title_*.
	(store_mode_line_noprop_char): Rename from store_frame_title_char.
	(store_mode_line_noprop): Rename from store_frame_title.
	(mode_line_target): New enum to specify current output target
	for mode line formatting.
	(display_mode_element): Test it rather than frame_title_ptr and
	mode_line_string_list to determine where output should go.
	(mode_line_proptrans_alist, mode_line_string_alist): Make static.
	(Vmode_line_unwind_vector): New variable.
	(format_mode_line_unwind_data, unwind_format_mode_line):
	New functions for unwind protection in mode line formatting.
	(x_consider_frame_title): Use them and new local var 'title_start'
	to support nested calls to format-mode-line and redisplay.
	Set mode_line_target to MODE_LINE_TITLE.
	(Fformat_mode_line): Use them and new local var 'string_start' to
	support nested calls to format-mode-line and redisplay.
	Set mode_line_target to MODE_LINE_NOPROP or MODE_LINE_STRING.
	Don't trim trailing dashes.
	(decode_mode_spec): Don't make infinite number of trailing dashes
	for MODE_LINE_NOPROP and MODE_LINE_STRING targets.
	(syms_of_xdisp): Initialize and staticpro mode_line_string_face,
	mode_line_string_face_prop, and Vmode_line_unwind_vector.
	(init_xdisp): Initialize mode_line_noprop_ptr to start of _buf.
	Initialize mode_line_target to MODE_LINE_DISPLAY.

2005-05-29  Richard M. Stallman  <rms@gnu.org>

	* buffer.c (Fbuffer_local_value): Call indirect_variable.

2005-05-28  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Change the
	pointer to a hand cursor when hoovering over a mouse-face.

2005-05-27  Kenichi Handa  <handa@m17n.org>

	* xterm.c (x_encode_char): Call check_ccl_update in advance.

	* ccl.c: Now an element of Vccl_program_table is a vector of
	length 4, not 3.
	(ccl_get_compiled_code): New arg idx.  Caller changed.
	Adjust for the change of Vccl_program_table.
	(setup_ccl_program): Adjust for the change of Vccl_program_table.
	(check_ccl_update): New function.
	(Fregister_ccl_program): Use ASET to set an element of a vector.
	Adjusted for the change of Vccl_program_table.

	* ccl.h (struct ccl_program): New member idx.
	(check_ccl_update): Extern it.

2005-05-27  Juanma Barranquero  <lekktu@gmail.com>

	* image.c (Vimage_library_alist): Move from image.el.
	(syms_of_image): Defvar it.
	(lookup_image_type): Use it.

	* buffer.c (Fbuffer_local_value): Make argument name match its use
	in docstring.

2005-05-26  Juanma Barranquero  <lekktu@gmail.com>

	* keyboard.c (Frecursive_edit): Fix typo in docstring.
	(Fposn_at_x_y): Make argument name match its use in docstring.

2005-05-26  Lute Kamstra  <lute@gnu.org>

	* eval.c (Frun_hooks): Mention run-mode-hooks in docstring.

2005-05-24  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Use b and e
	as loop sentinels.

2005-05-24  Nick Roberts  <nickrob@snap.net.nz>

	* xmenu.c (Fx_popup_dialog): Add a third boolean argument to
	select frame title ("Question"/"Information").
	(xdialog_show): Use it.

	* macmenu.c (Fx_popup_dialog, mac_dialog_show): As for xmenu.c.

	* w32menu.c (Fx_popup_dialog, w32_dialog_show): As for xmenu.c.

	* fns.c (Fyes_or_no_p, Fy_or_n_p): Call Fx_popup_dialog with
	a third argument (Qnil).

	* lisp.h: x-popup-dialog can have three arguments.

	* editfns.c (Fmessage_box): Use "Information" for frame title.

2005-05-23  Thien-Thi Nguyen  <ttn@gnu.org>

	* termcap.c [VMS]: Include <starlet.h>.

2005-05-23  Masatake YAMATO  <jet@gyve.org>

	* xdisp.c (note_mode_line_or_margin_highlight): Add code
	for mouse-face.  Change the type of the first argument from `window'
	to `Lisp_Object'.
	(note_mouse_highlight): Call note_mode_line_or_margin_highlight with
	window instead of w.

2005-05-22  Andreas Schwab  <schwab@suse.de>

	* process.c (send_process): Move misplaced volatile.

2005-05-21  Richard M. Stallman  <rms@gnu.org>

	* xdisp.c (display_mode_element): If we're processing a list and
	padding is specified, put it after the last element.

2005-05-21  Eli Zaretskii  <eliz@gnu.org>

